2013-06-01  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.20 TAGGED FOR RELEASE ***

	* README:		Bump version number to 8.4.20
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

	* changes:		updates for 8.4.20 release.

2013-05-19  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4:     Fix for FreeBSD, and remove support for older
	* unix/configure:  FreeBSD versions. Patch by Pietro Cerutti.

2013-05-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclBasic.c: Add panic in order to detect
	incompatible mingw32 sys/stat.h and sys/time.h headers,

2013-05-06  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclStubInit.c: Add support for Cygwin64, which has a 64-bit
	* generic/tclDecls.h: "long" type. Binary compatibility with win64
	requires that all stub entries use 32-bit long's, therefore the
	need for various wrapper functions/macros. For Tcl 9 a better
	solution is needed, but that cannot be done without introducing
	binary incompatibility.

2013-04-30  Andreas Kupries  <andreask@activestate.com>

	* library/platform/platform.tcl (::platform::LibcVersion):
	* library/platform/pkgIndex.tcl: Followup to the 2013-01-30
	  change. The RE become too restrictive again. SuSe added a
	  timestamp after the version. Loosened up a bit. Bumped package
	  to version 1.0.12.

2013-04-25  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinDde.c:		Update dde to version 1.3.3.
	* library/dde/pkgIndex.tcl:
	* win/tclWinReg.c:		Update registry to version 1.2.2.
	* library/reg/pkgIndex.tcl:

2013-04-18  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclDecls.h: Implement Tcl_Pkg* functions as
	(faster/stack-saving) macros around Tcl_Pkg*Ex functions.
	The same for many Tcl_*Var* functions around their
	Tcl_*Var*2 equivalent and Tcl_GetIndexFromObj around
	Tcl_GetIndexFromObjStruct.

2013-04-09  Reinhard Max  <max@suse.de>

	* library/http/http.tcl (http::geturl): Allow URLs that don't have
	a path, but a query query, e.g. http://example.com?foo=bar .
	* Bump the http package to 2.5.8.

2013-04-08  Don Porter  <dgp@users.sourceforge.net>

	* generic/regc_color.c:	[Bug 3610026] Stop crash when the number of
	* generic/regerrs.h:	"colors" in a regular expression overflows
	* generic/regex.h:	a short int.  Thanks to Heikki Linnakangas
	* generic/regguts.h:	for the report and the patch.
	* tests/regexp.test:

2013-03-19  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclFCmd.c: [Bug 3597000] Consistent [file copy] result.

2013-03-19  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinFile.c: [Bug 2893771]: file stat fails on locked files
	on win32.

2013-03-18  Donal K. Fellows  <dkf@users.sf.net>

	* tests/cmdAH.test (cmdAH-19.12): [Bug 3608360]: Added test to ensure
	that we never ever allow [file exists] to do globbing.

2013-03-12  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4: Patch by Andrew Shadura, providing better support for
	three architectures they have in Debian.

2013-03-06  Don Porter  <dgp@users.sourceforge.net>

	* generic/regc_nfa.c:	[Bugs 3604074,3606683] Rewrite of the
	* generic/regcomp.c:	fixempties() routine (and supporting
	routines) to completely eliminate the infinite loop hazard.
	Thanks to Tom Lane for the much improved solution.

2013-03-04  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclUtil.c:	New scheme for keeping the per-process
	tcl_precision value in sync without the need for mutex locks on
	every read.  Uses adapted ProcessGlobalValue machinery backported
	from Tcl 8.5 where it's been working without reported problems.
	Thanks to Phil Brooks for reporting on tests which highlight the
	thread performance problems raised by the old scheme, and to Clif
	Flynt for further testing pointing the finger at tcl_precision
	locks as the main culprit.

2013-02-27  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/regcomp.c:	[Bug 3606139]: missing error check allows
	* tests/regexp.test:    regexp to crash Tcl. Thanks to Tom Lane
	for providing the test-case and the patch.

2013-02-22  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCompile.c:	Shift more burden of smart cleanup onto the
	* generic/tclExecute.c:	TclFreeCompileEnv() routine.  Stop crashes
	when the hookProc raises an error.

2013-02-20  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclNamesp.c:	[Bug 3605447] Make sure the -clear option
	* tests/namespace.test:	to [namespace export] always clears, whether
	or not new export patterns are specified.

2013-02-15  Don Porter  <dgp@users.sourceforge.net>

	* generic/regc_nfa.c:	[Bug 3604074] Fix regexp optimization to
	* tests/regexp.test:	stop hanging on the expression
	((((((((a)*)*)*)*)*)*)*)* .  Thanks to Bjørn Grathwohl for discovery.

2013-02-05  Don Porter  <dgp@users.sourceforge.net>

	* win/tclWinFile.c:	[Bug 3603434] Make sure TclpObjNormalizePath() 
	properly declares "a:/" to be normalized, even when no "A:" drive is
	present on the system.

2013-01-30  Andreas Kupries  <andreask@activestate.com>

	* library/platform/platform.tcl (::platform::LibcVersion): See
	* library/platform/pkgIndex.tcl: [Bug 3599098]: Fixed the RE
	  extracting the version to avoid issues with recent changes to
	  the glibc banner. Now targeting a less variable part of the
	  string. Bumped package to version 1.0.11.

2013-01-26  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tclUnixCompat.c: [Bug 3601804]: platformCPUID segmentation
	fault on Darwin.

2013-01-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* Makefile.in: Enable win32 build with -DTCL_NO_DEPRECATED, just
	* generic/tcl.h: as the UNIX build. Define Tcl_EvalObj and
	* generic/tclDecls.h: Tcl_GlobalEvalObj as macros, even when
	* generic/tclBasic.c: TCL_NO_DEPRECATED is defined, so Tk
	can benefit from it too.

2013-01-08  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinFile.c: [Bug 3092089]: [file normalize] can remove path
	components.	[Bug 3587096] win vista/7: "can't find init.tcl" when
	called via junction.

2013-01-07  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.decls: Extend the public and private stub tables with
	* generic/tclInt.decls: dummy NULL entries, up to the size of the
	Tcl 8.6 stub tables. This makes it easier to debug extensions which
	use Tcl 8.5/8.6 features but (erroneously) are attempted to be loaded
	in Tcl 8.4.

2012-12-31  Donal K. Fellows  <dkf@users.sf.net>

	* doc/string.n: Noted the obsolescence of the 'bytelength',
	'wordstart' and 'wordend' subcommands, and moved them to later in the
	file.

2012-12-27  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclListObj.c: [Bug 3598580]: Tcl_ListObjReplace may release
	deleted elements too early

2012-12-21  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/dltest/pkgb.c:  Turn pkgb.so into a Tcl9 interoperability test
    library: Whatever Tcl9 looks like, loading pkgb.so in Tcl 9 should
    either result in an error-message, either succeed, but never crash.
	* generic/tclStubLib.c: Eliminate unnessarcy static HasStubSupport() and
	isDigit() functions, just do the same inline.

2012-12-13  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.h: Fix Tcl_DecrRefCount macro such that it
	doesn't access its objPtr parameter twice any more.

2012-11-14  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tclUnixPipe.c (DefaultTempDir): [Bug 2933003]: Allow overriding
	of the back-stop default temporary file location at compile time by
	setting the TCL_TEMPORARY_FILE_DIRECTORY #def to a string containing
	the directory name (defaults to "/tmp" as that is the most common
	default).

2012-11-07  Don Porter  <dgp@users.sourceforge.net>

	* win/tclWinSock.c:	[Bug 3574493] Avoid hanging on exit due to
	use of synchronization calls in routines called by DllMain().

2012-10-03  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclIO.c:	When checking for std channels being closed,
	compare the channel state, not the channel itself so that stacked
	channels do not cause trouble.

2012-08-17  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/nmakehlp.c: Add "-V<num>" option, in order to be able
	to detect partial version numbers.

2012-07-31  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/nmakehlp.c: Backport from Tcl 8.6, but add -Q option from
	sampleextension.

2012-07-27  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclUniData.c:   Support Unicode 6.2 (Add Turkish lira sign)
	* generic/regc_locale.c:

2012-07-17  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/makefile.vc: [Bug 3544932]: Visual studio compiler check fails

2012-07-05  Don Porter  <dgp@users.sourceforge.net>

	* unix/tclUnixPipe.c:	[Bug 1189293] Make "<<" binary safe.
	* win/tclWinPipe.c:

2012-06-29  Jan Nijtmans  <nijtmans@users.sf.net>

	* library/msgcat/msgcat.tcl:   Add tn, ro_MO and ru_MO to msgcat. Make it
	* library/msgcat/pkgIndex.tcl: work on cygwin. Bump to 1.3.5

2012-06-29  Donal K. Fellows  <dkf@users.sf.net>

	* doc/GetIndex.3: Reinforced the description of the requirement for
	the tables of names to index over to be static, following posting to
	tcl-core by Brian Griffin about a bug caused by Tktreectrl not obeying
	this rule correctly. This does not represent a functionality change,
	merely a clearer documentation of a long-standing constraint.

2012-06-23  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tclUnixNotfy.c: [Bug 3508771]: Cygwin notifier for handling
	win32 events.

2012-06-19  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinReg.c:  Plug memory leak, part of [Bug #3362446]

2012-06-08  Don Porter  <dgp@users.sourceforge.net>

	* unix/configure.in:	Update autogoo for gettimeofday().
	* unix/tclUnixPort.h:	Thanks Joe English.
	* unix/configure:	autoconf 2.13

2012-06-06  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tclUnixInit.c: On Cygwin, use win32 API in stead of uname()
	to determine the tcl_platform variables.

2012-05-25  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinDde.c:    [Bug 473946]: special characters not correctly sent,
	now for XTYP_EXECUTE as well as XTYP_REQUEST.
	* win/Makefile.in:    Fix "make genstubs" when cross-compiling on UNIX

2012-05-24  Jan Nijtmans  <nijtmans@users.sf.net>

	* tools/genStubs.tcl:  Take cygwin handling of X11 into account.
	* generic/tcl*Decls.h: re-generated
	* generic/tclStubInit.c:  Implement TclpIsAtty, Cygwin only.
	* doc/dde.n: Doc fix: "dde execute iexplore" doesn't work
	without -async, because iexplore doesn't return a value

2012-05-22  Jan Nijtmans  <nijtmans@users.sf.net>

	* tools/genStubs.tcl:   Let cygwin share stub table with win32
	* win/Makefile.in:      Don't hardcode dde and reg dll version numbers
	* win/tclWinSock.c:     implement TclpInetNtoa for win32
	* generic/tclInt.decls: Revert most of [ae92de6078], since when
	  we let cygwin share the win32 stub table this is no longer necessary
	* generic/tcl*Decls.h:  re-generated

2012-05-21  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclFileName.c: When using Tcl_SetObjLength() calls to grow
	* generic/tclIOUtil.c:	 and shrink the objPtr->bytes buffer, care must
	be taken that the value cannot possibly become pure Unicode.  Calling
	Tcl_AppendToObj() has the possibility of making such a conversion.  Bug
	found while valgrinding the trunk.

2012-05-17  Donal K. Fellows  <dkf@users.sf.net>

	* doc/expr.n: [Bug 3525462]: Corrected statement about what happens
	when comparing "0y" and "0x12"; the previously documented behavior was
	actually a subtle bug (now long-corrected).

2012-05-13  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinDde.c:   Protect against receiving strings without ending \0,
	as external applications (or Tcl with TIP #106) could generate that.

2012-05-10  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinDde.c:    [Bug 473946]: special characters not correctly sent
	* library/dde/pkgIndex.tcl  Increase version to 1.2.5

2012-05-02  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/configure.in:    Better detection and implementation for cpuid
	* generic/configure:       instruction on Intel-derived processors, both
	* generic/tclUnixCompat.c: 32-bit and 64-bit.
	* generic/tclTest.c:       Move cpuid testcase from win-specific to generic
	* win/tclWinTest.c:        tests, as it should work on all Intel-related
	* tests/platform.test:     platforms now
	* generic/tcl.decls:       Simplify stub tables for functions which work on
	* generic/tclInt.decls:    both UNIX and windows, as in Tcl 8.5 and 8.6
	* generic/tcl*Decls.h:

2012-04-27  Donal K. Fellows  <dkf@users.sf.net>

	* library/init.tcl (auto_execok): Allow shell builtins to be detected
	even if they are upper-cased.

2012-04-24  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclInt.decls:      [Bug 3508771] load tclreg.dll in cygwin tclsh
	* generic/tclIntPlatDecls.h: Implement TclWinGetSockOpt, TclWinGetServByName
	* generic/tclStubInit.c:     and TclWinCPUID for Cygwin
	* generic/tclUnixCompat.c:
	* unix/configure.in:
	* unix/configure:
	* unix/tclUnixCompat.c:

2012-04-16  Donal K. Fellows  <dkf@users.sf.net>

	* doc/FileSystem.3 (Tcl_FSOpenFileChannelProc): [Bug 3518244]: Fixed
	documentation of this filesystem callback function; it must not
	register its created channel - that's the responsibility of the caller
	of Tcl_FSOpenFileChannel - as that leads to reference leaks.

2012-04-11  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinInit.c:     [Bug 3448512]: clock scan "1958-01-01" fails only
	* win/tcl.m4:           in debug compilation.
	* win/configure:
	* unix/tcl.m4:          Use NDEBUG consistantly meaning: no debugging.
	* unix/configure:

2012-04-04  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinSock.c:     [Bug 510001]: TclSockMinimumBuffers needs plat imp
	* generic/tclIOSock.c:
	* generic/tclInt.decls:
	* generic/tclIntDecls.h:
	* generic/ttclStubInit.c:

2012-04-03  Jan Nijtmans  <nijtmans@users.sf.net>

	* tools/genStubs.tcl:        Let genStubs.tcl do the void -> VOID and
	const -> CONST translations, so we cannot forget it in the *.decls file
	* generic/tcl.decls:         VOID -> void and CONST -> const, so depend
	* generic/tclInt.decls:      on genStubs.tcl to generate the correct form
	form in the *Decls.h file. This brings tclInt.decls in the same form as
	Tcl 8.5/8.6, so a diff can show us the real signature differences.
	(Backported from Tcl 8.5, no change in any function signature)
	* generic/tclStubInit.c      Remove the TclpGetTZName implementation for
	* generic/tclIntDecls.h:     Cygwin (from previous commit) , re-generated
	* generic/tclIntPlatDecls.h:
	* generic/tclDecls.h

2012-03-30  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclInt.decls:      [Bug 3508771] load tclreg.dll in cygwin tclsh
	* generic/tclIntPlatDecls.h: Implement TclWinGetTclInstance, TclpGetTZName,
	* generic/tclStubInit.c:     and various more win32-specific internal functions for
	Cygwin, so win32 extensions using those can be loaded in the cygwin version of tclsh.

2012-03-29  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4:               [Bug 3511806] Compiler checks too early
	* unix/configure.in:         This change allows to build the cygwin
	* unix/configure:            and mingw32 ports of Tcl/Tk to build
	* win/tcl.m4:                out-of-the-box using a native or cross-
	* win/configure.in:          compiler.
	* win/configure:

2012-03-27  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.h:             [Bug 3508771] Wrong Tcl_StatBuf used on MinGW
	* generic/tclFCmd.c:         [Bug 2015723] duplicate inodes from file stat on windows

2012-03-24  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclInt.decls:      [Bug 3508771] load tclreg.dll in cygwin tclsh
	* generic/tclIntPlatDecls.h: Implement TclWinConvertError, TclWinConvertWSAError,
	* generic/tclStubInit.c:     and various more win32-specific internal functions for
	* unix/Makefile.in:          Cygwin, so win32 extensions using those can be
	* unix/tcl.m4:               loaded in the cygwin version of tclsh.
	* unix/configure:
	* win/tclWinError.c:

2012-03-20  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.h:             [Bug 3288345] Wrong Tcl_StatBuf used on Cygwin
	* unix/tclUnixFile.c
	* unix/tclUnixPort.h
	* win/tclWinFile.c           Remove cygwin stuff no longer needed
	* win/tclWinPort.h

	* generic/tcl.decls:         [Bug 3508771] load tclreg.dll in cygwin tclsh
	* generic/tclInt.decls:      Implement TclWinGetPlatformId, Tcl_WinUtfToTChar,
	* generic/tclIntPlatDecls.h: Tcl_WinTCharToUtf (and a dummy TclWinCPUID) for
	* generic/tclPlatDecls.h:    Cygwin, so win32 extensions using those can be
	* generic/tclStubInit.c:     loaded in the cygwin version of tclsh.
	* unix/tclUnixCompat.c:

2012-03-12  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinFile.c: [Bug 3388350] mingw64 compiler warnings

2012-03-07  Andreas Kupries  <andreask@activestate.com>

	* library/http/http.tcl: [Bug 3498327]: Generate upper-case
	* library/http/pkgIndex.tcl: hexadecimal output for compliance
	* tests/http.test: with RFC 3986. Bumped version to 2.5.7.

2012-03-06  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinPort.h: Compatibility with older Visual Studio versions.

2012-03-04  Alexandre Ferrieux  <ferrieux@users.sourceforge.net>
	* unix/tclUnixChan.c: TclUnixWaitForFile(): use FD_* macros
	* macosx/tclMacOSXNotify.c: to manipulate select masks (Cassoff).
	[Bug  3486554].  Backport  of  das' checkin  [e496f9ef50].  Allows
	Tcl8.4 to have sane fileevents on x86_64 at last.

2012-03-04  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclLoad.c: Patch from the cygwin folks
	* unix/tcl.m4:
	* unix/configure: (re-generated)

2012-02-29  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclIOUtil.c:	[Bug 3466099] BOM in Unicode
	* generic/tclEncoding.c:
	* tests/source.test

2012-02-09  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclStringObj.c:	[Bug 3484402] Correct Off-By-One
	error appending unicode. Thanks to Poor Yorick. Also corrected test
	for when growth is needed.

2012-02-06  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c:	[Bug 3484621] Invalidate bytecode when exec
	* tests/trace.test:	traces are added/removed from compiled cmd.

2012-02-02  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclUniData.c: [Frq 3464401] Support Unicode 6.1
	* generic/regc_locale.c:

2012-02-02  Don Porter  <dgp@users.sourceforge.net>

	* win/tclWinFile.c:	[Bugs 2974459,2879351,1951574,1852572,
	1661378,1613456]: Revisions to the NativeAccess() routine that
	queries file permissions on Windows native filesystems.  Meant to
	fix numerous bugs where [file writable|readable|executable] "lies"
	about what operations are possible, especially when the file resides
	on a Samba share.  Patch cherrypicked off the fix-win-native-access
	branch.

2012-01-22  Jan Nijtmans  <nijtmans@users.sf.net>

	* tools/uniClass.tcl:    [Frq 3473670]: Various Unicode-related
	* tools/uniParse.tcl:    speedups/robustness. Enhanced tools to
	* generic/tclUniData.c:  be able to handle characters > 0xffff
	* generic/tclUtf.c:      Done in all branches in order to simplify
	* generic/regc_locale.c: merges for new Unicode versions (such as 6.1)

2012-01-19  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.h:        [Bug-3474726]: Eliminate detection of struct
	* generic/tclWinPort.h: _stat32i64, just use _stati64 in combination
	* generic/tclFCmd.c:    with _USE_32BIT_TIME_T, which is the same then.
	* generic/tclTest.c:    Only keep _stat32i64 usage for cygwin, so it
	* win/configure.in:     will not conflict with cygwin's own struct stat.
	* win/configure:

2012-01-19  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c:	[Bug 3475667] Prevent buffer read overflow.
	Thanks to "sebres" for the report and fix.

2012-01-17  Don Porter  <dgp@users.sourceforge.net>

	* library/http/http.tcl:	Bump to 2.5.6.
	* library/http/pkgIndex.tcl:

2012-01-13  Donal K. Fellows  <dkf@users.sf.net>

	* library/http/http.tcl (http::Connect): [Bug 3472316]: Ensure that we
	only try to read the socket error exactly once.

2012-01-09  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclUtf.c:      [Bug 3464428] string is graph \u0120 is wrong
	* generic/regcomp.c:     Remove some unused code
	* generic/regc_locale.c: Add table for Unicode [:cntrl:] class
	* tools/uniClass.tcl:    Generate Unicode [:cntrl:] class table
	* tests/utf.test:
	* doc/re_syntax:         Fix [:print:] class description

2011-12-23  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclUtf.c:     [Bug 3464428] string is graph \u0120 is wrong
	* generic/tclUniData.c:
	* generic/regc_locale.c:
	* tests/utf.test:
	* tools/uniParse.tcl:   clean up some unused stuff, and be more robust
	against changes in UnicodeData.txt syntax

2011-12-07  Jan Nijtmans  <nijtmans@users.sf.net>

	* tools/uniParse.tcl:    [Bug 3444754] string tolower \u01c5 is wrong
	* generic/tclUniData.c:
	* tests/utf.test:

2011-11-30  Jan Nijtmans  <nijtmans@users.sf.net>

	* library/tcltest/tcltest.tcl: [Bug 967195]: Make tcltest work
	when tclsh is compiled without using the setargv() function on mingw.
	(no need to incr the version, since 2.2.10 is never released)

2011-11-29  Jan Nijtmans  <nijtmans@users.sf.net>

	* doc/tclsh.1:  Use the same shebang comment everywhere.
	* tools/str2c
	* tools/tcltk-man2html.tcl

2011-11-22  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclCmdAH.c:   [Bug 3354324] Windows: file mtime
	* generic/tclIOUtil.c:  sets wrong time

2011-10-11  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinFile.c:    [Bug 2935503] Incorrect mode field
	returned by file stat command

2011-10-07  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinChan.c:    Fix various gcc warnings
	* win/tclWinConsole.c: (discovered with latest
	* win/tclWinNotify.c:  mingw, based on gcc 4.6.1)
	* win/tclWinReg.c:
	* tests/env.test:      Fix env.test, when running
	under wine 1.3 (partly backported from Tcl 8.6)

2011-09-26  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/rules.vc:  Support Visual Studio 11

2011-09-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.h:        Don't change Tcl_UniChar type when
	* generic/regcustom.h:  TCL_UTF_MAX == 4 (not supported anyway)

2011-09-13  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclUtil.c:	[Bug 3390638] Workaround broken solaris
	studio cc optimizer.  Thanks to Wolfgang S. Kechel.

	* generic/tclDTrace.d:	[Bug 3405652] Portability workaround for
	broken system DTrace support.  Thanks to Dagobert Michelson.

2011-09-12  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinPort.h: [Bug 3407070] tclPosixStr.c won't build with
	EOVERFLOW==E2BIG

2011-09-06  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.decls: Tcl_HashStats does not return a CONST
	* generic/tclDecls.h: (Backported from Tcl 8.5)
	* generic/tclHash.c:
	* generic/tclVar.c:
	* unix/tcl.m4:    Add --disable-rpath option to configure
	* unix/configure: script (backported from Tcl 8.5)

2011-08-30  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4:    Make SHLIB_LD_LIBS='${LIBS}' the default and
	* unix/configure: set to "" on per-platform necessary basis.
	Add Haiku support and better NetBSD/FreeBSD support.
	All of this backported from TEA resp. Tcl8.5, but kept all
	original platform code which was removed from TEA.

2011-08-22  Andreas Kupries  <andreask@activestate.com>

	* win/tclWinDde.c (Tcl_DdeObjCmd): Fixed use of the C99 feature
	(Variable declaration within statement block) rejected by
	MSVC6. Moved the declaration to the beginning of the block.

2011-08-18  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclUniData.c: [Bug 3393714] overflow in toupper delta
	* tools/uniParse.tcl
	* tests/utf.test

2011-08-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclCmdAH.c:    [Bug 3388350] mingw64 compiler warnings
	* generic/tclFCmd.c      In mingw, sys/stat.h must be included
	* generic/tclFileName.c  before winsock2.h, so make sure of that.
	* generic/tclIOUtil.c
	* generic/tclTest.c
	* win/tclWin32Dll.c
	* win/tclWinChan.c
	* win/tclWinDde.c
	* win/tclWinFCmd.c

2011-08-15  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclBasic.c: [Bug 3390272] Leak of [info script] value.

2011-08-15  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tcl.m4:       [Bug 3388350] mingw64 compiler warnings
	* win/configure.in
	* win/configure
	* win/tclMtherr.c
	* win/tclWinPort.h
	* win/tclWinChan.c
	* win/tclWinDde.c
	* win/tclWinFCmd.c
	* win/tclWinPipe.c
	* win/tclWinReg.c
	* win/tclWinSerial.c
	* win/tclWinSock.c
	* win/tclWinTest.c
	* win/tclWinTime.c
	* generic/tclPosixStr.c
	* unix/tcl.m4:      Quoting and AC_DEFINE fixes (All backported from
	* unix/configure    Tcl 8.5

2011-07-21  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinPort.h: [Bug 3372130] Fix hypot math function with MSVC10

2011-07-15  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCompile.c: Avoid segfaults when RecordByteCodeStats()
	is called in a deleted interp.

2011-07-13  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclProc.c:	[Bug 3366265] Buffer for storing the command
	* tests/indexObj.test:	name formatted as a list element is allocated
	* tests/proc.test:	one byte too small, causing buffer overflow
	when the proc with the empty name raises a "wrong num args" error.

2011-07-03  Donal K. Fellows  <dkf@users.sf.net>

	* doc/FileSystem.3: Corrected statements about ctime field of 'struct
	stat'; that was always the time of the last metadata change, not the
	time of creation.

2011-06-22  Andreas Kupries  <andreask@activestate.com>

	* library/platform/pkgIndex.tcl: Updated to platform 1.0.10. Added
	* library/platform/platform.tcl: handling of the DEB_HOST_MULTIARCH
	location change for libc.

2011-05-07  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclInt.h: fix USE_TCLALLOC so that it can be enabled
	* unix/Makefile.in: without editing the Makefile

2011-04-21  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCompile.c:		Make sure SetFooFromAny routines react
	* generic/tclIndexObj.c:	reasonably when passed a NULL interp.
	* generic/tclNamesp.c:
	* generic/tclObj.c:

2011-04-21  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.h:       fix for [Bug 3288345]: Wrong Tcl_StatBuf
	* generic/tclInt.h:    used on MinGW. Make sure that all _WIN32
	* generic/tclIOUtil.c: compilers use exactly the same layout
	* win/tclWinFile.c:    for Tcl_StatBuf - the one used by MSVC6 -
	* win/configure.in:    in all situations.
	* win/configure:

2011-04-20  Andreas Kupries  <andreask@activestate.com>

	* tests/info.test: Fixed the shift in line numbers used for
	testing 'info frame' introduced by checkin [79367df0f0]
	(Mar 2, 2011).

2011-04-13  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclVar.c: fix for [Bug 2662380], crash caused by
	appending to a variable with a write trace that unsets it.

2011-04-04  Don Porter  <dgp@users.sourceforge.net>

	* README:	Updated README files, repairing broken URLs and
	* macosx/README:	removing other bits that were clearly wrong.
	* unix/README:	Still could use more eyeballs on the detailed build
	* win/README:	advice on various plaforms. [Bug 3202030]

2011-03-25  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclHash.c: [Bug 3007895]: Tcl_(Find|Create)HashEntry
	stub entries can never be called. They still cannot be called
	(no change in functionality), but at least they now do
	exactly the same as the Tcl_(Find|Create)HashEntry macro's,
	so the confusion addressed in this Bug report is gone.
	Merged --cherrypick from Tcl8.5 (2010-12-31,e75735ef76)

2011-03-24  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tclFCmd.c (TclFileAttrsCmd): Ensure that any reference to
	temporary index tables is squelched immediately rather than hanging
	around to trip us up in the future.

2011-03-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/configure, unix/tcl.m4: SHLIB_LD_LIBS='${LIBS}' for OSF1-V*.
	Add /usr/lib64 to set of auto-search dirs. [Bug 1230554]
	(SC_PATH_X): Correct syntax error when xincludes not found.
	Backported from Tcl 8.5
	* generic/tclCkalloc.c: [Bug #3197864] pointer truncation on Win64
	TCL_MEM_DEBUG builds

2010-03-11  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWin32Dll.c:	#ifdef protections to permit builds with
	* win/tclWinChan.c:	mingw on amd64 systems. Thanks to "mescalinum"
	* win/tclWinFCmd.c:	for reporting and testing.
	Merged --cherrypick from Tcl8.5 (2010-09-08,48191d3979)

2011-03-11  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tcl.m4:         handle --enable-64bit=ia64 for gcc.
	* win/configure:      (autoconf-2.13)
	* win/tclWin32Dll.c:  [Patch 3059922]: fixes for mingw64 - gcc4.5.1
	Merged --cherrypick from Tcl8.5 (2011-01-17, 6e410a115b)

2011-03-08  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclBasic.c: Fix gcc warnings: variable set but not used

2011-03-06  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclBasic.c:	More replacements of Tcl_UtfBackslash() calls
	* generic/tclCmdMZ.c:	with TclParseBackslash() where possible.
	* generic/tclCompExpr.c:
	* generic/tclCompile.c:
	* generic/tclUtil.c (TclFindElement):	Guard escape sequence scans
	to not overrun the string end.  [Bug 3192636]

2011-03-05  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclParse.c (TclParseBackslash): Correct trunction checks in
	* tests/parse.test:	\x and \u substitutions.  [Bug 3200987]

2011-01-25  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclCkalloc.c:  [Bug 3129448]: Possible over-allocation on 64-bit
	* generic/tclHash.c:     platforms, part 2, backported strcpy->memcpy
	* generic/tclProc.c      change but not change in any struct.

2011-01-14  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tclWinDde.c:  Fix gcc-4.5.2 error: lvalue required as ...
	* win/tclWinReg.c:  (backported from 8.5/8.6)

2010-12-05  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclCmdMZ.c: [Bug 3127687] Triggers FORTIFY_SOURCE
	buffer overflow detection

2010-11-03  Jeff Hobbs  <jeffh@ActiveState.com>

	Backported from 8.6 (see 2010-08-04).
	* win/tclWin32Dll.c (asciiProcs, unicodeProcs):
	* win/tclWinLoad.c (TclpDlopen): 'load' use LoadLibraryEx with
	* win/tclWinInt.h (TclWinProcs): LOAD_WITH_ALTERED_SEARCH_PATH to
	prefer dependent DLLs in same dir as loaded DLL.

2010-10-31  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tcl.m4     Add -D_CRT_SECURE_NO_DEPRECATE and
	-D_CRT_NONSTDC_NO_DEPRECATE, reducing the number of
	deprecation warnings on later VC++ versions.
	* win/rules.vc   Better VCVERSION determination
	* win/configure  (regenerated with autoconf 2.13)
	All changes backported from Tcl8.5/8.6

2010-10-23  Jan Nijtmans  <nijtmans@users.sf.net>

	* tools/uniParse.tcl:   [Bug 3085863]: tclUniData 9 years old
	* tools/uniClass.tcl:   Upgrade everything to Unicode 6.0, except
	* tests/utf.test:       non-BMP characters > 0xFFFF
	* generic/tclUniData.c: (re-generated)
	* generic/regc_locale.c:(re-generated)
	* generic/regcomp.c:    fix comment/signatures referencing regc_locale
	* win/rules.vc          Update for VS10

2010-09-24  Andreas Kupries  <andreask@activestate.com>

	* tclWinsock.c: [Bug 3056775]: Fixed race condition between thread
	and internal co-thread access of a socket's structure because of
	the thread not using the socketListLock in TcpAccept(). Added
	documentation on how the module works to the top.

2010-09-01  Andreas Kupries  <andreask@activestate.com>

	* generic/tclExecute.c: [Bug 3057639]. Applied patch by Jeff to
	* generic/tclVar.c: make the behaviour of lappend in bytecompiled
	* tests/append.test: mode consistent with direct-eval and 'append'
	* tests/appendComp.test: generally. Added tests (append*-9.*)
	showing the difference.

2010-07-25  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclInt.h: [Bug 3030870] make itcl 3.x built with pre-8.6
	* generic/tclBasic.c: work in 8.6 revert tclInt.h to what it was
	before, and relax the relation between Tcl_CallFrame and
	CallFrame.

2010-07-18  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.h: [Bug 3031278] fixed merge problem in previous
	commit.

2010-07-17  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.h: [Bug 3030870] make itcl 3.x built with pre-8.6
	* generic/tclInt.h: work in 8.6

2010-07-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tcl.h: (Backport) take over definitions of _WIN32,
	DLLIMPORT, DLLEXPORT and TCL_LL_MODIFIER macros from Tcl8.5/8.6

2010-06-28  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclPosixStr.c: [Bug 3019634] errno.h and tclWinPort.h
	have conflicting definitions.

2010-06-09  Andreas Kupries  <andreask@activestate.com>

	* library/platform/platform.tcl: Added OSX Intel 64bit
	* library/platform/pkgIndex.tcl: Package updated to version 1.0.9.

2010-05-07  Andreas Kupries  <andreask@activestate.com>

	* library/platform/platform.tcl: Fix cpu name for Solaris/Intel 64bit.
	* library/platform/pkgIndex.tcl: Package updated to version 1.0.8.

2010-04-29  Andreas Kupries  <andreask@activestate.com>

	* library/platform/platform.tcl: Another stab at getting the /lib,
	* library/platform/pkgIndex.tcl: /lib64 difference right for
	linux. Package updated to version 1.0.7.

2010-04-18  Donal K. Fellows  <dkf@users.sf.net>

	* doc/unset.n: [Bug 2988940]: Fix typo.

2010-04-14  Andreas Kupries  <andreask@activestate.com>

	* library/platform/platform.tcl: Linux platform identification:
	* library/platform/pkgIndex.tcl: Check /lib64 for existence of
	files matching libc* before accepting it as base directory. This
	can happen on weirdly installed 32bit systems which have an empty
	or partially filled /lib64 without an actual libc. Bumped to
	version 1.0.6.

2010-04-06  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclCmdMZ.c (Tcl_RegexpObjCmd): fixed object leak.

2010-04-02  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclStringObj.c: (SetStringFromAny): avoid trampling
	over the tclEmptyStringRep->bytes as it is thread-shared
	(thx to Gustaf Neumann for the (hard) work of locating this one).

2010-03-01  Alexandre Ferrieux  <ferrieux@users.sourceforge.net>

	* unix/tclUnixChan.c: [backported] Refrain from a possibly lengthy
	reverse-DNS lookup on 0.0.0.0 when calling [fconfigure -sockname]
	on an universally-bound (default) server socket.

2010-02-22  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tclExecute.c:   Fix [Bug 2954959] expr abs(-0.0) is -0.0
	* tests/expr.test         Added some test cases, backported from 8.5

2010-02-11  Andreas Kupries  <andreask@activestate.com>

	* generic/tclCompile.c: [Bug 2949302]: Fixed leak of support
	structures for [info frame] which occured when bytecode
	compilation fails.

2010-02-01  Donal K. Fellows  <dkf@users.sf.net>

	* generic/regexec.c (ccondissect, crevdissect): [Bug 2942697]: Rework
	these functions so that certain pathological patterns are matched much
	more rapidly. Many thanks to Tom Lane for dianosing this issue and
	providing an initial patch.

2009-11-16  Alexandre Ferrieux  <ferrieux@users.sourceforge.net>

	* generic/tclEncoding.c: (Backport) Fix [Bug 2891556] and improve
	* tests/econding.test:   test to detect similar manifestations in the
				 future.

2009-11-12  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c (CopyData): [Bug 2895565]. Dropped bogosity
	* tests/io.test: which used the number of _written_ bytes or
	character to update the counters for the read bytes/characters.
	New test io-53.11. This is a backward port from the 8.5 branch.

2009-11-10  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* tests/fCmd.test:     Fixed a number of issues for Vista
	* tests/registry.test: and Win7 that are due to restricted
	* tests/tcltest.test:  permissions under UAC.
	* tests/winFCmd.test:

2009-11-10  Stuart Cassoff <stwo@users.sf.net>

	* win/README: [bug 2459744]: Removed outdated Msys + Mingw info.

2009-11-10  Andreas Kupries  <andreask@activestate.com>

	* generic/tclObj.c: Plug memory leak in TclContinuationsEnter().
	[Bug 2895323]. Backport from Tcl 8.5 branch, change by Don Porter.

2009-11-09  Andreas Kupries  <andreask@activestate.com>

	* generic/tclBasic.c (TclEvalObjEx): Moved the #280 decrement of
	refCount for the file path out of the branch after the whole
	conditional, closing a memory leak. Added clause on structure type
	to prevent seg.faulting. Backport from valgrinding the Tcl 8.5
	branch.

	* tests/info.test: Resolve ambiguous resolution of variable
	"res". Backport from 8.5

2009-10-23  Andreas Kupries  <andreask@activestate.com>

	* generic/tclCompCmds.c: [Bug 2881263] (TclCompileForeachCmd,
	TclCompileLindexCmd): Fixed. Moved the use of
	DefineLineInformation after all regular variable declarations, so
	that an empty statement (-UTIP_280) doesn't confuse c89 compilers.

	* library/platform/pkgIndex.tcl: Backported the platform packages
	* library/platform/platform.tcl: from head and8.5 into the 8.4
	* library/platform/shell.tcl: branch. Updated makefiles to install
	* unix/Makfile.in: the packages.
	* win/Makefile.in:

	* generic/tclIO.c (FlushChannel): Skip OutputProc for low-level
	0-length writes. When closing pipes which have already been closed
	not skipping leads to spurious SIG_PIPE signals. Reported by
	Mikhail Teterin <mi+thun@aldan.algebra.com>.

2009-10-21  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tclPosixStr.c: [Bug 2882561]: Work around oddity on Haiku OS
	where SIGSEGV and SIGBUS are the same value.

2009-10-18  Joe Mistachkin  <joe@mistachkin.com>

	* tests/thread.test (thread-4.[345]): [Bug 1565466]: Correct tests to
	save their error state before the final call to threadReap just in case
	it triggers an "invalid thread id" error.  This error can occur if one
	or more of the target threads has exited prior to the attempt to send
	it an asynchronous exit command.

2009-10-04  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tclMacOSXBundle.c:	Workaround CF memory managment bug in
	* unix/tclUnixInit.c:		Mac OS X 10.4 & earlier. [Bug 2569449]

2009-09-28  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclAlloc.c:		Cleaned up various routines in the
	* generic/tclCkalloc.c:		call stacks for memory allocation to
	* generic/tclParse.c:		guarantee that any size values computed
	* generic/tclThreadAlloc.c:	are within the domains of the routines
	they get passed to.  [Bugs 2557696 and 2557796].

2009-09-18  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c (Tcl_SubstObj):	Pass 'length' values to
	recursive parsing calls to convert O(N^2) operations of [subst]
	to O(N).

2009-08-25  Andreas Kupries  <andreask@activestate.com>

	* generic/tclBasic.c (Tcl_CreateInterp, Tcl_EvalTokensStandard,
	(EvalTokensStandard, Tcl_EvalEx, EvalEx, TclAdvanceContinuations,
	(TclEvalObjEx):
	* generic/tclCmdMZ.c (Tcl_SwitchObjCmd, ListLines):
	* generic/tclCompCmds.c (*):
	* generic/tclCompile.c (TclSetByteCodeFromAny, TclInitCompileEnv,
	(TclFreeCompileEnv, TclCompileScript):
	* generic/tclCompile.h (CompileEnv):
	* generic/tclInt.h (ContLineLoc, Interp):
	* generic/tclObj.c (ThreadSpecificData, ContLineLocFree,
	(TclThreadFinalizeObjects, TclInitObjSubsystem,
	(TclContinuationsEnter, TclContinuationsEnterDerived,
	(TclContinuationsCopy, TclContinuationsGet, TclFreeObj):
	* generic/tclProc.c (TclCreateProc):
	* generic/tclVar.c (TclPtrSetVar):
	* tests/info.test (info-30.0-22):

	Extended parser, compiler, and execution with code and attendant
	data structures tracking the positions of continuation lines which
	are not visible in script's, to properly account for them while
	counting lines for #280, during direct and compiled execution.

2009-08-17  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclFileName.c: Correct result from [glob */test] when *
	* tests/fileName.test:	matches something like ~foo.  [Bug 2837800]

2009-07-23  Joe Mistachkin  <joe@mistachkin.com>

	* generic/tclNotify.c: Fix for [Bug 2820349].

2009-07-14  Andreas Kupries  <andreask@activestate.com>

	* generic/tclBasic.c (DeleteInterpProc,TclArgumentBCEnter,
	(TclArgumentBCRelease, TclArgumentGet):
	* generic/tclCompile.c (EnterCmdWordIndex, TclCleanupByteCode,
	(TclInitCompileEnv, TclCompileScript):
	* generic/tclCompile.h (ExtCmdLoc):
	* generic/tclExecute.c (TclExecuteByteCode):
	* generic/tclInt.h (ExtIndex, CFWordBC):
	* tests/info.test (info-39.0):

	Backport of some changes made to the Tcl head, to handle literal
	sharing better. The code here is much simpler (trimmed down)
	compared to the head as the 8.4 branch is not bytecode compiling
	whole files, and doesn't compile eval'd code either.

	Reworked the handling of literal command arguments in bytecode to
	be saved (compiler) and used (execution) per command (See the
	TCL_INVOKE_STK* instructions), and not per the whole bytecode.
	This removes the problems with location data caused by literal
	sharing in proc bodies. Simplified the associated datastructures
	(ExtIndex is gone, as is the function EnterCmdWordIndex).

2009-06-13  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCompile.c: The value stashed in iPtr->compiledProcPtr
	* generic/tclProc.c:    when compiling a proc survives too long.  We
	* tests/execute.test:   only need it there long enough for the right
	TclInitCompileEnv() call to re-stash it into envPtr->procPtr.  Once
	that is done, the CompileEnv controls.  If we let the value of
	iPtr->compiledProcPtr linger, though, then any other bytecode compile
	operation that takes place will also have its CompileEnv initialized
	with it, and that's not correct.  The value is meant to control the
	compile of the proc body only, not other compile tasks that happen
	along.  Thanks to Carlos Tasada for discovering and reporting the
	problem.  [Bug 2802881].

2009-04-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4, unix/configure (SC_CONFIG_CFLAGS): harden the check
	to add _r to CC on AIX with threads.

2009-04-27  Alexandre Ferrieux  <ferrieux@users.sourceforge.net>

	* generic/tclInt.h:   Backport fix for [Bug 1028264]: WSACleanup() too
	* generic/tclEvent.c: early. The fix introduces "late exit handlers"
	* win/tclWinSock.c:   for similar late process-wide cleanups.

2009-04-27  Alexandre Ferrieux  <ferrieux@users.sourceforge.net>

	* win/tclWinSock.c: Backport fix for [Bug 2446662]: resync Win
	behavior on RST with that of unix (EOF).

2009-04-22  Andreas Kupries  <andreask@activestate.com>

	* generic/tclStringObj.c (UpdateStringOfString): Added cast to fix
	signed/unsigned mismatch breaking win32 symbol/debug build.

2009-04-15  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclStringObj.c:       AppendUnicodeToUnicodeRep failed
	to set stringPtr->allocated to 0, leading to crashes.

2009-04-14  Stuart Cassoff  <stwo@users.sourceforge.net>

	* unix/tcl.m4:	Removed -Wno-implicit-int from CFLAGS_WARNING.

2009-04-08  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl:	Fixed unsafe [eval]s in the tcltest
	* library/tcltest/pkgIndex.tcl:	package.  [Bug 2570363]

2009-04-07  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclStringObj.c:       Completed backports of fixes for
	[Bug 2494093] and [Bug 2553906].

2009-03-30  Don Porter  <dgp@users.sourceforge.net>

	* doc/Alloc.3:	Size argument is "unsigned int".  [Bug 2556263]

	* generic/tclStringObj.c:       Added protections from invalid memory
	* generic/tclTestObj.c:         accesses when we append (some part of)
	* tests/stringObj.test:         a Tcl_Obj to itself.  Added the
	appendself and appendself2 subcommands to the [teststringobj] testing
	command and added tests to the test suite.  [Bug 2603158]

2009-03-27  Don Porter  <dgp@users.sourceforge.net>

	* tests/fileName.test:	Tests for [Bug 2710920] to guard against
	its appearance.

2009-03-20  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclStringObj.c:	Test stringObj-6.9 checks that
	* tests/stringObj.test:		Tcl_AppendStringsToObj() no longer
	crashes when operating on a pure unicode value.  [Bug 2597185]

	* generic/tclExecute.c (INST_CONCAT1):	Panic when appends overflow
	the max length of a Tcl value.  [Bug 2669109]

2009-03-18  Don Porter  <dgp@users.sourceforge.net>

	* win/tclWinFile.c (TclpObjNormalizePath):      Corrected Tcl_Obj leak.
	Thanks to Joe Mistachkin for detection and patch.  [Bug 2688184].

2009-02-20  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclPathObj.c: Fixed mistaken logic in TclFSGetPathType()
	* tests/fileName.test:  that assumed (not "absolute" => "relative").
	This is a false assumption on Windows, where "volumerelative" is
	another possibility.  [Bug 2571597].

2008-02-06  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tcl.h (Darwin): workaround conflict between deprecated tcl
	panic macro and panic() function declaration in <mach/mach.h> header.

2009-02-05  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclStringObj.c: Added overflow protections to the
	AppendUtfToUtfRep routine to either avoid invalid arguments and
	crashes, or to replace them with controlled panics.  [Bug 2561794]

2009-02-04  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclStringObj.c (SetUnicodeObj):       Corrected failure of
	Tcl_SetUnicodeObj() to panic on a shared object.  [Bug 2561488].  Also
	factored out common code to reduce duplication.

2009-01-09  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclStringObj.c (STRING_SIZE): Corrected failure to limit
	memory allocation requests to the sizes that can be supported by
	Tcl's memory allocation routines.  [Bug 2494093].

2009-01-08  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclStringObj.c (STRING_UALLOC):  Added missing parens
	required to get correct results out of things like
	STRING_UALLOC(num + append).  [Bug 2494093].

2008-12-04  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclIOUtil.c (Tcl_FSGetNormalizedPath):	Added another
	flag value TCLPATH_NEEDNORM to mark those intreps which need more
	complete normalization attention for correct results.  [Bug 2385549]

2008-12-03  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclFileName.c (TclDoGlob):	One of the
	Tcl_FSMatchInDirectory() calls did not have its return code
	checked.  Some VFS drivers can return TCL_ERROR, and when that's
	not checked, the error message gets converted into a list of
	matching files returned by [glob], with ridiculous results.

2008-12-01  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclIO.c (TclFinalizeIOSubsystem): Revised latest commit to
	something that doesn't crash the test suite.

2008-11-25  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c (TclFinalizeIOSubsystem): Applied backport of
	  Alexandre Ferrieux's patch for [Bug 2270477] to prevent infinite
	  looping during finalization of channels not bound to
	  interpreters.

2008-11-23  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c: Backport of fix for [Bug 2333466].

2008-11-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclPort.h: remove the ../{win,unix}/ header dirs as the
	build system already has it, and it confuses builds when used with
	private headers installed.

2008-09-25  Don Porter  <dgp@users.sourceforge.net>

	* doc/global.n:	Correct false claim about [info locals].

2008-08-14  Don Porter  <dgp@users.sourceforge.net>

	* tests/fileName.test:	Revise new tests for portability to case
	insensitive filesystems.

2008-08-14  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tclCompile.h:		add support for debug logging of DTrace
	* generic/tclBasic.c:		'proc', 'cmd' and 'inst' probes (does
					_not_ require a platform with DTrace).

	* unix/Makefile.in:		ensure Makefile shell is /bin/bash for
	* unix/configure.in (SunOS):	DTrace-enabled build on Solaris.
					(followup to 2008-06-12) [Bug 2016584]

	* unix/tcl.m4 (SC_PATH_X):	check for libX11.dylib in addition to
					libX11.so et al.

	* unix/configure: 		autoconf-2.13

2008-08-13  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclFileName.c:	Fix for errors handling -types {}
	* tests/fileName.test:		option to [glob]. [Bug 1750300]
	Thanks to Matthias Kraft and George Peter Staplin.

2008-08-11  Andreas Kupries  <andreask@activestate.com>

	* generic/tclProc.c (Tcl_ProcObjCmd): Fixed memory leak triggered
	* tests/proc.test: by procbody::test::proc. See [Bug 2043636].
	Added a test case demonstrating the leak before the fix. Fixed a
	few spelling errors in test descriptions as well.

2008-07-28  Andreas Kupries  <andreask@activestate.com>

	* generic/tclBasic.c: Added missing release of extended command
	word index when deleting an interpreter (DeleteInterpProc). Added
	missing ref count when creating an empty string as path (EvalEx).

	* generic/tclCompile.c (TclInitCompileEnv): Made same change to
	control flow as in TclEvalObjEx. Not needed while uplevel and
	siblings go through the eval-direct code path, however if that
	changes (like it did in 8.5+) better to have this in place instead
	of re-searching why certain places are without absolute locations.

	* tests/info.test: Added tests 38.*, exactly testing the tracking
	of location for uplevel scripts, and made the testsuite fully
	usable with and without -singleproc 1.

2008-07-25  Daniel Steffen  <das@users.sourceforge.net>

	* tests/info.test: Add !singleTestInterp constraint to various tests;
	(info-22.8, info-23.0): switch to glob matching to avoid sensitivity
	to tcltest.tcl line number changes. [Bug 1605269]

2008-07-24  Andreas Kupries  <andreask@activestate.com>

	* tests/info.test: Tests 38.* added, exactly testing the tracking
	of location for uplevel scripts.

2008-07-23  Andreas Kupries  <andreask@activestate.com>

	* generic/tclBasic.c: Modified TclArgumentGet to reject pure lists
	* generic/tclCmdIL.c: immediately, without search. Reworked setup
	* generic/tclCompile.c: of eoFramePtr, doesn't need the line
	* tests/info.test: information, more sensible to have everything
	on line 1 when eval'ing a pure list. Updated the users of the line
	information to special case this based on the frame type (i.e.
	TCL_LOCATION_EVAL_LIST). Added a testcase demonstrating the new
	behaviour.

2008-07-22  Andreas Kupries  <andreask@activestate.com>

	* generic/tclBasic.c: Added missing function comments.

	* generic/tclCompile.c: Made the new TclEnterCmdWordIndex
	* generic/tclCompile.h: static.

	* generic/tclBasic.c: Reworked the handling of bytecode literals
	* generic/tclCompile.c: for #280 to fix the abysmal performance
	* generic/tclCompile.h: for deep recursion, replaced the linear
	* generic/tclExecute.c: search through the whole stack with
	* generic/tclInt.h: another hashtable and simplified the data
	structure used by the compiler (array instead of hashtable).
	Incidentially this also fixes the memory leak reported via [Bug
	2024937].

2008-07-21  Andreas Kupries <andreask@activestate.com>

	* generic/tclBasic.c: Extended the existing TIP #280 system (info
	* generic/tclCmdAH.c: frame), added the ability to track the
	* generic/tclCompCmds.c: absolute location of literal procedure
	* generic/tclCompile.c: arguments, and making this information
	* generic/tclCompile.h: available to uplevel, eval, and
	* generic/tclInterp.c: siblings. This allows proper tracking of
	* generic/tclInt.h: absolute location through custom (Tcl-coded)
	* generic/tclNamesp.c: control structures based on uplevel, etc.
	* generic/tclProc.c:

2008-07-07  Andreas Kupries  <andreask@activestate.com>

	* generic/tclCmdIL.c (InfoFrameCmd): Fixed unsafe idiom of setting
	the interp result found by Don Porter.

2008-07-04  Joe English  <jenglish@users.sourceforge.net>

	* generic/tclEncoding.c(UtfToUtfProc): Avoid unwanted sign extension
	when converting incomplete UTF-8 sequences. See [Bug 1908443] for
	details.

2008-07-03  Don Porter  <dgp@users.sourceforge.net>

	* library/package.tcl:	Removed [file readable] testing from
	[tclPkgUnknown] and friends.  We find out soon enough whether a
	file is readable when we try to [source] it, and not testing
	before allows us to workaround the bugs on some common filesystems
	where [file readable] lies to us.  [Patch 1969717]

2008-06-28  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclIOUtil.c:	Plug memory leak in latest commit.  Thanks
	Rolf Ade for detecting and Dan Steffen for the fix [Bug 2004654].

2008-06-23  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclIOUtil.c: Fixed bug in Tcl_GetTranslatedPath() when
	operating on the "Special path" variant of the "path" Tcl_ObjType
	intrep.  A full normalization was getting done, in particular, coercing
	relative paths to absolute, contrary to what the function of
	producing the "translated path" is supposed to do.  [Bug 1972879].

2008-06-20  Don Porter  <dgp@users.sourceforge.net>

	* tests/binary.test:	Corrected flawed tests revealed by a -debug 1
	* tests/io.test:	-singleproc 1 test suite run.

2008-06-18  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclParseExpr.c:	Disabled attempts to support [expr]
	functions named eq(...) or ne(...).  Any attempts to use such
	functions were panicking.  [Bug 1971879].

2008-06-16  Andreas Kupries  <andreask@activestate.com>

	* generic/tclCmdIL.c (InfoFrameCmd): Backport of fix made on the
	* tests/info.test: head branch :: Moved the code looking up the
	information for key 'proc' out of the TCL_LOCATION_BC branch to
	after the switch, this is common to all frame types. Updated the
	testsuite to match. This was exposed by the 2008-06-08 commit
	(Miguel), switching uplevel from direct eval to compilation. Fixes
	[Bug 1987851].

2008-06-12  Andreas Kupries  <andreask@activestate.com>

	* generic/tclCmdIL.c (InfoFrameCmd): TIP #280 conditional
	  feature. Added checks to validate HashEntry and HashTable
	  information gotten from Command structures. This seems to be
	  needed to handle structures managed by Itcl.

2008-06-12  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in:		add complete deps on tclDTrace.h.

	* unix/Makefile.in:		clean generated tclDTrace.h file.
	* unix/configure.in (SunOS): 	fix static DTrace-enabled build.

	* unix/tcl.m4 (SunOS-5.11): fix 64bit amd64 support with gcc & Sun cc.
	* unix/configure: autoconf-2.13

2008-05-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/io.test (io-53.9): need to close chan before removing file.

2008-05-23  Andreas Kupries  <andreask@activestate.com>

	* win/tclWinChan.c (FileWideSeekProc): Accepted a patch by
	  Alexandre Ferrieux <ferrieux@users.sourceforge.net> to fix the
	  [Bug 1965787]. 'tell' now works for locations > 2 GB as well
	  instead of going negative.

	* generic/tclIO.c (Tcl_SetChannelBufferSize): Accepted a patch by
	* tests/io.test:  Alexandre Ferrieux <ferrieux@users.sourceforge.net>
	  to fix the [Bug 1969953]. Buffersize outside of the supported
	  range are now clipped to nearest boundary instead of ignored.

2008-04-26  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclAsync.c: Tcl_AsyncDelete(): panic if attempt
	to locate handler token fails. Happens when some other
	thread attempts to delete somebody else's token.

	Also, panic early if we find out the wrong thread attempting
	to delete the async handler (common trap). As, only the one
	that created the handler is allowed to delete it.

2008-04-17  Andreas Kupries  <andreask@activestate.com>

	*** 8.4.19 TAGGED FOR RELEASE ***

	* generic/tclCompExpr.c (CompileMathFuncCall): Added
	* tests/compExpr.test (compExpr-5.10): Tcl_ResetResult before
	appending error message, to clear out possible sharing. Added test
	case demonstrating the crash (abort on shared object) without the
	fix.

2008-04-15  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c (CopyData): Applied another patch by Alexandre
	* io.test (io-53.8a): Ferrieux <ferrieux@users.sourceforge.net>,
	to shift EOF handling to the async part of the command if a
	callback is specified, should the channel be at EOF already when
	fcopy is called. Testcase by myself.

2008-04-14  Kevin B. Kenny  <kennykb@acm.org>

	* unix/tclUnixTime.c (TclpGetClicks, Tcl_GetTime): Removed
	obsolete use of 'struct timezone' in the call to 'gettimeofday'.
	[Bug 1942197].

2008-04-14  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclExecute.c:	Plug memory leak introduced in the
	2008-03-07 commit.  [Bug 1940433]

2008-04-11  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.4.19
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

	* changes:		updates for 8.4.19 release.

2008-04-10  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIOCmd.c (Tcl_FcopyObjCmd): Keeping check for negative
	values, changed to not be an error, but behave like the special
	value -1 (copy all, default).

	* tests/iocmd.test (iocmd-15.{12,13}): Removed.

	* tests/io.test (io-52.5{,a,b}): Reverted last change, added
	comment regarding the meaning of -1, added two more testcases for
	other negative values, and input wrapped to negative.

2008-04-09  Andreas Kupries  <andreask@activestate.com>

	* tests/io.test (io-52.5): Removed '-size -1' from test, does not
	seem to have any bearing, and was an illegal value. Test case is
	not affected by the value of -size, test flag restoration and that
	everything was properly copied.

	* generic/tclIOCmd.c (Tcl_FcopyObjCmd): Added checking of -size
	* tests/ioCmd.test (iocmd-15.{13,14}): value to reject negative
	values, and values overflowing 32-bit signed. [Bug 1557855]. Basic
	patch by Alexandre Ferrieux <ferrieux@users.sourceforge.net>, with
	modifications from me to separate overflow from true negative
	value. Extended testsuite.

2008-04-08  Andreas Kupries  <andreask@activestate.com>

	* tests/io.test (io-53.8,53.9,53.10): Backported das' fix of typo
	  and quoting for spaces in builddir path.

2008-04-07  Andreas Kupries  <andreask@activestate.com>

	* tests/io.test (io-53.10): Testcase for bi-directionaly fcopy.
	* generic/tclIO.c: Additional changes to data structures for fcopy
	* generic/tclIO.h: and channels to perform proper cleanup in case
	  of a channel having two background copy operations running as is
	  now possible.

	* generic/tclIO.c (BUSY_STATE, CheckChannelErrors,
	  TclCopyChannel): New macro, and the places using it. This change
	  allows for bi-directional fcopy on channels. [Bug 1350564].
	  Thanks to Alexandre Ferrieux <ferrieux@users.sourceforge.net>
	  for the patch.

	* tests/io.test (io-53.9): Made test cleanup robust against the
	  possibility of slow process shutdown on Windows. Backported from
	  Kevin Kenny's change to the same test on the 8.5 and head
	  branches.

2008-04-04  Andreas Kupries  <andreask@activestate.com>

	* tests/io.test (io-53.9): Added testcase for [Bug 780533], based
	  on Alexandre's test script. Also fixed problem with timer in
	  preceding test, was not canceled properly in the ok case.

2008-04-03  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c (CopyData): Applied patch [Bug 1932639] to
	* tests/io.test: prevent fcopy from calling -command synchronously
	  the first time. Thanks to Alexandre Ferrieux
	  <ferrieux@users.sourceforge.net> for report and patch.

2008-04-02  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c (CopyData): Applied patch for the fcopy problem
	  [Bug 780533], with many thanks to Alexandre Ferrieux
	  <ferrieux@users.sourceforge.net> for tracking it down and
	  providing a solution. Still have to convert his test script into
	  a proper test case.

2008-03-27  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (SunOS-5.1x): fix 64bit support for Sun cc. [Bug 1921166]

	* unix/dltest/Makefile.in: support use of LDFLAGS in SHLIB_LD.

	* unix/configure: autoconf-2.13

2008-03-24  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tclBinary.c: bug #1923966 - crash in binary format
	* tests/binary.test:   Added tests for the above crash condition.

2008-03-11  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tclMacOSXNotify.c: avoid using CoreFoundation after fork() on
	Darwin 9 even when TclpCreateProcess() uses vfork().

2008-03-07  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclExecute.c (Tcl_ExprObj):   Revised expression bytecode
	compiling so that bytecodes invalid due to changing context or due
	to the difference between expressions and scripts are not reused.
	[Bug 1899164].

	* generic/tclTest.c:	Backport the [testexprlongobj] testing command.

	* tests/execute.test (execute-6.8):	Added tests checking that
	bytecode is invalidates in the right situations.

2008-03-03  Reinhard Max  <max@suse.de>

	* unix/tclUnixChan.c: Fix mark and space parity on Linux, which
	uses CMSPAR instead of PAREXT.

2008-02-27  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/http/pkgIndex.tcl: Backported 2.5.5 changes from
	* library/http/http.tcl:     8.5 version.
	* doc/http.n:                Document the meta accessor.

2008-02-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIOCmd.c (Tcl_GetsObjCmd): do not reuse resultObj as
	it may be shared (crash condition).

2008-02-22  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/http/pkgIndex.tcl: Set version 2.5.4
	* library/http/http.tcl:     Fix for bug #1818565. Always check that
	the state array exists in the http::status command.

2008-02-06  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.18 TAGGED FOR RELEASE ***

	* README:		Bump version number to 8.4.18
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

	* changes:		updates for 8.4.18 release.

2008-02-02  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure.in (Darwin):	correct Info.plist year substitution in
					non-framework builds.

	* unix/configure:		autoconf-2.13

2008-01-30  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclInterp.c (Tcl_GetAlias): fix for [Bug 1882373]

2008-01-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinSerial.c (SerialCloseProc, TclWinOpenSerialChannel):
	use critical section for read & write side. [Bug 1353846] (newman)

2007-12-31  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.17 TAGGED FOR RELEASE ***

	* changes:		updates for 8.4.17 release.
	* doc/filename.n:	Typo

2007-12-18  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* generic/regguts.h, generic/regc_color.c, generic/regc_nfa.c:
	Fixes for problems created when processing regular expressions that
	generate very large automata. An enormous number of thanks to Will
	Drewry <wad@google.com>, Tavis Ormandy <taviso@google.com>, and Tom
	Lane <tgl@sss.pgh.pa.us> from the Postgresql crowd for their help in
	tracking these problems down. [Bug 1810264]

2007-12-14  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/README: updated notes

2007-12-14  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* unix/tclUnixCompat.c (TclpGetHostByName): Really applied
	the change noted on 2007-11-13 by dkf below.

2007-12-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIOUtil.c (TclGetOpenMode): Only set the O_APPEND flag
	* tests/ioUtil.test (ioUtil-4.1):	on a channel for the 'a'
	mode and not for 'a+'. [Bug 1773127] (backport from HEAD)

2007-12-05  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclCmdIL.c (Tcl_LsearchObjCmd): Prevent shimmering crash
	when -exact and -integer/-real are mixed. [Bug 1844789]

2007-11-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinSock.c (Tcl_GetHostName): update to previous fix to
	set hostname length appropriately, clean up check overall.

2007-11-27  Don Porter  <dgp@users.sourceforge.net>

	* win/tclWinSock.c:	Add missing encoding conversion of the
	[info hostname] value from the system encoding to Tcl's internal
	encoding.  This is important now that ICANN no longer limits host
	names to ASCII.  [Bug 1823552]

2007-11-26  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclThread.c: Back-port locking changes from Tcl8.5
	in Tcl_Mutex/ConditionFinlize. Now we properly master-lock
	the finalization of sync primitives.

2007-11-15  Don Porter  <dgp@users.sourceforge.net>

	* generic/regc_nfa.c:	Fixed infinite loop in the regexp compiler
	* generic/regcomp.c:	[Bug 1810038].  Corrected looping logic in
	* tests/regexp.test:	fixempties() to avoid wasting time walking a
	list of dead states [Bug 1832612].  Convert optst() from expensive
	no-op to a cheap no-op.  Improve newline usage in debug output.

2007-11-13  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tclUnixCompat.c (TclpGetHostByName): The six-argument form of
	getaddressbyname_r() uses the fifth argument to indicate whether the
	lookup succeeded or not on at least one platform. [Bug 1618235]

2007-10-30  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/regc_lex.c (lexescape): Ensure that backreference numbers
	can't overflow a signed int in a way that breaks things. [Bug 1810264]

2007-10-15  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclParse.c (Tcl_ParseBraces): fix for possible read
	after the end of buffer, [Bug 1813528] (Joe Mistachkin).

2007-10-03  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclObj.c (Tcl_FindCommandFromObj): fix finding a deleted
	command; cannot trigger this from Tcl itself, but crash reported
	on xotcl. This check is new to 8.4 but exists in 8.5, so this is a
	backport or something. Thanks Gustaf Neumann.

2007-10-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tcl.h (Tcl_DecrRefCount): Update change from 2006-05-29
	to make macro more warning-robust in unbraced if code.

2007-10-02  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.4.17
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

2007-09-20  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.16 TAGGED FOR RELEASE ***

	* doc/load.n:	Backport corrected example.

2007-09-19  Don Porter  <dgp@users.sourceforge.net>

	* unix/Makefile.in:     Update `make dist` so that tclDTrace.d is
	included in the source code distribution.

	* generic/tclPkg.c:	Backport fix for [1573844] to the
	* tests/pkg.test:	TCL_TIP268 sections.

2007-09-18  Don Porter  <dgp@users.sourceforge.net>

	* changes: updates for 8.4.16 release.

2007-09-15  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (SunOS-5.1x): 	replace direct use of '/usr/ccs/bin/ld'
					in SHLIB_LD by 'cc' compiler driver.
	* unix/configure: autoconf-2.13

2007-09-14  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tclDTrace.d (new file): add DTrace provider for Tcl; allows
	* generic/tclCompile.h:		  tracing of proc and command entry &
	* generic/tclBasic.c: 		  return, bytecode execution, object
	* generic/tclExecute.c:		  allocation and more; with essentially
	* generic/tclInt.h:		  zero cost when tracing is inactive;
	* generic/tclObj.c:		  enable with --enable-dtrace configure
	* generic/tclProc.c:		  arg (disabled by default, will only
	* unix/Makefile.in:		  enable if DTrace is present).
	* unix/configure.in:		  [Patch 1793984]

	* macosx/Makefile:		  enable DTrace support.

	* unix/configure: autoconf-2.13

2007-09-11  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl:	Accept underscores and colons in
	* library/tcltest/pkgIndex.tcl:	constraint names.  Properly handle
	constraint expressions that return non-numeric boolean results like
	"false".  Bump to tcltest 2.2.9. [Bug 1772989; RFE 1071322]

2007-09-11  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc:  AMD64 target fixes for symbols builds.
	* win/rules.vc:

2007-09-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclLink.c (Tcl_UpdateLinkedVar): guard against var being
	unlinked. [Bug 1740631] (maros)

2007-08-25  Kevin Kenny  <kennykb@acm.org>

	* generic/tclClock.c (FormatClock): Claimed additional space for
	the %c format code to avoid a buffer overrun when formatting
	(for example) a Friday in February in the Portuguese locale.
	[Bug 1751117]

2007-08-24  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclCompile.c: replaced copy loop that tripped some
	compilers with memmove [Bug 1780870]

2007-08-14  Don Porter  <dgp@users.sourceforge.net>

	* tests/trace.test:	Backport some tests.

2007-08-14  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tclLoadDyld.c: use dlfcn API on Mac OS X 10.4 and later; fix
	issues with loading from memory on intel and 64bit; add debug messages.

	* tests/load.test: add test load-10.1 for loading from vfs.

2007-08-07  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tclEnv.c:	improve environ handling on Mac OS X (adapted
	* unix/tclUnixPort.h:	from Apple changes in Darwin tcl-64).

	* unix/Makefile.in:	add support for compile flags specific to
				object files linked directly into executables.

	* unix/configure.in (Darwin): only use -seg1addr flag when prebinding;
	use -mdynamic-no-pic flag for object files linked directly into exes;
	support overriding TCL_PACKAGE_PATH in environment.

	* unix/configure: autoconf-2.13

2007-07-19  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclParse.c:	In contexts where interp and parsePtr->interp
	might be different, be sure to use the latter for error reporting.

2007-07-05  Don Porter  <dgp@users.sourceforge.net>

	* library/init.tcl (unknown):	Corrected inconsistent error message
	in interactive [unknown] when empty command is invoked. [Bug 1743676]

2007-06-30  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclBinary.c (Tcl_BinaryObjCmd): De-fang an instance of the
	shared-result anti-pattern. [Bug 1716704]

2007-06-30  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclThread.c: Prevent RemeberSyncObj() from growing the sync
	object lists by reusing already free'd slots, if possible.
	See discussion on Bug 1726873 for more information.

2007-06-29  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tclAlloc.c:		on Darwin, ensure memory allocated by
	* generic/tclThreadAlloc.c:	the custom TclpAlloc()s is aligned to
	16 byte boundaries (as is the case with the Darwin system malloc).

2007-06-27  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c:	Corrected broken trace reversal logic in
	* generic/tclTest.c:	TclCheckInterpTraces that led to infinite loop
	* tests/basic.test:	when multiple Tcl_CreateTrace traces were set
	and one of them did not fire due to level restrictions.  [Bug 1743941].

2007-06-23  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tclMacOSXNotify.c (AtForkChild): don't call CoreFoundation
	APIs after fork() on systems where that would lead to an abort().

2007-06-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* README: updated links. [Bug 1715081]

2007-06-06  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure.in (Darwin):		add plist for tclsh; link the
	* unix/Makefile.in  (Darwin):		Tcl and tclsh plists into their
	* macosx/Tclsh-Info.plist.in (new):	binaries in all cases.

	* unix/tcl.m4 (Darwin): fix CF checks in fat 32&64bit builds.
	* unix/configure: autoconf-2.13

2007-06-05  Don Porter  <dgp@users.sourceforge.net>

	* tests/result.test (result-6.2): Add test for [Bug 1649062] so that
	8.4 and 8.5 both test the same outcome and we verify compatibility.

2007-05-30  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.4.16
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

2007-05-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tclUnixThrd.c (Tcl_JoinThread): fix for 64-bit handling of
	pthread_join exit return code storage. [Bug 1712723]

2007-05-24  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.15 TAGGED FOR RELEASE ***

	* generic/tclIO.c:	Backport memleak fix in TclFinalizeIOSubsystem.

2007-05-17  Don Porter  <dgp@users.sourceforge.net>

	* tests/fCmd.test:	Backport the notNetworkFilesystem constraint.

2007-05-15  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclNamesp.c:	Plugged memory leak related to
	[namespace delete ::]. [Bug 1716782]

	* changes: updates for 8.4.15 release.

	* win/tclWinReg.c:		Bump to registry 1.1.5 to account
	* library/reg/pkgIndex.tcl:	for [Bug 1682211] fix.

2007-05-10  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclInt.h:     TclFinalizeThreadAlloc() is always defined,
	so make sure it is also always declared.

	[Tcl Bug 1706140]

	* generic/tclCmdMZ.c (Trace*Proc):	Update Tcl_VarTraceProcs so
	* generic/tclLink.c (LinkTraceProc):    that they call
	* generic/tclUtil.c (TclPrecTraceProc): Tcl_InterpDeleted() for
	themselves, and do not rely on (frequently buggy) setting of the
	TCL_INTERP_DESTROYED flag by the trace core.

	* generic/tclVar.c:     Update callers of CallVarTraces to not
	pass in the TCL_INTERP_DESTROYED flag.  Also apply filters so that
	public routines only pass documented flag values down to lower level
	routines.

	* generic/tclVar.c (CallVarTraces):        The setting of the
	TCL_INTERP_DESTROYED flag is now done entirely within the
	CallVarTraces routine, the only place it can be done right.

2007-04-30  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in: add 'tclsh' dependency to install targets that rely
	on tclsh, fixes parallel 'make install' from empty build dir.

2007-04-29  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tclUnixFCmd.c: add workaround for crashing bug in fts_open()
	* unix/tclUnixInit.c: without FTS_NOSTAT on 64bit Darwin 8 or earlier.

	* unix/tclLoadDyld.c (TclpLoadMemory): fix (void*) arithmetic.

	* macosx/tclMacOSXNotify.c:	fix warnings.

	* macosx/README:		sync whitespace/formatting with HEAD.
	* macosx/tclMacOSXBundle.c:
	* macosx/tclMacOSXNotify.c:
	* unix/tclLoadDyld.c:

	* macosx/Makefile:		fix/add copyright and license refs.
	* macosx/tclMacOSXBundle.c:
	* macosx/Tcl-Info.plist.in:

	* unix/Makefile.in (dist): copy license.terms to dist macosx dir.
	* unix/configure.in: install license.terms into Tcl.framework.
	* unix/configure: autoconf-2.13

2007-04-21  Kevin B. Kenny  <kennyb@acm.org>

	* generic/tclClock.c:	     Restored Cygwin buildability [Bug 1387154]
	* generic/tclInt.decls:      Yet another round of attempting
	* generic/tclInt.h:          to get the correct type signature
	* unix/tclUnixPort.h:        for TclpLocaltime and TclpGmtime.
	* unix/tclUnixTime.c:        CONST TclpTime_t is a 'time_t *CONST'
	* win/tclWinTime.c:          and not a 'CONST time_t*' [Bug 1677275]
	* generic/tclIntDecls.h:
	* generic/tclIntPlatDecls.h: Regenerated.

2007-03-24  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* win/tclWinThrd.c: Thread exit handler marks the current
	thread as un-initialized. This allows exit handlers that
	are registered later to re-initialize this subsystem in
	case they need to use some sync primitives (cond variables)
	from this file again.

2007-03-19  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclEvent.c (Tcl_CreateThread):	Replaced some calls to
	* generic/tclPkg.c (CheckVersion):	Tcl_Alloc() with calls to
	* unix/tclUnixTime.c (SetTZIfNecessary):	ckalloc(), which better
	* win/tclAppInit.c (setargv):	supports memory debugging.

2007-03-17  Kevin Kenny  <kennykb@acm.org>

	* win/tclWinReg.c (GetKeyNames): Size the buffer for enumerating
	key names correctly, so that Unicode names exceeding 127 chars
	can be retrieved without crashing. [Bug 1682211]
	* tests/registry.test (registry-4.9): Added test case for the
	above bug.

2007-03-13  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclExecute.c (INST_FOREACH_STEP4):	Re-fetch pointers for
	* tests/foreach.test (foreach-10.1):	the value list each iteration
	of the loop as defense against shimmers.  [Bug 1671087]

	* generic/tclVar.c (TclArraySet):	Re-fetch pointers for the list
	* tests/var.test (var-17.1):	argument of [array set] each time
	through the loop as defense against possible shimmer issues.
	[Bug 1669489].

2007-03-10  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclCmdIL.c (Tcl_LsortObjCmd): Handle tricky case with loss
	* tests/cmdIL.test (cmdIL-1.29):of list rep during sorting due
	to shimmering. [Bug 1675116]

2007-03-07  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tclMacOSXNotify.c: add spinlock debugging and sanity checks.

	* unix/tcl.m4 (Darwin): s/CFLAGS/CPPFLAGS/ in macosx-version-min check.
	* unix/configure: autoconf-2.13

2007-03-01  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclCompCmds.c (TclCompileForeachCmd): Prevent an unexpected
	* tests/foreach.test (foreach-9.1):		infinite loop when the
	variable list is empty and the foreach is compiled. [Bug 1671138]

2007-02-22  Andreas Kupries  <andreask@activestate.com>

	* tests/pkg.test: Added tests for the case of an alpha package
	  satisfying a require for the regular package, demonstrating a
	  corner case specified in TIP#280. More notes in the comments to
	  the test.

2007-02-20  Don Porter  <dgp@users.sourceforge.net>

	* doc/tcltest.n:	Typo fix.  [Bug 1663539]

2007-02-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIOUtil.c (Tcl_FSEvalFile): safe incr of objPtr ref.

	* unix/tcl.m4: use SHLIB_SUFFIX=".so" on HP-UX ia64 arch.
	* unix/configure: autoconf-2.13

2007-02-12  Andreas Kupries  <andreask@activestate.com>

	* generic/tclEncoding.c (EscapeFromUtfProc): Applied patch
	  supplied by Mo DeJong to fix [Bug 1516109]. Backport from Tcl
	  8.5. Mo's description: Clear the TCL_ENCODING_END flag when end
	  bytes are written. This fix keep this method from writing escape
	  bytes for an encoding like iso2022-jp multiple times when the
	  escape byte overlap with the end of the IO buffer.
	* tests/io.test: Add test case for escape byte overlap case.

2007-02-04  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure.in: add caching to -pipe check.
	* unix/configure: autoconf-2.13

2007-01-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/Makefile.in (install-private-headers): added target

2007-01-29  Don Porter  <dgp@users.sourceforge.net>

	* doc/fcopy.n:	Typo fix. [Bug 1630627]

2007-01-25  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4:       integrate CPPFLAGS into CFLAGS as late as possible
	* unix/configure.in: and move (rather than duplicate) -isysroot flags
	from CFLAGS to CPPFLAGS to avoid errors about multiple -isysroot flags
	from some older gcc builds.

	* unix/configure: autoconf-2.13

2007-01-22  Andreas Kupries <andreask@activestate.com>

	* compat/memcmp.c (memcmp): Fixed the VOID / CONST typo introduced
	  by the last checkin.

2007-01-22  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* compat/memcmp.c (memcmp): Reworked so that arithmetic is never
	performed upon void pointers, since that is illegal. [Bug 1631017]

2006-01-19  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tclMacOSXNotify.c: accommodate changes to prototypes of
	OSSpinLock(Un)Lock API.

	* tests/env.test: add extra system env vars that need to be preserved
	on some Mac OS X versions for testsuite to work.

	* unix/tcl.m4: ensure CPPFLAGS env var is used when set. [Bug 1586861]
	(Darwin): add -isysroot and -mmacosx-version-min flags to CPPFLAGS when
	present in CFLAGS to avoid discrepancies between what headers configure
	sees during preprocessing tests and compiling tests.

	* unix/configure: autoconf-2.13

2006-12-19  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tclUnixThrd.c (TclpInetNtoa): fix for 64 bit.

	* unix/tcl.m4 (Darwin): --enable-64bit: verify linking with 64bit -arch
	flag succeeds before enabling 64bit build.
	* unix/configure: autoconf-2.13

2006-12-14  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/string.n: Fix example. [Bug 1615277]

2006-12-05  Andreas Kupries <andreask@activestate.com>

	* tests/pkg.test:   Backport to 8.4 (Don Porter's work):
	* generic/tclPkg.c: When no requirements are supplied to a [package
	require $pkg] and [package unknown] is invoked to find a satisfying
	package, pass the requirement argument "0-" (which means all versions
	are acceptable). This permits a registered [package unknown] command
	to call [package vsatisfies $testVersion {*}$args] without any special
	handling of the empty $args case. This fixes/avoids a bug in
	[::tcl::tm::UnknownHandler] that was causing old TM versions to be
	provided in preference to newer TM versions. Thanks to Julian Noble
	for discovering the issue.

2006-12-04  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/file.n: Fix confusing wording for [file pathtype]. [Bug 1606454]

2006-11-28  Andreas Kupries  <andreask@activestate.com>

	* generic/tclBasic.c: TIP #280 implementation, conditional on the
	* generic/tclCmdAH.c: define TCL_TIP280.
	* generic/tclCmdIL.c:
	* generic/tclCmdMZ.c:
	* generic/tclCompCmds.c:
	* generic/tclCompExpr.c:
	* generic/tclCompile.c:
	* generic/tclCompile.h:
	* generic/tclExecute.c:
	* generic/tclIOUtil.c:
	* generic/tclInt.h:
	* generic/tclInterp.c:
	* generic/tclNamesp.c:
	* generic/tclObj.c:
	* generic/tclProc.c:
	* tests/compile.test:
	* tests/info.test:
	* tests/platform.test:
	* tests/safe.test:

2006-11-27  Kevin Kenny  <kennykb@acm.org>

	* unix/tclUnixChan.c (TclUnixWaitForFile):
	* tests/event.test (event-14.*): Corrected a bug where
	TclUnixWaitForFile would present select() with the wrong mask on an
	LP64 machine if a fd number exceeds 32. Thanks to Jean-Luc Fontaine
	for reporting and diagnosing [Bug 1602208]

2006-11-26  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Linux): --enable-64bit support.	[Patch 1597389]
	* unix/configure: autoconf-2.13			[Bug 1230558]

2006-11-07  Andreas Kupries  <andreask@activestate.com>

	* unix/tclUnixFCmd.c (CopyFile): Added code to fall back to a
	hardwired default block size should the filesystem report a bogus
	value. [Bug 1586470]

2006-11-03  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclBasic.c (TEOVI): fix for possible leak of a Command in
	the presence of execution traces that delete it.

	* generic/tclBasic.c (TEOVI):
	* tests/trace.test (trace-21.11): fix for [Bug 1590232], execution
	traces may cause a second command resolution in the wrong
	namespace.

2006-11-01  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tclEnv.c (Darwin): mark _environ symbol as unexported.

2006-10-31  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* rules.vc: Fix [Bug 1582769] build with VC2003 and correct i386 arch

2006-10-23  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.4.15
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

2006-10-18  Pat Thoyts  <patthoyts@users.sourceforge.net>

	*** 8.4.14 TAGGED FOR RELEASE ***

	* win/nmakehlp.c: Ensure builds with VC6 without Platform SDK.
	* win/rules.vc:	  Pickup MACHINE from environment.

2006-10-17  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclIOUtil.c:	Cleaned up some code flagged by a
	* generic/tclInt.h:	`make checkexports` test.
	* win/tclWin32Dll.c:
	* win/tclWinFile.c:

2006-10-16  Daniel Steffen  <das@users.sourceforge.net>

	* changes: updates for 8.4.14 release.

	* macosx/Makefile: don't redo prebinding of non-prebound binaires.

2006-10-11  Andreas Kupries  <andreask@activestate.com>

	* generic/tclPkg.c (Tcl_PkgRequireEx): Corrected crash when argument
	version==NULL passed in. Backport of the fix for the same problem in
	8.5.

2006-10-10  Don Porter  <dgp@users.sourceforge.net>

	* changes:		changes updated for 8.4.14 release.

2006-10-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/http.test: update tests to handle strictness change.

2006-10-06  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/rules.vc: avoid /RTCc flag with MSVC8. [Bug 1571954]

2006-10-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/http/http.tcl (http::geturl): only do geturl url rfc 3986
	validity checking if $::http::strict is true (default false for 8.4).
	[Bug 1560506]

	* generic/tcl.h: note limitation on changing Tcl_UniChar size
	* generic/tclEncoding.c (UtfToUnicodeProc, UnicodeToUtfProc):
	* tests/encoding.test (encoding-16.1): fix alignment issues in
	unicode <> utf conversion procs. [Bug 1122671]

2006-10-05  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclVar.c (Tcl_LappendObjCmd):
	* tests/append.test(4.21-22): fix for longstanding [Bug 1570718],
	lappending nothing to non-list. Reported by lvirden

2006-10-02  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclFileName.c (TclGlob):	Prevent doubling of directory
	separators by [glob]. [Bug 1569042]

2006-10-01  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tclWinFile.c: Handle possible missing define.
	* win/tclWinFile.c: Backported fix for [Bug 1420432] (cannot set
	* tests/cmdAH.test: mtime for directories on windows).

2006-09-30  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclUtil.c (Tcl_SplitList): optimisation, [Patch 1344747]
	by dgp.

2006-09-26  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc:  Updated MSVC build to properly deal with
	* win/nmakehlp.c:   MSVC8 and AMD64 target. Backport from 8.5
	* win/rules.vc:
	* generic/tcl.h:    Fixed stat definition for MSVC8 AMD64.
	* win/tclWinSock.c: Casting type police.
	* win/tclWinTime.c:

2006-09-26  Don Porter  <dgp@users.sourceforge.net>

	* generic/tcl.h:	As 2006-09-22 commit from Donal K. Fellows
	demonstrates, "#define NULL 0" is just wrong, and as a quotable chat
	figure observed, "If NULL isn't defined, we're not using a C compiler."
	Improper fallback definition of NULL removed.

2006-09-25  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c (Tcl_StackChannel): Fixed [SF Tcl Bug 1564642], aka
	coverity #51. Extended loop condition, added checking for NULL to
	prevent seg.fault.

2006-09-25  Andreas Kupries <andreask@activestate.com>

	* generic/tclBasic.c: Reverted exposure of patchlevel in registered
	core version when TIP#268 features are activated. Better compatibility
	with existing packages. Like Tk.

2006-09-24  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclParse.c (Tcl_ParseCommand): also return an error if
	start==NULL and numBytes<0. This is coverity's bug #20

	* generic/tclStringObj.c (STRING_SIZE): fix allocation for 0-length
	strings. This is coverity's bugs #54-5

2006-09-22  Andreas Kupries  <andreask@activestate.com>

	* generic/tclInt.h: Moved TIP#268's field 'packagePrefer' to the end
	of the structure, for better backward compatibility.

2006-09-22  Andreas Kupries <andreask@activestate.com>

	* generic/tclPkg.c (Tcl_PkgRequireEx): Changes handling of the return
	information from 'Tcl_PkgRequireProc'. Keep the interpreter result
	empty. Backport of fix for problem found while testing #268 under 8.5.
	More details in the comments.

2006-09-22  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclThreadTest.c (TclCreateThread): Use NULL instead of 0 as
	end-of-strings marker to Tcl_AppendResult; the difference matters on
	64-bit machines. [Bug 1562528]

2006-09-21  Andreas Kupries <andreask@activestate.com>

	* generic/tcl.decls:  Implemented TIP #268, conditionally.
	* generic/tclBasic.c: Define TCL_TIP268 to activate the new
	* generic/tclDecls.h: features.
	* generic/tclInt.h:
	* generic/tclPkg.c:
	* generic/tclStubInit.c:
	* generic/tclTest.c:
	* library/init.tcl
	* library/package.tcl:
	* tests/pkg.test:
	* tests/platform.test:
	* tests/safe.test:
	* doc/PkgRequire.3:

2006-09-15  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/http/http.tcl:      Change " " -> "+" url encoding mapping
	* library/http/pkgIndex.tcl:  to " " -> "%20" as per RFC 3986.
	* tests/http.test (http-5.1): bump http to 2.5.3 for 8.4.14

2006-09-12  Andreas Kupries  <andreask@activestate.com>

	* unix/configure.in (HAVE_MTSAFE_GETHOST*): Modified to recognize
	HP-UX 11.00 and beyond as having mt-safe implementations of the
	gethost functions.
	* unix/configure: Regenerated, using autoconf 2.13

	* unix/tclUnixCompat.c (PadBuffer): Fixed bug in calculation of the
	increment needed to align the pointer, and added documentation
	explaining why the macro is implemented as it is.

2006-09-11  Andreas Kupries  <andreask@activestate.com>

	* tests/msgcat.test: Bumped version in auxiliary files as well.
	* doc/msgcat.n:

2006-09-11  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tclUnixCompat.c: make compatLock static and only declare it
	when it will actually be used; #ifdef parts of TSD that are not always
	needed; adjust #ifdefs to cover all possible cases; fix whitespace.

2006-09-10  Don Porter  <dgp@users.sourceforge.net>

	* library/msgcat/msgcat.tcl:	Bump to version msgcat 1.3.4 to account
	* library/msgcat/pkgIndex.tcl:	for modifications.

2006-09-10  Daniel Steffen  <das@users.sourceforge.net>

	* library/msgcat/msgcat.tcl (msgcat::Init): on Darwin, add fallback of
	* tests/msgcat.test:			    default msgcat locale to
	* unix/tclUnixInit.c (TclpSetVariables):    current CFLocale
	identifier if available (via private ::tcl::mac::locale global, set at
	interp init when on Mac OS X 10.3 or later with CoreFoundation).

	* unix/tcl.m4: add caching to new SC_TCL_* macros for MT-safe wrappers
	* unix/configure: autoconf-2.13

2006-09-08  Andreas Kupries  <andreask@activestate.com>

	* unix/tclUnixCompat.c: Fixed conditions for CopyArray/CopyString, and
	CopyHostent. Also fixed bad var names in TclpGetHostByName.

2006-09-08  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* unix/tclUnixCompat.c: Added fallback to gethostbyname() and
	gethostbyaddr() if the implementation is known to be MT-safe
	(currently for Darwin 6 or later only).

	* unix/configure.in: Assume gethostbyname() and gethostbyaddr() are
	MT-safe starting with Darwin 6 (Mac OSX 10.2).

	* unix/configure: Regenerated with autoconf V2.13

2006-09-07  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* unix/tclUnixFCmd.c: Removed some false tests added (and left by
	mistake) by fixing [Bug 999544]

	* unix/tclUnixCompat.c: Added fallback to MT-unsafe library calls if
	TCL_THREADS is not defined. Fixed alignment of arrays copied by
	CopyArrayi() to be on the sizeof(char *) boundary.

2006-09-07  Andreas Kupries <andreask@activestate.com>

	* unix/configure: Regenerated using autoconf 2.13.

2006-09-07  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* unix/tclUnixChan.c   Rewritten MT-safe wrappers to
	* unix/tclUnixCompat.c return ptrs to TSD storage
	* unix/tclUnixFCmd.c   making them all look like their
	* unix/tclUnixPort.h   MT-unsafe pendants API-wise.
	* unix/tclUnixSock.c

2006-09-06  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* unix/tclUnixChan.c: Added TCL_THREADS ifdef'ed  usage
	* unix/tclUnixFCmd.c: of MT-safe calls like:
	* unix/tclUnixSock.c: getpwuid, getpwnam, getgrgid, getgrnam,
	* unix/tclUnixPort.h: gethostbyname and gethostbyaddr.
	* unix/Makefile.in:   See Tcl Bug: 999544
	* unix/configure.in:
	* unix/tcl.m4:
	* unix/configure: Regenerated.

	* unix/tclUnixCompat.c: New file containing MT-safe implementation of
	some library calls.

2006-09-04  Don Porter  <dgp@users.sourceforge.net>

	* tests/main.text (Tcl_Main-4.4):	Test corrected to not be
	timing sensitive to the Bug 1481986 fix. [Bug 1550858]

2006-09-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/package.n: correct package example

2006-08-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinChan.c: [Bug 819667] Improve logic for identifying COM
	ports.

	* win/tclWinFCmd.c:    [Bug 1548263] Added test for NULL return
	* generic/tclIOUtil.c: from Tcl_FSGetNormalizedPath which was
	causing segv's

	* generic/tclFileName.c (TclDoGlob): match incr with existing decr.

	* unix/Makefile.in: add valgrindshell target and update default
	VALGRINDARGS. User can override, or add to it with VALGRIND_OPTS env
	var.

	* generic/tclBasic.c (Tcl_CreateInterp): init iPtr->threadId

	* generic/tclIOGT.c (ExecuteCallback):
	* generic/tclPkg.c (Tcl_PkgRequireEx): replace Tcl_GlobalEval(Obj)
	with more efficient Tcl_Eval(Obj)Ex

2006-08-22  Andreas Kupries <andreask@activestate.com>

	* unix/tclUnixNotfy.c (Tcl_WaitForEvent): Fixed broken if syntax
	committed 2006-08-21 by Daniel. The broken syntax is visible to all
	unix platforms, but not on OSX for machines which HAVE_COREFOUNDATION.

2006-08-21  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclIOUtil.c:	Revisions to complete the thread finalization
	of the cwdPathPtr. [Bug 1536142]

2006-08-21  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tclMacOSXNotify.c (Tcl_WaitForEvent): if the run loop is
	already running (e.g. if Tcl_WaitForEvent was called recursively),
	re-run it in a custom run loop mode containing only the source for the
	notifier thread, otherwise wakeups from other sources added to the
	common run loop modes might get lost; sync panic msg changes from
	HEAD.

	* unix/tclUnixNotfy.c (Tcl_WaitForEvent): on 64-bit Darwin,
	pthread_cond_timedwait() appears to have a bug that causes it to wait
	forever when passed an absolute time which has already been exceeded
	by the system time; as a workaround, when given a very brief timeout,
	just do a poll on that platform. [Bug 1457797]

	* unix/tclUnixPort.h (Darwin): override potentially faulty configure
	detection of termios availability in all cases, since termios is known
	to be present on all Mac OS X releases since 10.0. [Bug 497147]

2006-08-18  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): add support for --enable-64bit on x86_64, for
	universal builds including x86_64, for 64-bit CoreFoundation on
	Leopard and for use of -mmacosx-version-min instead of
	MACOSX_DEPLOYMENT_TARGET.
	* unix/configure: autoconf-2.13

	* generic/tcl.h:      add fixes for building on Leopard and support
	* unix/tclUnixPort.h: for 64-bit CoreFoundation on Leopard.

	* unix/tclUnixPort.h: on Darwin x86_64, disable use of vfork as it
	causes execve to fail intermittently. (rdar://4685553)

	* macosx/README: updates for x86_64 support and Xcode 2.4.

	* unix/tclUnixChan.c (TclUnixWaitForFile): with timeout < 0, if
	select() returns early (e.g. due to a signal), call it again instead
	of returning a timeout result. Fixes intermittent event-13.8 failures.

2006-08-09  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclEncoding.c:	Replace buffer copy in for loop with
	call to memcpy(). Thanks to afredd. [Patch 1530262]

2006-08-03  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tclUnixPipe.c (TclpCreateProcess): for USE_VFORK: ensure
	standard channels are initialized before vfork() so that the child
	doesn't potentially corrupt global state in the parent's address
	space.

2006-07-30  Kevin Kenny  <kennykb@acm.org>

	* tests/clock.test: Allowed UTC as a synonym for GMT in two tests that
	indirectly invoke 'strftime' with the result of 'gmtime' to fix a
	bogus test failure on FreeBSD systems. [Bug 1513489]

2006-07-30  Joe English  <jenglish@users.sourceforge.net>

	* doc/AppInit.3: Fix typo [Bug 1496886]

2006-07-20  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tclMacOSXNotify.c (Tcl_InitNotifier, Tcl_WaitForEvent):
	create notifier thread lazily upon first call to Tcl_WaitForEvent()
	rather than in Tcl_InitNotifier(). Allows calling exeve() in processes
	where the event loop has not yet been run (Darwin's execve() fails in
	processes with more than one thread), in particular allows embedders
	to call fork() followed by execve(), previously the pthread_atfork()
	child handler's call to Tcl_InitNotifier() would immediately recreate
	the notifier thread in the child after a fork.

	* macosx/tclMacOSXNotify.c (Tcl_InitNotifier):	   add support for
	* unix/tclUnixFCmd.c (DoRenameFile, CopyFileAtts): weakly importing
	* unix/tclUnixInit.c (TclpSetInitialEncodings):	   symbols not
	available on OSX 10.2 or 10.3, enables binaires built on later OSX
	versions to run on earlier ones.
	* macosx/README: document how to enable weak-linking; cleanup.
	* unix/tclUnixPort.h: add support for weak-linking; conditionalize
	AvailabilityMacros.h inclusion; only disable realpath on 10.2 or
	earlier when threads are enabled.
	* unix/tclLoadDyld.c (TclpLoadMemoryGetBuffer): change runtime Darwin
	* unix/tclUnixInit.c (TclpInitPlatform):	release check to use
						       global initialized once
	* unix/tclUnixFCmd.c (DoRenameFile, TclpObjNormalizePath): add runtime
	Darwin release check to determine if realpath is threadsafe.
	* unix/configure.in: add check on Darwin for compiler support of weak
	* unix/tcl.m4:	     import and for AvailabilityMacros.h header; move
	Darwin specific checks & defines that are only relevant to the tcl
	build out of tcl.m4; restrict framework option to Darwin; cleanup
	quoting.
	* unix/configure: autoconf-2.13

	* unix/tclLoadDyld.c (TclpLoadMemory):
	* unix/tclUnixPipe.c (TclpCreateProcess): fix signed-with-unsigned
	comparison and other warnings from gcc4 -Wextra.

2006-07-13  Andreas Kupries <andreask@activestate.com>

	* unix/tclUnixPort.h: Added the inclusion of <AvailabilityMacros.h>.
	The missing header caused the upcoming #if conditions to wrongly
	exclude realpath, causing file normalize to ignore symbolic links in
	the path.

2006-07-11  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclAsync.c: Made Tcl_AsyncDelete() more tolerant when called
	after all thread TSD has been garbage-collected.

2006-07-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIO.c (Tcl_CreateChannel): allow Tcl std channel
	inheritance to be #defined out (default remains in).

2006-06-15  Don Porter  <dgp@users.sourceforge.net>

	* changes:		changes to start prep for an 8.4.14 release.

2006-06-14  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tclUnixPort.h (Darwin): support for MAC_OS_X_VERSION_MAX_ALLOWED
	define from AvailabilityMacros.h: override configure detection and only
	use API available in the indicated OS version or earlier.

2006-06-14  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/regerror.c:	Enable building Tcl with Microsoft's latest
	* generic/tcl.h:	compiler offering (VS2005). We have to handle
	* generic/tclDate.c:	a number of oddities as they have deprecated
	* tests/env.test:	most of the standard C library and now
	* win/makefile.vc:	generate manifest files to be linked into the
	* win/nmakehlp.c:	binaries. [Bug 1424909]
	* win/rules.vc:
	* win/tclWinTime.c:

2006-06-13  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tclLoadDl.c (TclpDlopen): Workaround for a compiler bug in Sun
	Forte 6. [Bug 1503729]

2006-06-06  Don Porter  <dgp@users.sourceforge.net>

	* doc/GetStdChan.3:	Added recommendation that each call to
	Tcl_SetStdChannel() be accompanied by a call to Tcl_RegisterChannel().

2006-05-31  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclNamesp.c (NamespaceInscopeCmd): revert [Bug 1400572]
	fix of 2006-01-09 for [namespace inscope] as it seems to mess with
	itcl scope decoding. Leaving namespace-29.6 test failure until final
	cause it determined.

2006-05-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tcl.h (Tcl_DecrRefCount): use if/else construct to allow
	placement in unbraced outer if/else conditions. (jcw)

2006-05-27  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tclMacOSXNotify.c: implemented pthread_atfork() handler that
	* unix/tcl.m4 (Darwin):	    recreates CoreFoundation state and notifier
	thread in the child after a fork(). Note that pthread_atfork() is
	available starting with Tiger only. Because vfork() is used by the core
	on Darwin, [exec]/[open] are not affected by this fix, only extensions
	or embedders that call fork() directly (such as TclX). However, this
	only makes fork() safe from corefoundation tcl with --disable-threads;
	as on all platforms, forked children may deadlock in threaded tcl due
	to the potential for stale locked mutexes in the child. [Patch 923072]
	* unix/configure: autoconf-2.59

2006-05-24  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* unix/tcl.m4 (SC_CONFIG_SYSTEM): Fixed quoting of command script to
	awk; it was a rarely used branch, but it was wrong. [Bug 1494160]

2006-05-13  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclFileName.c (TclDoGlob):	Disabled the partial
	normalization done by the recursive glob routine, since changing the
	precise string of the pathname broke [glob] on some Tcl_Filesystems.
	[Bug 943995]

	* generic/tclProc.c (ProcCompileProc):	When a bump of the compile
	epoch forces the re-compile of a proc body, take care not to
	overwrite any Proc struct that may be referred to on the active
	call stack. This fixes [Bug 1482718]. Note that the fix will not be
	effective for code that calls the private routine TclProcCompileProc()
	directly.

2006-05-05  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclMain.c (Tcl_Main):		Corrected flaw that required
	* tests/main.test: (Tcl_Main-4.5):	processing of one interactive
	command before passing control to the loop routine registered with
	Tcl_SetMainLoop() [Bug 1481986]

2006-05-04  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.4.14
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

	* generic/tclExecute.c (ExprSrandFunc):	Restore acceptance of wide
	* tests/expr-old.test: integer values by srand() [Bug 1480509]

2006-04-12  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.13 TAGGED FOR RELEASE ***

	* changes:	updates for another RC.

2006-04-11  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c:	Stop some interference between enter traces
	* tests/trace.test:	and enterstep traces. [Bug 1458266]

2006-04-10  Don Porter  <dgp@users.sourceforge.net>

	* changes:	updates for another RC.

2006-04-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclRegexp.c (FinalizeRegexp): full reset data to indicate
	readiness for reinitialization.

2006-04-06  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclIndexObj.c (Tcl_GetIndexFromObjStruct):	It seems there
	* tests/indexObj.test:	are extensions that rely on the prior behavior
	* doc/GetIndex.3:	that the empty string cannot succeed as a
	unique prefix matcher, so I'm restoring Donal Fellows's solution.
	Added mention of this detail to the documentation. [Bug 1464039]

2006-04-06  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4: removed TCL_IO_TRACK_OS_FOR_DRIVER_WITH_BAD_BLOCKING
	define on Darwin. [Bug 1457515]
	* unix/configure: autoconf-2.13

2006-04-05  Don Porter  <dgp@users.sourceforge.net>

	* library/reg/pkgIndex.tcl:	Long overlooked bump to registry
	* win/tclWinReg.c:		package version 1.1.4 (should have
	been done for the Tcl 8.4.8 release!)

	* library/dde/pkgIndex.tcl:	Long overlooked bump to dde package
	* win/tclWinDde.c:		version 1.2.4 (should have been done
	for the Tcl 8.4.8 release!)

2006-04-05  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclIndexObj.c (Tcl_GetIndexFromObjStruct): Allow empty
	strings to be matched by the Tcl_GetIndexFromObj machinery, in the
	same manner as any other key. [Bug 1464039]

2006-04-04  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclPkg.c:	Revised Bug 1162286 fix from 2005-11-08 to be
	* tests/pkg.test:	even more forgiving of package version
	mismatch errors in [package ifneeded] commands, not even logging any
	warning messages. This further reduces the
	***POTENTIAL INCOMPATIBILITY*** noted for that change.

2006-04-03  Andreas Kupries <andreask@activestate.com>

	* generic/tclIO.c (ReadChars): Added check, panic and commentary to a
	piece of code which relies on BUFFER_PADDING to create enough space at
	the beginning of each buffer for the insertion of partial multibyte
	data at the beginning of a buffer. Commentary explains why this code
	is OK, and the panic is as a precaution if someone twiddled the
	BUFFER_PADDING into uselessness.

	* generic/tclIO.c (ReadChars): Temporarily suppress the use of
	TCL_ENCODING_END set when EOF was reached while the buffer we are
	converting is not truly the last buffer in the queue. Together with
	the Utf bug below it was possible to completely wreck the buffer data
	structures, eventually crashing Tcl. [Bug 1462248]

	* generic/tclEncoding.c (UtfToUtfProc): Stop accessing memory beyond
	the end of the input buffer when TCL_ENCODING_END is set and the last
	bytes of the buffer start a multi-byte sequence. This bug contributed
	to [Bug 1462248].

2006-03-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/configure, win/tcl.m4: define MACHINE for gcc builds as well.
	Needed by Tk for manifest generation.

	* win/tclWinConsole.c: revert 2005-11-03 [Patch 1256872] change to add
	win32 unicode console support as it broke the ability to modify the
	encoding to the console.

2006-03-28  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tclUnixFCmd.c (TclpObjNormalizePath): deal with *BSD/Darwin
	realpath() converting relative paths into absolute paths. [Bug 1064247]

2006-03-28  Vince Darley  <vincentdarley@sourceforge.net>

	* generic/tclIOUtil.c: fix to nativeFilesystemRecord comparisons
	(lesser part of [Bug 1064247])

2006-03-27  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tclWinTest.c:	Fixes for [Bug 1456373] (mingw-gcc issue)

2006-03-23  Don Porter  <dgp@users.sourceforge.net>

	* tests/expr.test:	Nan self-inquality test silenced. [Bug 761471]

2006-03-22  Don Porter  <dgp@users.sourceforge.net>

	* changes:	updates for another RC.

2006-03-18  Vince Darley  <vincentdarley@sourceforge.net>

	* generic/tclTest.c:
	* win/tclWinFile.c:
	* win/tclWinTest.c:
	* tests/fCmd.test:
	* tests/winFCmd.test:
	* tests/tcltest.test: Backport of [file writable] fixes for Windows
	from HEAD. [Bug 1193497]

2006-03-16  Andreas Kupries <andreask@activestate.com>

	* doc/open.n: Documented the changed behaviour of 'a'ppend mode.

	* tests/io.test (io-43.1 io-44.[1234]): Rewritten to be
	self-contained with regard to setup and cleanup. [Bug 681793]

	* generic/tclIOUtil.c (TclGetOpenMode): Added the flag O_APPEND to the
	list of POSIX modes used when opening a file for 'a'ppend. This
	enables the proper automatic seek-to-end-on-write by the OS. See [Bug
	680143] for longer discussion.

	* tests/ioCmd.test (iocmd-13.7.*): Extended the testsuite to check the
	new handling of 'a'.

2006-03-15  Andreas Kupries <andreask@activestate.com>

	* tests/socket.test: Extended the timeout in socket-11.11 from 10 to
	40 seconds to allow for really slow machines. Also extended
	actual/expected results with value of variable 'done' to make it
	clearer when a test fails due to a timeout. [Bug 792159]

2006-03-14  Andreas Kupries <andreask@activestate.com>

	* generic/tclPipe.c (TclCreatePipeline): Modified the processing of
	pipebars to fail if the last bar is followed only by redirections.
	[Bug 768659]

2006-03-14  Andreas Kupries <andreask@activestate.com>

	* doc/fconfigure.n: Clarified that -translation is binary is reported
	as lf when queried, because it is identical to lf, except for the
	special additional behaviour when setting it. [Bug 666770]

2006-03-14  Andreas Kupries <andreask@activestate.com>

	* win/tclWinPipe.c (Tcl_WaitPid): Backport of fix made to the head by
	David Gravereaux in 2004. See ChangeLog entry 2004-01-19. [Bug 1381436]

	Fixed a thread-safety problem with the process list. The delayed cut
	operation after the wait was going stale by being outside the list
	lock. It now cuts within the lock and does a locked splice for when it
	needs to instead. [Bug 859820]

2006-03-13  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclEncoding.c:	Report error when an escape encoding
	is missing one of its sub-encodings [Bug 506653]

	* unix/configure.in:	Revert change from 2005-07-26 that sometimes
	* unix/configure:	added $prefix/share to the tcl_pkgPath.
	See [Patch 1231015]. autoconf-2.13.

2006-03-10  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	-- Summary of changes fixing [Bug 1437595] --

	* generic/tclEvent.c: Cosmetic touches and identation
	* generic/tclInt.h: Added TclpFinalizeSockets() call.

	* generic/tclIO.c: Calls TclpFinalizeSockets() as part of the
	TclFinalizeIOSubsystem().

	* unix/tclUnixSock: Added no-op TclpFinalizeSockets().

	* mac/tclMacSock.c:
	* win/tclWinPipe.c
	* win/tclWinSock.c: Finalization of the sockets/pipes is now solely
	done in TclpFinalizeSockets() and TclpFinalizePipes() and not over the
	thread-exit handler, because the order of actions the Tcl generic core
	will impose may result in cores/hangs if the thread exit handler tears
	down corresponding subsystem(s) too early.

2006-03-10  Vince Darley  <vincentdarley@sourceforge.net>

	* win/tclWin32Dll.c:
	* win/tclWinInt.h:
	* win/tclWinFile.c: backported some fixes from HEAD relating to 'file
	readable' and 'file writable', but main 'file writable' bug still
	outstanding.

2006-03-07  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.4.13 and update
	* changes:		changes to start prep for an 8.4.13 release.
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure{.in}:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure{.in}:

	* tests/parse.test:	Missing constraint

2006-03-06  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclBasic.c:	Revised handling of TCL_EVAL_* flags to
	* tests/parse.test:	simplify TclEvalObjvInternal and to correct
	the auto-loading of alias targets (parse-8.12).	[Bug 1444291]

2006-03-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/Makefile.in: convert _NATIVE paths to use / to avoid ".\"
	path-as-escape issue.

	* unix/tcl.m4, win/tcl.m4: []-quote ac_defun functions.

2006-03-02  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* unix/tcl.m4:	  Fix for [Tk Bug 1334613] to sort out shared library
	* unix/configure: issues on NetBSD. Regenerated configure script.

2006-02-28  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclBasic.c:	Corrections to be sure that TCL_EVAL_GLOBAL
	* tests/parse.test:	evaluations act the same as [uplevel #0]
	* tests/trace.test:	evaluations, even when execution traces or
	invocations of [::unknown] are present. [Bug 1439836]

2006-02-16  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclIndexObj.c:	Disallow the "ambiguous" error message
	* tests/indexObj.test:		when TCL_EXACT matching is requested.

2006-02-15  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclIO.c:	Made several routines tolerant of
	* generic/tclIOUtil.c:	interp == NULL arguments. [Bug 1380662]

2006-02-09  Don Porter  <dgp@users.sourceforge.net>

	* tests/main.test (Tcl_Main-6.7):	Improved robustness of command
	auto-completion test. [Bug 1422736]

2006-01-25  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tclUnixInit.c (TclpInitPlatform): Improved conditions on when
	to update the FP rounding mode on FreeBSD, taken from FreeBSD port.

2006-01-23  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclStringObj.c (Tcl_GetRange):
	* tests/stringTest (string-12.21):fixed incorrect handling of internal
	rep in Tcl_GetRange. Thanks to twylite and Peter Spjuth. [Bug 1410553]

2006-01-16  Reinhard Max  <max@suse.de>

	* generic/tclPipe.c (FileForRedirect): Prevent nameString from being
	freed without having been initialized.
	* tests/exec.test: Added a test for the above.

2006-01-12  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclIOUtil.c (Tcl_FSGetInternalRep): fixed potential
	overwriting of already freed memory which caused all kinds of (rare
	but reproducible) coredumps all over the place.

2006-01-11  Don Porter  <dgp@users.sourceforge.net>

	* tests/error.test (error-7.0):	Test the timing of write traces on
	::errorInfo. [Bug 1397843]

2006-01-10  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure:    add caching, use AC_CACHE_CHECK instead of
	* unix/configure.in: AC_CACHE_VAL where possible, consistent message
	* unix/tcl.m4:	     quoting, sync relevant tclconfig/tcl.m4 and HEAD
	changes and gratuitous formatting differences, fix SC_CONFIG_MANPAGES
	with default argument, Darwin improvements to SC_LOAD_*CONFIG.

2006-01-09  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclNamesp.c (NamespaceInscopeCmd):	[namespace inscope]
	* tests/namespace.test:	commands were not reported by [info level].
	[Bug 1400572]

2005-12-20  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclThreadAlloc.c (Tcl_GetMemoryInfo): Format values as longs
	and not ints, so they are less likely to wrap on 64-bit machines.

2005-12-19  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/Tcl.n: Clarify what is going on in variable substitution
	following thread on comp.lang.tcl.

2005-12-14  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tclIOUtil.c: workaround gcc warning "comparison is always
	* generic/tclTest.c:   false due to limited range of data type".

	* unix/configure.in: run check for fts API on all platforms, since
	Linux glibc2 and *BSDs also have this and using fts is more efficient
	than recursive opendir/readdir (sync with HEAD).
	* unix/configure: regen.

2005-12-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4, unix/configure: Fix sh quoting error reported in
	bash-3.1+ [Bug 1377619] (schafer)

2005-12-12  Reinhard Max  <max@suse.de>

	* generic/tclExecute.c (ExprAbsFunc): fixed the abs(MIN_INT) case so
	that it doesn't break on compilers that don't assume integers to wrap
	around (e.g. gcc-4.1.0).

2005-12-09  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* tests/lsearch.test (lsearch-10.8..10): If the -start is off the end,
	* generic/tclCmdIL.c (Tcl_LsearchObjCmd): searching should find
	nothing at all. [Bug 1374778]

2005-12-05  Daniel Steffen  <das@users.sourceforge.net>

	*** 8.4.12 TAGGED FOR RELEASE ***

	* unix/tclUnixPort.h (Darwin): fix incorrect __DARWIN_UNIX03 configure
	overrides that were originally copied from Darwin CVS (rdar://3693001).

2005-12-05  Don Porter  <dgp@users.sourceforge.net>

	* unix/configure.in:	Revised fix for [Bug 1034337] from Daniel
	* unix/tclUnixFCmd.c:	Steffen. Uses fts_*() routines.
	* unix/configure:	autoconf-2.13
	* changes:		Update changes for 8.4.12 release

2005-12-04  Daniel Steffen  <das@users.sourceforge.net>

	* README: refer to macosx/README instead of mac/README.
	* mac/README: add note that mac classic port is no longer supported.

2005-12-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* README: correct 2 urls

2005-12-01  Don Porter  <dgp@users.sourceforge.net>

	* changes:		Update changes for 8.4.12 release

2005-12-01  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): fixed error when MACOSX_DEPLOYMENT_TARGET unset
	* unix/configure: regen.

2005-11-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tcl.m4:	   Add build support for Windows-x64 builds.
	* win/configure:   --enable-64bit now accepts =amd64|ia64 for
	* win/Makefile.in: Windows 64-bit build variants (default: amd64)
	* win/makefile.vc: [Bug 1369597]

2005-11-29  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclObj.c (Tcl_GetWideIntFromObj): Add more efficient
	conversion to wides from normal ints. [Bug 1310081]

	* generic/tclCmdIL.c (Tcl_LsearchObjCmd): Allow [lsearch -regexp] to
	process REs that contain backreferences. This expensive mode of
	operation is only used if the RE would otherwise cause a compilation
	failure. [Bug 1366683]

2005-11-28  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* win/tclWinSock.c (CreateSocket): Applied [Patch 1353853] to prevent
	reads of uninitialized variables during cleanup.

2005-11-27  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): add 64bit support, check for Tiger copyfile(),
	add CFLAGS to SHLIB_LD to support passing -isysroot in env(CFLAGS) to
	configure (flag can't be present twice, so can't be in both CFLAGS and
	LDFLAGS during configure), don't use -prebind when deploying on 10.4,
	define TCL_IO_TRACK_OS_FOR_DRIVER_WITH_BAD_BLOCKING (rdar://3171542).
	(SC_ENABLE_LANGINFO, SC_TIME_HANDLER): add/fix caching, fix obsolete
	autoconf macros. Sync with tk/unix/tcl.m4, sync whitespace with HEAD.

	* unix/configure.in: fix obsolete autoconf macros, sync gratuitous
	formatting/ordering differences with tk/unix/configure.in.

	* unix/Makefile.in: add CFLAGS to tclsh/tcltest link to make
	executable linking the same as during configure (needed to avoid
	loosing any linker relevant flags in CFLAGS, in particular flags that
	can't be in LDFLAGS). Avoid concurrent linking of tclsh and compiling
	of tclTestInit.o or xtTestInit.o during parallel make.
	(checkstubs, checkdoc, checkexports): dependency and Darwin fixes

	* unix/tclLoadDyld.c (TclpDlopen): [Bug 1204237] use
	NSADDIMAGE_OPTION_WITH_SEARCHING on second NSAddImage only.
	(TclGuessPackageName): should not be MODULE_SCOPE.
	(TclpLoadMemory): ppc64 and endian (i386) fixes, add support for
	loading universal (fat) bundles from memory.

	* unix/tclUnixPort.h:
	* unix/tclUnixFCmd.c: add support for new Tiger copyfile() API to
	enable copying of xattrs & ACLs by [file copy].

	* generic/tcl.h: add Darwin specifc configure overrides for TCL_WIDE
	defines to support fat compiles of ppc and ppc64 at the same time,
	(replaces Darwin CVS fix by emoy, rdar://3693001).
	add/correct location of version numbers in macosx files.

	* generic/tclInt.h: clarify fat compile comment.

	* unix/tclUnixPort.h: add Darwin specifc configure overrides to
	support fat compiles, where configure runs only once for multiple
	architectures (replaces Darwin CVS fix by emoy, rdar://3693001).

	* macosx/tclMacOSXBundle.c:
	* macosx/tclMacOSXNotify.c:
	* unix/tclUnixNotfy.c: fix #include order to support compile time
	* unix/tclUnixPort.h:  override of HAVE_COREFOUNDATION in
	tclUnixPort.h when building for ppc64

	* macosx/Tcl.pbproj/default.pbxuser (new file):
	* macosx/Tcl.pbproj/jingham.pbxuser:
	* macosx/Tcl.pbproj/project.pbxproj: sync with HEAD.

	* macosx/README: clarification/cleanup, sync with HEAD, document
	universal (fat) builds via CFLAGS (i.e. all of ppc ppc64 i386 at once).

	* macosx/Makefile: add support for reusing configure cache, build
	target fixes, remove GENERIC_FLAGS override now handled by tcl.m4.

	* generic/tclIOUtil.c:
	* generic/tclRegexp.c:
	* generic/tclVar.c: declare globals used only in own file as static
	(sync with HEAD).

	* generic/rege_dfa.c (getvacant):
	* generic/regexec.c (cfind):
	* generic/tclCompExpr.c (CompileSubExpr):
	* unix/tclUnixChan.c (TclUnixWaitForFile): initialise variables to
	silence gcc 4 warnings.

	* generic/regguts.h: only #define NDEBUG if not already #defined.

	* macosx/tclMacOSXNotify.c: sync whitespace & comments with HEAD

	* unix/configure: regen.

2005-11-20  Joe English  <jenglish@users.sourceforge.net>

	* generic/tclStubLib.c: Don't set tclStubsPtr to 0 when
	Tcl_PkgRequireEx() fails [Fix for [Bug 1091431] "Tcl_InitStubs failure
	crashes wish"]

2005-11-18  Miguel Sofer <msofer@users.sf.net>

	* tests/trace.test (trace-34.5): [Bug 1047286], added a second test
	illustrating the role of "ns in callStack" in the ns's visibility
	during deletion traces.

	* generic/tclBasic.c (Tcl_DeleteCommandFromToken):
	* generic/tclCmdMZ.c (TraceCommandProc):
	* generic/tclInt.h (NS_KILLED):
	* generic/tclNamesp.c (Tcl_DeleteNamespace
	* tests/namespace.test (namespace-7.3-6):
	* tests/trace.test (trace-20.13-16): fix [Bugs 1355942/1355342].

2005-11-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIO.c (TclFinalizeIOSubsystem): preserve statePtr until we
	netrieve next statePtr from it.

2005-11-18  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclPkg.c:	Revised Bug 1162286 fix from 2005-11-08 to be
	* tests/pkg.test:	more forgiving of package version mismatch
	errors in [package ifneeded] commands. This reduces the
	***POTENTIAL INCOMPATIBILITY*** noted for that change.

2005-11-18  Andreas Kupries <andreask@activestate.com>

	* generic/tclIO.c (TclFinalizeIOSubsystem): Applied Pat Thoyts' patch
	for [Bug 1359094]. This moves the retrieval of the next channel state
	to the end of the loop, as the called closeproc may close other
	channels, i.e., modify the list we are iterating, invalidating any
	pointer retrieved earlier.

2005-11-18  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/http/http.tcl (http::geturl): Improved syntactic validation
	of URLs, and better error messages in some cases. [Bug 1358369]

2005-11-16  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.4.12
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf-2.13
	* win/configure:

2005-11-15  Don Porter  <dgp@users.sourceforge.net>

	* changes:		Update changes for 8.4.12 release

2005-11-15  Kevin B. Kenny  <kennykb@acm.org>

	* tests/cmdAH.test: Backported the fix for [Bug 926016] because of
	* win/tclWinFile.c: a repeated bug report in 8.4 [Bug 1353840].
	Windows [file mtime] will now return seconds from the Posix epoch
	correctly (except for FAT32 file systems after a DST change without a
	reboot - for which there is no help). A side effect is that file times
	will appear different in Tcl from the way they do in Windows Explorer
	or a 'dir' listing, because the Microsoft tools get the DST state
	wrong in the listings.

2005-11-09  Kevin B. Kenny  <kennykb@acm.org>

	* generic/tclTimer.c: Changed [after] so that it behaves correctly
	* tests/timer.test:   with negative arguments. [Bug 1350293]

2005-11-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tclUnixFCmd.c (MAX_READDIR_UNLINK_THRESHOLD): reduce to 130
	based on errors seen on OS X 10.3 with lots of links in a dir. [Bug
	1034337 followup]

2005-11-08  Don Porter  <dgp@users.sourceforge.net>

	* tests/expr.test:	Portable tests expr-46.13-18 [Bug 1341368]

	* generic/tclPkg.c:	Corrected inconsistencies in the value returned
	* tests/pkg.test:	by Tcl_PkgRequire(Ex) so that the returned
	values will always agree with what is stored in the package database.
	This way repeated calls to Tcl_PkgRequire(Ex) have the same results.
	Thanks to Hemang Lavana. [Bug 1162286]
	***POTENTIAL INCOMPATIBILITY***: Incompatible with those existing
	packages that are accustomed to the [package] command forgiving
	their bugs.

	* tests/namespace.test (25.7,8):	Backport test of knownBug.

2005-11-08  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclCmdMZ.c (TclTraceVariableObjCmd, TraceVarProc): Applied
	Miguel's fix for [Bug 1348775]. It is not quite as elegant as the one
	applied to the HEAD, but it is easier to use it rather than fully
	backporting.

2005-11-07  Miguel Sofer <msofer@users.sf.net>

	* tests/trace.test (trace-13.2-4): added tests to detect leak, see
	[Bug 1348775].

2005-11-04  Don Porter  <dgp@users.sourceforge.net>

	* unix/tcl.m4:	Added code to enable [load] on LynxOS. Thanks to
	heidibr@users.sf.net for the patch. [Bug 1163896]

	* unix/configure:	autoconf-2.13.

2005-11-04  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tclWinPipe.c: Applied [Patch 1267871] by Matt Newman which
	* win/tclWinPort.h: provides extended error code support.
	* tests/exec.test:  Wrote some tests for this feature.

2005-11-04  Kevin Kenny  <kennykb@acm.org>

	* generic/tclGetDate.y: Added abbreviations for the Korean timezone.
	* generic/tclDate.c:	Regenerated.

	* compat/strftime.c: Fixed a problem where the name of the time zone
	was double-converted from system encoding to UTF-8. Thanks to the
	anonymous submitter of [Bug 1317477] for the report and the patch.

2005-11-04  Miguel Sofer <msofer@users.sf.net>

	* generic/tclInt.h:
	* generic/tclNamesp.c:
	* generic/tclVar.c: fix for [Bugs 1338280/1337229]. Thanks Don.

	* tests/trace.test: fix duplicate test numbers

2005-11-03  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclUnixInit.c (TclpSetInitialEncodings):	Modified so
	that multiple calls can continue to atttempt to properly set the
	system encoding. Needed for Tclkit to properly support non-default
	encodings. Thanks to Yaroslav Schekin. [Bug 1201171]

2005-11-03  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tclWin32Dll.c:   Backported Anton Kovalenko's [Patch 1256872]
	* win/tclWinConsole.c: to give unicode console support on
	* win/tclWinInt.h:     suitable systems (eg: NT/XP)

2005-11-01  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c (TclCheckExecutionTraces):	Corrected mistaken
	assumption that all command traces are set at the script level.
	Report/fix from Jacques H. de Villiers. [Bug 1337941]

	* tests/expr-old.test (expr-32.52):	Use int(.) to restrict result
	of left shift to the C long range.

2005-10-29  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/expr.test: Fix problems in new round() tests that lead to
	correct result only on 32 bit long systems. [Bug 1341368]

2005-10-29  Miguel Sofer <msofer@users.sf.net>

	* generic/tclCmdMZ.c (TraceVarProc): [Bug 1337229], partial fix.
	Ensure that a second call with TCL_TRACE_DESTROYED does not lead to a
	second call to Tcl_EventuallyFree(). It is still true that that second
	call should not happen, so the bug is not completely fixed.
	* tests/trace.test (test-18.3-4): added tests for [Bugs 1337229 and
	1338280].

2005-10-27  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tclExecute.c (ExprRoundFunc): Fix typo where number before
	rounding is compared with smallest integer instead of number after
	rounding. This fix does not change the results of any tests.
	* tests/expr.test: Add round() tests for cases near the min and max
	int values.
	* tests/util.test: Remove pointless warning code about testobj command

2005-10-23  Miguel Sofer <msofer@users.sf.net>

	* generic/tclBasic.c:
	* generic/tclBinary.c:
	* generic/tclCmdAH.c:
	* generic/tclCmdIL.c:
	* generic/tclCmdMZ.c:
	* generic/tclExecute.c:
	* generic/tclLink.c:
	* generic/tclMain.c:
	* generic/tclProc.c:
	* generic/tclScan.c:
	* generic/tclTest.c:
	* generic/tclVar.c:
	* mac/tclMacInit.c:
	* unix/tclUnixInit.c:
	* win/tclWinInit.c: Ensure that the core never calls TclPtrSetVar,
	Tcl_SetVar2Ex, Tcl_ObjSetVar2 or Tcl_SetObjErrorCode with a 0-ref new
	value. It is not possible to handle error returns correctly in that
	case [Bug 1334947], one has the choice of leaking the object in some
	cases, or else risk crashing in some others.

2005-10-22  Miguel Sofer <msofer@users.sf.net>

	* generic/tclExecute.c (INST_CONCAT): disable the optimisation for
	wide integers. [Bug 1251791]

2005-10-14  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclIO.c (Tcl_ClearChannelHandlers): removed change dated
	2005-10-04 below. Look into [Bug 1323992] for detailed discussion.

2005-10-13  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclCmdAH.c (Tcl_FormatObjCmd): Stop [format] from seeing
	the difference between ints and wides. [Bug 1284178]

2005-10-13  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclIO.c (Tcl_ClearChannelHandlers): temporary
	ifdef TCL_THREADS changes done to de-activate pending
	event processing when channel is being closed/cutted.

2005-10-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclInt.h: ensure MODULE_SCOPE decl

2005-10-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tclUnixFCmd.c (TraverseUnixTree): Adjust 2004-11-11 change to
	* tests/fCmd.test (fCmd-20.2):		 account for NFS special
	files with a readdir rewind threshold. [Bug 1034337]

2005-10-05  Andreas Kupries <andreask@activestate.com>

	* generic/tclPipe.c (TclCreatePipeline): Fixed [Bug 1109294]. Applied
	the patch provided by David Gravereaux.

	* doc/CrtChannel.3: Fixed [Bug 1104682], by application of David
	Welton's patch for it, and added a note about wideSeekProc.

2005-10-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/env.test (env-6.1):
	* win/tclWinPort.h: define USE_PUTENV_FOR_UNSET 1
	* generic/tclEnv.c (TclSetEnv, TclUnsetEnv): add
	USE_PUTENV_FOR_UNSET to existing USE_PUTENV define to account for
	various systems that have putenv(), but can't unset env vars with it.
	Note difference between Windows and Linux for actually unsetting the
	env var (use of '=').
	Correct the resizing of the environ array. We assume that we are in
	full ownership, but that's not correct. [Bug 979640]

2005-10-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinSerial.c (SerialSetOptionProc): free argv [Bug 1067708]

	* tests/http.test:		Do not URI encode -._~ according to
	* library/http/http.tcl (init): RFC3986. [Bug 1182373] (aho)

	* generic/tclIOUtil.c (TclFSNormalizeAbsolutePath): make static
	* generic/tclEncoding.c (TclFindEncodings): make static

	* unix/tclLoadShl.c (TclpDlopen): use DYNAMIC_PATH on second
	shl_load only. [Bug 1204237]

2005-10-04  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclIO.c (Tcl_ClearChannelHandlers): now deletes any
	outstanding timer for the channel. Also, prevents events still
	in the event queue from triggering on the current channel.

	* generic/tclTimer.c (Tcl_DeleteTimerHandler): bail out early
	if passed NULL argument.

2005-09-30  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclMain.c:	Separate encoding conversion of command line
	arguments from list formatting. [Bug 1306162]

2005-09-27  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclBinary.c (FormatNumber): Factorize out copying of double
	values to a helper to work around ugly broken compiler problems. [Bug
	1116542]

2005-09-15  Miguel Sofer <msofer@users.sf.net>

	* doc/ParseCmd.3: copy/paste fix [Bug 1292427]

2005-09-15  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tcl.m4 (SC_TCL_EARLY_FLAGS): Added extra hack to allow Tcl to
	transparently open large files on RHEL 3. [Bug 1287638]

	* unix/configure:	autoconf-2.13

2005-09-07  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclUtf.c (Tcl_UniCharToUtf):	Corrected handling of negative
	* tests/utf.test (utf-1.5):	Tcl_UniChar input value. Incorrect
	handling was producing byte sequences outside of Tcl's legal internal
	encoding. [Bug 1283976]

2005-08-29  Kevin Kenny  <kennykb@acm.org>

	* generic/tclBasic.c (ExprMathFunc): Restored "round away from zero"
	* tests/expr.test (expr-46.*):	     behaviour to the "round"
	function. Added test cases for the behavior, including the awkward
	case of a number whose fractional part is 1/2-1/2ulp. [Bug 1275043]

2005-08-25  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclListObj.c (UpdateStringOfList): Stop uncontrolled and
	unsafe crashes from happening when working with very large string
	representations. [Bug 1267380]

2005-08-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclFCmd.c (TclFileMakeDirsCmd): fix to race condition in
	file mkdir (backport from head 2005-06-13) [Bug 1217375]

2005-08-16  Kevin Kenny <kennykb@acm.org>

	* generic/tclEvent.c (Tcl_Finalize): Pushed Tcl_FinalizeLoad and
	Tcl_ResetFilesystem down after Tcl_FinalizeThreadAlloc because
	unloading DLLs can't happen while they still own TSD keys.
	(This is a backport of changes made in the HEAD on 2005-08-10.)

2005-08-05  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tclUnixInit.c (localeTable): Solaris uses a non-standard name
	for the cp1251 charset. Thanks to Victor Wagner for reporting this.
	[Bug 1252475]

2005-08-05  Kevin Kenny  <kennykb@users.sourceforge.net>

	* generic/tclExecute.c (TclExecuteByteCode): Fixed a corner case
	* tests/expr.test (expr-38.1):		     where applying abs to
	MIN_INT failed to promote the result to a wide integer. [Bug 1241572]

2005-08-04  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclObj.c:	Simplified routines that manage the typeTable.

2005-08-03  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCompExpr.c:	Untangled some dependencies in the
	* generic/tclEvent.c:		order of finalization routines.
	* generic/tclInt.h:		[Bug 1251399]
	* generic/tclObj.c:

2005-07-30  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure, unix/tcl.m4: revert 2005-07-28 change.

	* unix/tclLoadDyld.c (TclpDlopen, TclpLoadMemory): workarounds for
	bugs/changes in behaviour in Mac OS X 10.4 Tiger, sync formatting
	changes from HEAD.

2005-07-29  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tclCmdIL.c (InfoGlobalsCmd): Even in high-speed mode, still
	have to take care with non-existant variables. [Bug 1247135]

2005-07-28  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/README: Update link to msys_mingw8.zip. Remove old Cygwin +
	Mingw info, people should just build with the msys + mingw
	configuration.

2005-07-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure, unix/tcl.m4: defined TCL_LOAD_FROM_MEMORY on Darwin
	only for SHARED_BUILD

2005-07-28  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tclPipe.c (TclCreatePipeline): Arrange for POSIX systems to
	* unix/tclUnixPipe.c (TclpOpenFile):	 use the O_APPEND flag for
	* tests/exec.test (exec-19.1):		 files opened in a pipeline
	like ">>this".	Note that Windows cannot support such access; there is
	no equivalent flag on the handle that can be set at the kernel-call
	level. The test is unix-specific in every way. [Bug 1245953]

2005-07-26  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/configure.in: Check for a $prefix/share directory and add it
	the the package if found. This will check for Tcl packages in
	/usr/local/share when Tcl is configured with the default dist install.
	[Patch 1231015]

2005-07-26  Don Porter  <dgp@users.sourceforge.net>

	* doc/tclvars.n:	Improved $errorCode documentation. [RFE 776921]

	* generic/tclBasic.c (Tcl_CallWhenDeleted):	Converted to use
	per-thread counter, rather than a process global one that required
	mutex protection. [RFE 1077194]

	* generic/tclNamesp.c (TclTeardownNamespace):	Re-ordering so that
	* tests/trace.test (trace-34.4):	command delete traces fire
	while the command still exists. [Bug 1047286]

2005-07-24  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/tcl.m4 (SC_PROG_TCLSH, SC_BUILD_TCLSH):
	* win/tcl.m4 (SC_PROG_TCLSH, SC_BUILD_TCLSH):
	Split confused search for tclsh on PATH and build and install
	locations into two macros. SC_PROG_TCLSH searches just the PATH.
	SC_BUILD_TCLSH determines the name of the tclsh executable in the Tcl
	build directory. [Bug 1160114], [Patch 1244153]

2005-07-22  Don Porter  <dgp@users.sourceforge.net>

	* library/auto.tcl:	Updates to the Tcl script library to make
	* library/history.tcl:	use of Tcl 8.4 feautures.  Thanks to
	* library/init.tcl:	Patrick Fradin for prompting on this.
	* library/package.tcl:	[Patch 1237755]
	* library/safe.tcl:
	* library/word.tcl:

2005-07-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4, unix/configure: Backported [Bug 1095909], removing
	* unix/tclUnixPort.h:	       any use of readdir_r as it is not
	* unix/tclUnixThrd.c:	       necessary and just confuses things.

2005-07-05  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdAH.c:	 New "encoding" Tcl_ObjType (not registered)
	* generic/tclEncoding.c: that permits longer lifetimes of the
	* generic/tclInt.h:	 Tcl_Encoding values kept as intreps of
	Tcl_Obj's.  Reduces the need for repeated reading of encoding
	definition files from the filesystem. [Bug 1077262]

	* generic/tclNamesp.c:	Allow for [namespace import] of a command
	* tests/namespace.test: over a previous [namespace import] of itself
	without throwing an error. [RFE 1230597]

2005-07-01  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* unix/tclUnixNotfy.c: protect against spurious wake-ups while waiting
	on the condition variable when tearing down the notifier thread. [Bug
	1222872]

2005-06-27  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.11 TAGGED FOR RELEASE ***

	* library/auto.tcl:	Reverted to Revision 1.12.2.3 (Tcl 8.4.9).
	Restores the (buggy) behavior of [auto_reset] that fails to clear
	away auto-loaded commands from non-global namespaces.  Fixing this
	bug exposed an unknown number of buggy files out there (including at
	least portions of the Tk script library) that cannot tolerate double
	[source]-ing.  The burden of fixing these exposed bugs will not be
	forced on package/extension/application authors until Tcl 8.5.

2005-06-24  Kevin Kenny  <kennykb@acm.org>

	* generic/tclEvent.c (Tcl_Finalize):
	* generic/tclInt.h:
	* generic/tclPreserve.c (TclFinalizePreserve): Changed the
	finalization logic so that Tcl_Preserve finalizes after exit
	handlers run; a lot of code called from Tk's exit handlers
	presumes tha Tcl_Preserve will still work even from an exit
	handler.  Also, made the assertion check that no exit handlers
	are created in Tcl_Finalize conditional on TCL_MEM_DEBUG to
	avoid spurious panics in the "stable" release.

2005-06-24  Don Porter  <dgp@users.sourceforge.net>

	* library/auto.tcl:	Make file safe to re-[source] without
	destroying registered auto_mkindex_parser hooks.

2005-06-23  Daniel Steffen  <das@users.sourceforge.net>

	* tools/tcltk-man2html.tcl: fixed useversion glob pattern to accept
	multi-digit patchlevels.

2005-06-23  Kevin Kenny  <kennykb@acm.org>

	* win/tclWinChan.c: More rewriting of __asm__ blocks that
	* win/tclWinFCmd.c: implement SEH in GCC, because mingw's
	gcc 3.4.2 is not as forgiving of violations committed by
	the old code and caused panics. [Bug 1225957]

2005-06-23  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in (install-private-headers): rewrite tclPort.h when
	installing private headers to remove ../unix relative #include path to
	tclUnixPort.h (which is incorrect at the installed location).

2005-06-22  Kevin Kenny <kennykb@acm.org>

	* generic/tclInt.h:			    Changed the finalization
	* generic/tclEvent.c (Tcl_Finalize):	    logic to defer the
	* generic/tclIO.c (TclFinalizeIOSubsystem): shutdown of the pipe
	* unix/tclUnixPipe.c (TclFinalizePipes):    management until after
	* win/tclWinPipe.c (TclFinalizePipes):	    all channels have been
	    closed, in order to avoid a situation where the Windows
	    PipeCloseProc2 would re-establish the exit handler after exit
	    handlers had already run, corrupting the heap. [Bug 1225727]
	Corrected a read of uninitialized memory in PipeCloseProc2, which (at
	least on certain configurations) caused a great number of tests to
	either fail or hang. [Bug 1225044]

2005-06-22  Andreas Kupries <andreask@activestate.com>

	* generic/tclInt.h: Followup to change made on 2005-06-18 by Daniel
	Steffen. There are compilers (*) who error out on the redefinition of
	WORDS_BIGENDIAN. We have to undef the previous definition (on the
	command line) first to make this acceptable. (*): AIX native.

2005-06-22  Don Porter  <dgp@users.sourceforge.net>

	* win/tclWinFile.c:	Potential buffer overflow. [Bug 1225571]
	Thanks to Pat Thoyts for discovery and fix.

	* tests/safe.test:	Backport performance improvement from
	reduced $::auto_path.

2005-06-21  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* tests/winDde.test: Added some waits to the dde server script to
	let event processing run after we create the dde server and before
	we exit the server process. This avoids 'server did not respond'
	errors.

2005-06-21  Kevin Kenny  <kennykb@acm.org>

	* generic/tclFileName.c: Corrected a problem where a directory name
	containing a colon can crash the process on Windows [Bug 1194458]
	* tests/fileName.test: Added test for [file split] and [file join]
	with a name containing a colon.
	* win/tclWinPipe.c: Reverted davygrvy's changes of 2005-04-19;
	they cause multiple failures in io.test. [Bug 1225044, still open]

2005-06-21  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclBasic.c:	Made the walk of the active trace list aware
	* generic/tclCmdMZ.c:	of the direction of trace scanning, so the
	* generic/tclInt.h:	proper correction can be made. [Bug 1224585]
	* tests/trace.test (trace-34.2,3):

	* generic/tclBasic.c (Tcl_DeleteTrace):	Added missing walk of the
	* tests/trace.test (trace-34.1):	list of active traces to
	cleanup references to traces being deleted. [Bug 1201035]

2005-06-20  Don Porter  <dgp@users.sourceforge.net>

	* doc/FileSystem.3: added missing Tcl_GlobTypeData documentation [Bug
	935853]

2005-06-18  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tclInt.h: ensure WORDS_BIGENDIAN is defined correctly with
	fat compiles on Darwin (i.e. ppc and i386 at the same time), the
	configure AC_C_BIGENDIAN check is not sufficient in this case because
	a single run of the compiler builds for two architectures with
	different endianness.

	* unix/tcl.m4 (Darwin): add -headerpad_max_install_names to LDFLAGS to
	ensure we can always relocate binaries with install_name_tool.

	* unix/configure: autoconf-2.13

2005-06-18  Don Porter  <dgp@users.sourceforge.net>

	* changes:		Update changes for 8.4.11 release

	* README:		Bump version number to 8.4.11
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf
	* win/configure:

2005-06-18  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclCmdAH.c (Tcl_FormatObjCmd): Fix for [Bug 1154163]; only
	* tests/format.test: insert 'l' modifier when it is needed.

2005-06-07  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tclUnixNotfy.c (Tcl_FinalizeNotifier): Add dummy variable
	so threaded build compiles.

2005-06-06  Kevin B. Kenny  <kennykb@acm.org>

	* win/tclWin32Dll.c: Corrected another buglet in the assembly code for
	stack probing on Win32/gcc. [Bug 1213678]

2005-06-03  Daniel Steffen  <das@users.sourceforge.net>

	*** 8.4.10 TAGGED FOR RELEASE ***

	* unix/tclLoadDyld.c: fixed header conflict when building this file
	with USE_TCL_STUBS.

	* macosx/Makefile: fixed 'embedded' target.

2005-06-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in (html): add BUILD_HTML_FLAGS optional var
	* tools/tcltk-man2html.tcl: add a --useversion to prevent
	confusion when multiple Tcl source dirs exist.

	* changes: updated for 8.4.10 release (porter)

2005-05-31  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* unix/tclUnixNotfy.c: the notifier thread is now created as
	joinable thread and it is properly joined in Tcl_FinalizeNotifier.
	This is an attempt to fix [Bug 1082283]

2005-05-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinThrd.c (TclpFinalizeThreadData): move tlsKey defn
	to top of file and clarify name (was 'key'). [Bug 1204064]

2005-05-27  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:	    Bumped patchlevel to 8.4.10
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/tcl.spec, unix/configure, unix/configure.in:
	* win/configure, win/configure.in:

2005-05-26  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: moved & corrected EMBEDDED_BUILD check.

	* unix/configure.in: corrected framework finalization to softlink
	stub library to Versions/8.x subdir instead of Versions/Current.
	* unix/configure: autoconf-2.13

2005-05-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclCmdMZ.c (Tcl_TimeObjCmd): add necessary cast

	* unix/configure, unix/configure.in: ensure false Tcl.framework is
	only created with --enable-framework

2005-05-24  Daniel Steffen  <das@users.sourceforge.net>

	* tests/env.test: added DYLD_FRAMEWORK_PATH to the list of env vars
	that need to be handled specially.

	* macosx/Makefile:
	* macosx/README:
	* macosx/Tcl-Info.plist.in (new file):
	* unix/Makefile.in:
	* unix/configure.in:
	* unix/tcl.m4:
	* unix/tclUnixInit.c: moved all Darwin framework build support from
	macosx/Makefile into the standard unix configure/make buildsystem, the
	macosx/Makefile is no longer required to build Tcl.framework (but its
	functionality is still available for backwards compatibility).
	* unix/configure: autoconf-2.13

	* generic/tclIOUtil.c (TclLoadFile):
	* generic/tclInt.h:
	* unix/tcl.m4:
	* unix/tclLoadDyld.c: added support for [load]ing .bundle binaries in
	addition to .dylib's: .bundle's can be [unload]ed (unlike .dylib's),
	and can be [load]ed from memory, e.g. directly from VFS without
	needing to be written out to a temporary location first. [Bug 1202209]
	* unix/configure: autoconf-2.13

	* generic/tclCmdMZ.c (Tcl_TimeObjCmd): change [time] called with a
	count > 1 to return a string with a float value instead of a rounded
	off integer. [Bug 1202178]

2005-05-20  Zoran Vasiljevic <vasiljevic@users.sourceforge.net>

	* generic/tclParseExpr.c: removed unreferenced stack variable "errMsg"
	probably included by fixing [Bug 1201589] (see below).

2005-05-20  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclParseExpr.c:	Corrected parser to recognize all
	boolean literals accepted by Tcl_GetBoolean, including prefixes like
	"y" and "f", and to allow "eq" and "ne" as function names in the
	proper context. [Bug 1201589]

2005-05-19  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tclMacOSXNotify.c (Tcl_InitNotifier): fixed crashing
	CFRelease of runLoopSource in Tcl_InitNotifier (reported by Zoran):
	CFRunLoopAddSource doesn't CFRetain, so can only CFRelease the
	runLoopSource in Tcl_FinalizeNotifier.

2005-05-14  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tclMacOSXBundle.c:
	* unix/tclUnixInit.c:
	* unix/tcl.m4 (Darwin): made use of CoreFoundation API configurable
	and added test of CoreFoundation availablility to allow building on
	ppc64, replaced HAVE_CFBUNDLE by HAVE_COREFOUNDATION; test for
	availability of Tiger or later OSSpinLockLock API.

	* unix/tclUnixNotfy.c:
	* unix/Makefile.in:
	* macosx/tclMacOSXNotify.c (new file): when CoreFoundation is
	available, use new CFRunLoop based notifier: allows easy integration
	with other event loops on Mac OS X, in particular the TkAqua Carbon
	event loop is now integrated via a standard tcl event source (instead
	of TkAqua upon loading having to finalize the exsting notifier and
	replace it with its custom version). [Patch 1202052]

	* tests/unixNotfy.test: don't run unthreaded tests on Darwin since
	notifier may be using threads even in unthreaded core.

	* unix/tclUnixPort.h:
	* unix/tcl.m4 (Darwin): test for thread-unsafe realpath durning
	configure, as Darwin 7 and later realpath is threadsafe.

	* macosx/tclMacOSXBundle.c:
	* unix/tclLoadDyld.c:
	* unix/tclUnixInit.c: fixed gcc 4.0 warnings.

	* unix/configure: autoconf-2.13

2005-05-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/string.test: string-10.[21-30]
	* generic/tclCmdMZ.c (Tcl_StringObjCmd): add extra checks to
	prevent possible UMR in unichar cmp function for string map.

2005-05-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4, unix/configure: correct Solaris 10 (5.10) check and
	add support for x86_64 Solaris cc builds.

2005-04-29  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/FileSystem.3: Backport of doc fix. [Bug 1172401]

2005-04-27  Don Porter  <dgp@users.sourceforge.net>

	* library/init.tcl:	Corrected flaw in interactive command
	* tests/main.test:	auto-completion. [Bug 1191409]

	* tests/unixInit.test (7.1):	Alternative fix for the
	2005-04-22 commit.

2005-04-25  Daniel Steffen  <das@users.sourceforge.net>

	* compat/string.h: fixed memchr() protoype for __APPLE__ so that we
	build on Mac OS X 10.1 again.

	* generic/tclNotify.c (TclFinalizeNotifier): fixed notifier not being
	finalized in unthreaded core (was testing for notifier initialization
	in current thread by checking thread id != 0 but thread id is always 0
	in untreaded core).

	* unix/tclUnixNotfy.c (Tcl_WaitForEvent): sync with HEAD: only declare
	and use timeout var in unthreaded core.

	* unix/Makefile.in: added @PLAT_SRCS@ to SRCS and split out
	NOTIFY_SRCS from UNIX_SRCS for parity with UNIX_OBJS & NOTIFY_OBJS.

	* unix/configure.in: only run check for broken strstr implementation
	if AC_REPLACE_FUNCS(strstr) hasn't already determined that strstr is
	unavailable, otherwise compat/strstr.o will be used twice (resulting
	in duplicate symbol link errors on Mac OS X 10.1)

	* unix/tcl.m4 (Darwin): added configure checks for recently added
	linker flags -single_module and -search_paths_first to allow building
	with older tools (and on Mac OS X 10.1), use -single_module in
	SHLIB_LD and not just T{CL,K}_SHLIB_LD_EXTRAS, added unexporting from
	Tk of symbols from libtclstub to avoid duplicate symbol warnings,
	added PLAT_SRCS definition for Mac OS X.
	(SC_MISSING_POSIX_HEADERS): added caching of dirent.h check.
	(SC_TCL_64BIT_FLAGS): fixed 'checking for off64_t' message output.

	* unix/configure: autoconf-2.13

2005-04-22  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c:	Corrected intrep-dependence of
	* tests/string.test:	[string is boolean] [Bug 1187123]

2005-04-22  Daniel Steffen  <das@users.sourceforge.net>

	* tests/unixInit.test (7.1): fixed failure when running tests with
	-tmpdir arg not set to working dir.

2005-04-20  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclGet.c (Tcl_GetInt):	Corrected error that did not
	* generic/tclObj.c (Tcl_GetIntFromObj): permit 0x80000000 to be
	recognized as an integer on TCL_WIDE_INT_IS_LONG systems [Bug 1090869]

2005-04-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/winPipe.test (winpipe-6.2): remove -blocking 1 as this one
	can truly block.

2005-04-19  David Gravereaux <davygrvy@pobox.com>

	* win/tclWinPipe.c: The pipe channel driver now respects the -blocking
	option when closing. The windows pipe driver now has the same behavior
	as the UNIX side. This change is to avoid a hung shell when exiting
	due to open pipes that refuse to close in a graceful manner.
	* doc/open.n: Added a note about -blocking 0 and lack of exit status
	as it had never been documented. [Bug 947693]

	***POTENTIAL INCOMPATIBILITY***

	Scripts that use async pipes on windows, must (like the UNIX side) set
	-blocking to 1 before calling [close] to receive the exit status.

	* tests/winPipe.test (winpipe-6.1/2): added 'fconfigure $f -blocking
	1' so the exit status can be acquired.

2005-04-13  David Gravereaux <davygrvy@pobox.com>

	* generic/tclIO.c (Tcl_SetChannelBufferSize): Lowest size limit
	* tests/io.test:	changed from ten bytes to one byte. Need for
	* tests/iogt.test:	this change was proven by Ross Cartlidge
	<rossc@cisco.com> where [read stdin 1] was grabbing 10 bytes followed
	by starting a child process that was intended to continue reading from
	stdin. Even with -buffersize set to one, nine chars were getting lost
	by the buffersize over reading for the native read() caused by [read].

2005-04-12  Kevin B. Kenny  <kennykb@acm.org>

	* compat/strstr.c: Added default definition of NULL to accommodate
	building on systems with badly broken headers. [Bug 1175161]

2005-04-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/README: updated requirements for OS & developer tool versions
	+ other small fixes/cleanup.

	* unix/tcl.m4 (Darwin): added -single_module linker flag to
	TCL_SHLIB_LD_EXTRAS and TK_SHLIB_LD_EXTRAS.
	* unix/configure: autoconf-2.13

2005-04-05  Zoran Vasiljevic  <vasiljevic@users.sourceforge.net>

	Set of changes correcting huge memory waste (not a leak) when a thread
	exits. This has been introduced in 8.4.7 within an attempt to
	correctly cleanup after ourselves when Tcl library is being unloaded
	with the Tcl_Finalize() call.

	This fixes the [Bug 1178445].

	* generic/tclInt.h: added prototypes for TclpFreeAllocCache() and
	TclFreeAllocCache()

	* generic/tclThreadAlloc.c: modified TclFinalizeThreadAlloc() to
	explicitly call TclpFreeAllocCache with the NULL-ptr as argument
	signalling cleanup of private tsd key used only by the threading
	allocator.

	* unix/tclUnixThrd.c: fixed TclpFreeAllocCache() to recognize when
	being called with NULL argument. This is a signal for it to clean up
	the tsd key associated with the threading allocator.

	* win/tclWinThrd.c: renamed TclWinFreeAllocCache to TclpFreeAllocCache
	and fixed to recognize when being called with NULL argument. This is a
	signal for it to clean up the tsd key associated with the threading
	allocator.

2005-04-05  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclExecute.c (ExprSrandFunc):	Replaced incursions into the
	* generic/tclUtil.c (TclGetIntForIndex): intreps of numeric types with
	simpler calls of Tcl_GetIntFromObj and Tcl_GetLongFromObj, now that
	those routines are better behaved wrt shimmering. [Patch 1177129]

2005-03-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tcl.m4, win/configure: do not require cygpath in macros to
	allow msys alone as an alternative.

	* win/tclWinTime.c (TclpGetDate): use time_t for 'time' [Bug 1163422]

2005-03-18  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCompCmds.c (TclCompileIncrCmd):	Corrected checks for
	immediate operand usage to permit leading space and sign characters.
	Restores more efficient bytecode for [incr x -1] that got lost in the
	CONST string reforms of Tcl 8.4. [Bug 1165671]

	* generic/tclBasic.c (Tcl_EvalEx,TclEvalTokensStandard):
	* generic/tclCmdMZ.c (Tcl_SubstObj):
	* tests/basic.test (basic-46.4):	Restored recursion limit
	* tests/parse.test (parse-19.*):	testing in nested command
	substitutions within direct script evaluation (Tcl_EvalEx) that got
	lost in the parser reforms of Tcl 8.1. Added tests for correct
	behavior. [Bug 1115904]

2005-03-15  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclFileName.c:
	* win/tclWinFile.c:
	* tests/winFCMd.test: fix to 'file pathtype' and 'file norm' failures
	on reserved filenames like 'COM1:', etc.

2005-03-15  Kevin B. Kenny  <kennykb@acm.org>

	* generic/tclClock.c:
	* generic/tclDate.c:
	* generic/tclGetDate.y:
	* generic/tclInt.decls:
	* unix/tclUnixTime.c:
	* win/tclWinTime.c:	Replaced 'unsigned long' variable holding
	times with 'Tcl_WideInt', to cope with systems on which a time_t is
	wider than a long (Win64) [Bug 1163422]
	* generic/tclIntDecls.h: Regen

2005-03-15  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* unix/tcl.m4: Make it work on OpenBSD again. Imported patch
	from the OpenBSD ports tree.

2005-03-10  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c (TclCheckInterpTraces):	Corrected mistaken
	cast of ClientData to (TraceCommandInfo *) when not warranted. Thanks
	to Yuri Victorovich for the report. [Bug 1153871]

2005-03-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/makefile.vc: clarify necessary defined vars that can come
	from MSVC or the Platform SDK.

2005-02-24  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl:	Better use of [glob -types] to avoid
	* tests/tcltest.test:	failed attempts to [source] a directory, and
	similar matters. Thanks to "mpettigr". [Bug 1119798]

	* library/tcltest/pkgIndex.tcl: Bump to tcltest 2.2.8

2005-02-23  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/CrtChannel.3 (THREADACTIONPROC): Formatting fix. [Bug 1149605]

2005-02-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinFCmd.c (TraverseWinTree): use wcslen on wchar, not
	Tcl_UniCharLen.

2005-02-16  Miguel Sofer <msofer@users.sf.net>

	* doc/variable.n: fix for [Bug 1124160], variables are detected by
	[info vars] but not by [info locals].

2005-02-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in: remove SHLIB_LD_FLAGS (only for AIX, inlined
	* unix/tcl.m4:	    into SHLIB_LD).  Combine AIX-* and AIX-5
	* unix/configure:   branches in SC_CONFIG_CFLAGS.
	Correct gcc builds for AIX-4+ and HP-UX-11.

2005-02-10  Miguel Sofer <msofer@users.sf.net>

	* generic/tclBasic.c (Tcl_EvalObjEx):
	* tests/basic.test (basic-26.2): preserve the arguments passed to TEOV
	in the pure-list branch, in case the list shimmers away. Fix for [Bug
	1119369], reported by Peter MacDonald.

2005-02-10  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/binary.n: Made the documentation of sign bit masking and
	[binary scan] consistent. [Bug 1117017]

2005-02-01  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclExecute.c (TclCompEvalObj): Removed stray statement
	left behind in prior code reorganization.

2005-01-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure, unix/tcl.m4: add solaris 64-bit gcc build
	support. [Bug 1021871]

2005-01-27  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclBasic.c (Tcl_ExprBoolean, Tcl_ExprDouble)
	(Tcl_ExprLong): Fix to recognize Tcl_WideInt type. [Bug 1109484]

2005-01-27  Andreas Kupries <andreask@activestate.com>

	TIP#218 IMPLEMENTATION

	* generic/tclDecls.h:	Regenerated from tcl.decls.
	* generic/tclStubInit.c:

	* doc/CrtChannel.3:	Documentation of extended API,
	* generic/tcl.decls:	extended testsuite, and
	* generic/tcl.h:	implementation. Removal of old
	* generic/tclIO.c:	driver-specific TclpCut/Splice
	* generic/tclInt.h:	functions. Replaced with generic
	* tests/io.test:	thread-action calls through the
	* unix/tclUnixChan.c:	new hooks. Update of all builtin
	* unix/tclUnixPipe.c:	channel drivers to version 4.
	* unix/tclUnixSock.c:	Windows drivers extended to
	* win/tclWinChan.c:	manage thread state in a thread
	* win/tclWinConsole.c:	action handler.
	* win/tclWinPipe.c:
	* win/tclWinSerial.c:
	* win/tclWinSock.c:
	* mac/tclMacChan.c:

2005-01-25  Don Porter  <dgp@users.sourceforge.net>

	* library/auto.tcl:	Updated [auto_reset] to clear auto-loaded
	procs in namespaces other than :: [Bug 1101670].

2005-01-25  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): fixed bug with static build linking to dynamic
	library in /usr/lib etc instead of linking to static library earlier
	in search path. [Bug 956908]
	Removed obsolete references to Rhapsody.
	* unix/configure: autoconf-2.13

2005-01-19  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tclWinChan.c (FileCloseProc): Invoke TclpCutFileChannel() to
	remove a FileInfo from the thread local list before deallocating it.
	This should have been done via an earlier call to Tcl_CutChannel, but
	I was running into a crash in the next call to Tcl_CutChannel during
	the IO finalization stage.

2005-01-17  Vince Darley  <vincentdarley@users.sourceforge.net>

	* tests/winFCmd.test: made test independent of current drive. [Bug
	1066528]

2005-01-10  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tclUnixFCmd.c (CopyFile): Convert u_int to unsigned to make
	clashes with types in standard C headers less of a problem. [Bug
	1098829]

2005-01-06  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/http/http.tcl (http::mapReply): Significant performance
	enhancement by using [string map] instead of [regsub]/[subst], and
	update version requirement to Tcl8.4. [Bug 1020491]

2005-01-05  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tclUnixInit.c (localeTable): Add encoding mappings for some
	Chinese locales. [Bug 1084595]

	* doc/lsearch.n: Convert to other form of emacs mode control
	comment to prevent problems with old versions of man. [Bug 1085127]

2004-12-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tcl.m4, win/configure: update MSVC CFLAGS_OPT to -O2, remove
	-Gs (included in -O2) and -GD (outdated).  Use "link -lib" instead
	of "lib" binary and remove -YX for MSVC7 portability.  Add
	-fomit-frame-pointer for gcc OPT compiles. [Bug 1092952, 1091967]

2004-12-13  Kevin B. Kenny  <kennykb@acm.org>

	* doc/clock.n: Clarify that the [clock scan] command does not accept
	the full range of ISO8601 point-in-time formats. [Bug 1075433]

2004-12-09  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/Async.3: Reword for better grammar, better nroff and get the
	flag name right. (Reported by David Welton.)

2004-12-06  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.9 TAGGED FOR RELEASE ***

	* unix/tclUnixNotfy.c (NotifierThreadProc): init numFdBits [Bug
	1079286]

2004-12-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* changes: updated for 8.4.9 release

2004-12-02  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclIOUtil.c: fix and new tests for [Bug 1074671] to
	* tests/fileSystem.test: ensure tilde paths are not returned specially
	by 'glob'.

2004-12-01  Don Porter  <dgp@users.sourceforge.net>

	* library/auto.tcl (tcl_findLibrary): Disabled use of [file normalize]
	that caused trouble with freewrap. [Bug 1072136]

2004-11-26  Don Porter  <dgp@users.sourceforge.net>

	* tests/reg.test (reg-32.*): Added missing testregexp constraints.

	* library/auto.tcl (tcl_findLibrary): Made sure the uniquifying
	operations on the search path does not also normalize.	[Bug 1072136]

2004-11-26  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/dde.n: Resynchonized the documentation with itself and fixed
	some formatting errors.

2004-11-25  Zoran Vasiljevic <vasiljevic@users.sf.net>

	* doc/Notify.3:
	* doc/Thread.3: Added doc fixes and hints from [Bug 1068077].

2004-11-25  Reinhard Max  <max@suse.de>

	* tests/tcltest.test: The order in which [glob] returns the file names
	* tests/fCmd.test:    is undefined, so tests should not depend on it.

2004-11-24  Don Porter  <dgp@users.sourceforge.net>

	* unix/tcl.m4 (SC_ENABLE_THREADS): Corrected failure to determine
	the number of arguments for readdir_r on SunOS systems. [Bug 1071701]

	* unix/configure:	autoconf-2.13

2004-11-24  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:	    Bumped patchlevel to 8.4.9
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/tcl.spec, unix/configure, unix/configure.in:
	* win/configure, win/configure.in:

2004-11-24  Kevin B. Kenny  <kennykb@acm.org>

	* unix/tcl.m4 (SC_ENABLE_THREADS): Corrected bad check for 3-argument
	readdir_r(). [Bug 1001325]
	* unix/configure: Regenerated.
	* unix/tclUnixNotfy.c: Corrected all uses of 'select' to manage their
	masks using the FD_CLR, FD_ISSET, FD_SET, and FD_ZERO macros rather
	than bit-whacking that failed under Solaris-Sparc-64. [Bug 1071807]

2004-11-23  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdIL.c (InfoVarsCmd):	Corrected segfault in new
	* tests/info.test (info-19.6):	trivial matching branch [Bug 1072654]

2004-11-23  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclPathObj.c: fix and new test for [Bug 1043129] in
	* tests/fileSystem.test: the treatment of backslashes in file join on
	Windows.

2004-11-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4 (SC_TCL_64BIT_FLAGS): Define HAVE_TYPE_OFF64_T only when
	off64_t, open64(), and lseek64() are defined. IRIX 5.3 is known to not
	include an open64 function. [Bug 1030465]

2004-11-22  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4 (SC_ENABLE_THREADS): Check for a 2 argument version of
	readdir_r that is known to exists under IRIX 5.3.
	* unix/tclUnixThrd.c (TclpReaddir): Use either 2 arg or 3 arg version
	of readdir_r. [Bug 1001325]

2004-11-19  Reinhard Max  <max@suse.de>

	*** 8.4.8 TAGGED FOR RELEASE ***

	* unix/installManPage: Classic sed doesn't support | in REs.

2004-11-19  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile:
	* unix/configure.in:
	* unix/tclUnixInit.c (MacOSXGetLibraryPath): changed detection of tcl
	framework build when determining tclLibPath from overloaded
	TCL_LIBRARY to configuration define TCL_FRAMEWORK. [Bug 1068088]

	* unix/configure: autoconf-2.13

	* tests/unixInit.test (7.1): fixed failure when running tests
	with -tmpdir arg not set to working dir.

2004-11-18  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Final updates for Tcl 8.4.8 release.

2004-11-18  Reinhard Max  <max@suse.de>

	* unix/tcl.m4 (SC_CONFIG_MANPAGES): Applied an improved version of
	* unix/configure.in:		    [Patch 996085], that introduces
	* unix/Makefile.in:		    --enable-man-suffix.

	* unix/installManPage:		    added
	* unix/mkLinks.tcl:		    removed
	* unix/mkLinks:			    removed

2004-11-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tclUnixChan.c (TtySetOptionProc): fixed crash configuring
	-ttycontrol on a channel. [Bug 1067708]

2004-11-16  Andreas Kupries <andreask@activestate.com>

	* win/makefile.vc: Fixed bug in installation of http 2.5.
	* win/makefile.bc: Was installed into directory http2.4.
	* win/Makefile.in: This has been corrected.
	* unix/Makefile.in:
	* tools/tcl.wse.in:
	* tools/tclmin.wse:

2004-11-16  Don Porter  <dgp@users.sourceforge.net>

	* library/auto.tcl:	Updated [tcl_findLibrary] search path to
	include the $::auto_path. [RFE 695441]

2004-11-16  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/tclvars.n: Mention global variables set by tclsh and wish so
	they are easier to find. [Patch 1065732]

2004-11-15  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c (Tcl_TraceObjCmd):	Fixed Bug 1065378 which failed
	* tests/trace.test (trace-33.1):	to permit a variable trace
	created with [trace variable] to be destroyed with [trace remove].
	Thanks to Keith Vetter for the report.

2004-11-12  Don Porter  <dgp@users.sourceforge.net>

	* library/init.tcl:	Made [unknown] robust in the case that either
	of the variables ::errorInfo or ::errorCode gets unset. [Bug 1063707]

2004-11-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclEncoding.c (TableFromUtfProc): correct crash
	condition when TCL_UTF_MAX == 6. [Bug 1004065]

2004-11-12  Daniel Steffen  <das@users.sourceforge.net>

	* doc/clock.n:
	* doc/registry.n:
	* doc/upvar.n: fixed *roff errors uncovered by running 'make html'.

	* tools/tcltk-man2html.tcl: added faked support for bullet point
	lists, i.e. *nroff ".IP \(bu" syntax.
	Synced other changes from HEAD.

2004-11-11  Daniel Steffen  <das@users.sourceforge.net>

	* tests/fCmd.test:
	* unix/tclUnixFCmd.c (TraverseUnixTree): added option to rewind() the
	readdir() loop whenever the source hierarchy has been modified by
	traverseProc (e.g. by deleting files); this is required to ensure
	complete traversal of the source hierarchy on certain filesystems like
	HFS+. Added test for failing recursive delete on Mac OS X that was due
	to this. [Bug 1034337]

	* generic/tclListObj.c (Tcl_ListObjReplace): use memmove() instead of
	manual copy loop to shift list elements. Decreases time spent in
	Tcl_ListObjReplace() from 5.2% to 1.7% of overall runtime of tclbench
	on a ppc 7455 (i.e. 200% speed increase). [Patch 1064243]

	* generic/tclHash.c: hoisted some constant pointer dereferences out of
	loops to eliminate redundant loads that the gcc optimizer didn't deal
	with. Decreases time spend in Tcl_FindHashEntry() by 10% over a full
	run of the tcl testuite on a ppc 7455. [Patch 1064243]

	* tests/fileName.test:
	* tests/fileSystem.test:
	* tests/io.test:
	* tests/tcltest.test: fixed bugs causing failures when running tests
	with -tmpdir arg not set to working dir.

	* macosx/Makefile: corrected path to html help inside framework.
	Prevent parallel make from building several targets at the same time.

2004-11-09  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/catch.n: Clarify documentation on return codes. [Bug 1062647]

2004-11-02  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for Tcl 8.4.8 release.

2004-11-02  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl:		Corrected some misleading
	* tests/tcltest.test (tcltest-26.1,2):	displays of ::errorInfo and
	::errorCode information when the -setup, -body, and/or -cleanup scripts
	return an unexpected return code.  Thanks to Robert Seeger for the
	fix. [RFE 1017151]

2004-11-02  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclExecute.c (TclExecuteByteCode): NaN-equality fix from
	Miguel Sofer. [Bug 761471]

	* doc/CrtChannel.3 (Tcl_GetChannelMode): Add synopsis. [Bug 1058446]

2004-10-31  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclCmdIL.c (InfoGlobalsCmd):
	* tests/info.test (info-8.4): Strip leading global-namespace
	specifiers from the pattern argument. [Bug 1057461]

2004-10-30  Miguel Sofer <msofer@users.sf.net>

	* generic/tclCmdAH.c (Tcl_CatchObjCmd): removed erroneous comment [Bug
	1029518]

2004-10-29  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl:	Correct reaction to errors in the
	obsolete processCmdLineArgsHook.	[Bug 1055673]
	* library/tcltest/pkgIndex.tcl: Bump to tcltest 2.2.7

2004-10-28  Andreas Kupries <andreask@activestate.com>

	* generic/tclAlloc.c:	    Fixed [Bug 1030548], a threaded debug
	* generic/tclThreadAlloc.c: build on Windows now works again. Had to
	* win/tclWinThrd.c:	    touch Unix as well. Basic patch by Kevin,
	* unix/tclUnixThrd.c:	    with modifications by myself.

2004-10-28  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bumped patch level to 8.4.8 to prepare for
	* generic/tcl.h:	next patch release.
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf (2.13)
	* win/configure:

2004-10-28  Kevin B. Kenny  <kennykb@acm.org>

	* generic/tclInt.decls:
	* unix/tclUnixTime.c (TclpGmtime, TclpLocaltime):
	* win/tclWinTime.c (TclpGmtime, TclpLocaltime): Changed type
	signatures of TclpGmtime and TclpLocaltime to accept CONST TclpTime_t
	throughout, to avoid any possible confusion in pedantic compilers.
	[Bug 1001319]
	* generic/tclIntDecls.h:
	* generic/tclIntPlatDecls.h:  Regenerated.

2004-10-27  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdAH.c (Tcl_FormatObjCmd):	Restored missing line
	from yesterday's 868489 backport that caused failed alloc's on LP64
	systems.

	* tests/appendComp.test:	Backport test suite fixes of errors
	* tests/autoMkindex.test:	revealed by -singleproc 1 -debug 1
	* tests/exec.test:		options to make test.
	* tests/execute.test:
	* tests/interp.test:
	* tests/io.test:
	* tests/namespace.test:
	* tests/regexpComp.test:
	* tests/stringComp.test:
	* tests/unixInit.test:
	* tests/winPipe.test:

2004-10-26  Kevin B. Kenny  <kennykb@acm.org>

	* generic/tclCmdAH.c (Tcl_FormatObjCmd): Backport a missing bit of the
						 [Bug 868489] fix.
	* generic/tclObj.c (SetBooleanFromAny): Backport fix for [Bug 1026125]
	* tests/format.test (format-19.1): Additional regression test for
					   [Bug 868489].

2004-10-26  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/*.n: Backporting of documentation updates.

2004-10-26  Don Porter  <dgp@users.sourceforge.net>

	* tests/subst.test (subst-12.3-5):	More tests for [Bug 1036649]

	* tests/compile.test (compile-12.4):	Backport test for [Bug 1001997]
	* tests/timer.test (timer-10.1):	Backport test for [Bug 1016167]
	* tests/tcltest.test (tcltest-12.3,4):	Backport setup corrections.
	* tests/error.test (error-6.3,4,7,9):	Backport of some tests.
	* tests/basic.test (basic-49.*):
	* tests/namespace.test (namespace-8.7):
	* tests/init.test (init-2.8):	Updated to not rely on http package.

	* generic/tclThreadTest.c (ThreadEventProc):	Corrected subtle bug
	where the returned (char *) from Tcl_GetStringResult(interp) continued
	to be used without copying or refcounting, while activity on the
	interp continued.

2004-10-14  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclUtil.c (TclMatchIsTrivial): Detect degenerate cases of
	glob matching that let us avoid scanning through hash tables.
	* generic/tclCmdIL.c (InfoCommandsCmd, InfoGlobalsCmd, InfoProcsCmd):
	(InfoVarsCmd): Use this to speed up some [info] subcommands.

2004-10-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinFile.c (NativeIsExec): correct result of 'file executable'
	to not be case sensitive. [Bug 954263]

2004-10-05  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclNamesp.c (Tcl_PopCallFrame): Removed Bug 1038021
	workaround. That bug is now fixed.

2004-09-30  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclNamespace.c (TclTeardownNamespace): Tcl_Obj-ified the
	* tests/namespace.test (namespace-8.5,6):	save/restore of
	::errorInfo and ::errorCode during global namespace teardown. Revised
	the comment to clarify why this is done, and added tests that will
	fail if this is not done.

	* generic/tclResult.c (TclTransferResult):	Added safety checks so
	that unexpected undefined ::errorInfo or ::errorCode will not lead to
	a segfault.

	* generic/tclVar.c (CallVarTraces):	Save/restore the flag values
	* tests/var.test (var-16.1):	that define part of the interpreter
	state during variable traces. [Bug 1038021]

2004-09-30  Miguel Sofer <msofer@users.sf.net>

	* tests/subst.test (12.2): test correction.

2004-09-29  Miguel Sofer <msofer@users.sf.net>

	* generic/tclBasic.c (Tcl_EvalEx):
	* tests/subst.test (12.1-2): fix for buffer overflow in [subst], [Bug
	1036649]

2004-09-23  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/dltest/Makefile.in (clean): Fixup make clean rule so that it
	does not delete all files when SHLIB_SUFFIX is set to the empty string
	in a static build. [Bug 1016726]

2004-09-18  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclExecute.c (TEBC-INST_LSHIFT,INST_RSHIFT): Ensure that
	large shifts end up shifting correctly. [Bug 868467]

2004-09-15  Daniel Steffen  <das@users.sourceforge.net>

	* tests/load.test (load-2.3): adopted fix for failure on darwin from
	HEAD.

2004-09-14  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclObj.c (Tcl_GetIntFromObj):	Corrected flaw in returning
	the int value of a wideInteger. [Bug 1027690]

2004-09-10  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclObj.c (SetIntOrWideFromAny): Rewritten integral value
	parsing code so that values do not flip so easily between numeric
	representations. Thanks to KBK for this! [Bug 868489]

	* generic/tclIO.c (Tcl_Seek): Make sure wide seeks do not fail to set
	::errorCode on error. [Bug 1025359]

2004-09-10  Andreas Kupries  <andreask@activestate.com>

	* generic/tcl.h: Micro formatting fixes.
	* generic/tclIOGT.c: Channel version fixed, must be 3, to have
	wideseekProc. Thanks to David Graveraux <davygrvy@pobox.com>.

2004-09-11  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclNamespace.c (TclGetNamespaceForQualName):	Resolved
	longstanding inconsistency in the treatment of the TCL_NAMESPACE_ONLY
	flag revealed by testing the 2004-09-09 commits against Itcl.
	TCL_NAMESPACE_ONLY now acts as specified in the pre-function
	comment, forcing resolution in the passed in context namespace. It has
	been incorrectly forcing resolution in the interp's current namespace.

2004-09-10  Miguel Sofer <msofer@users.sf.net>

	* generic/tclExecute.c (INST_CONCAT1): added a peephole optimisation
	for concatting an empty string. This enables replacing the idiom 'K $x
	[set x {}]' by '$x[set x {}]' for fastest execution.

2004-09-09  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclNamesp.c (Tcl_ForgetImport): Corrected faulty logic that
	* tests/namespace.test:	relied exclusively on string matching and
	failed in the presence of [rename]s. [Bug 560297]
	Also corrected faulty prevention of [namespace import] cycles. [Bug
	1017299]

2004-09-08  Kevin B. Kenny  <kennykb@acm.org>

	* compat/strftime.c (_conv): Corrected a problem where hour 0 would
	format as a blank format group with %k.
	* tests/clock.test (clock-41.1): Added regression test case for %k at
	the zero hour.

2004-09-07  Kevin B. Kenny  <kennykb@acm.org>

	* generic/tclTimer.c: Removed a premature optimisation that attempted
	to store the assoc data in the client data; the optimisation caused a
	bug that [after] would overwrite its imports. [Bug 1016167]

2004-09-02  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/lsearch.n: Clarified meaning of -dictionary. [Bug 759545]

2004-09-01  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinReg.c (BroadcastValue): WIN64 cast corrections

	* win/tclWinDde.c (DdeClientWindowProc):
	(DdeServicesOnAck, DdeEnumWindowsCallback): WIN64 corrections

	* win/tclWin32Dll.c (TclWinCPUID): need _asm for WIN64 (Itanium),
	until we have it, just return unknown. [Bug 1020445]

2004-08-30  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclCmdMZ.c (Tcl_StringObjCmd): Stop [string map] from
	crashing when its map and input string are the same object.

2004-08-27  Daniel Steffen  <das@users.sourceforge.net>

	* tests/env.test: macosx fixes.

2004-08-19  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclScan.c (Tcl_ScanObjCmd, ValidateFormat): Ensure that the
	%ld conversion works correctly on 64-bit platforms. [Bug 1011860]

2004-08-16  Miguel Sofer <msofer@users.sf.net>

	* doc/SetVar.3:
	* generic/tclTest.c (TestseterrorcodeCmd):
	* generic/tclVar.c (TclPtrSetVar):
	* tests/result.test (result-4.*, result-5.*): [Bug 1008314]
	detected and fixed by dgp.

2004-08-13  Don Porter  <dgp@users.sourceforge.net>

	* library/msgcat/msgcat.tcl:	Added checks to prevent [mclocale]
	* tests/msgcat.test:	from registering filesystem paths to possibly
	malicious code to be evaluated by a later [mcload].
	* library/msgcat/pkgIndex.tcl:	Bump to msgcat 1.3.3

2004-08-10  Zoran Vasiljevic <vasiljevic@users.sf.net>

	* unix/tclUnixThrd.c (TclpThreadCreate): changed handling of the
	returned thread ID since broken on 64-bit systems (Cray). Thanks to
	Rob Ratcliff for reporting the bug.

2004-07-30  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclEvent.c (Tcl_Finalize):	Re-organized Tcl_Finalize so
	that Tcl_ExitProc's that call Tcl_Finalize recursively do not cause
	deadlock. [Patch 999084, fixes Tk Bug 714956]

2004-07-30  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure:
	* unix/tcl.m4 (SC_CONFIG_CFLAGS): Darwin: instead of setting PLAT_OBJS
	to explict object files in tcl.m4, refer to MAC_OSX_OBJS makefile var.
	* unix/Makefile.in: added MAC_OSX_OBJS variable.

2004-07-28  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclMain.c (Tcl_Main, StdinProc):  Append newline only to
	* tests/basic.test (basic-46.1):	    incomplete scripts as part
	of multi-line script construction. Do not add an extra trailing
	newline to the complete script. [Bug 833150]

2004-07-26  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.7 TAGGED FOR RELEASE ***

	* tests/io.test (io-61.1): create file in binary mode for x-plat.

2004-07-25  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tclThreadAlloc.c: Moved the tclInt.h include to provide
	Tcl_Panic which is now required for non-threaded build.

2004-07-22  Don Porter  <dgp@users.sourceforge.net>

	* tests/eofchar.data (removed):	Test io-61.1 now generates its own
	* tests/io.test:	file of test data as needed.

2004-07-21  Don Porter  <dgp@users.sourceforge.net>
	* win/tclWinDde.c:		Bump to dde 1.2.3 to cover changes
	* library/dde/pkgIndex.tcl:	committed on 2004-06-14.

	* changes:	Updated for Tcl 8.4.7 release.

2004-07-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclEvent.c:	    Correct threaded obj allocator to
	* generic/tclInt.h:	    fully cleanup on exit and allow for
	* generic/tclThreadAlloc.c: reinitialization. [Bug 736426]
	* unix/tclUnixThrd.c:	    (mistachkin, kenny)
	* win/tclWinThrd.c:

2004-07-20  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4: fixed Darwin autoconf breakage caused by recent CFLAGS
	reordering.
	* unix/configure: regen

	* unix/tclConfig.sh.in: replaced EXTRA_CFLAGS with CFLAGS.
	* unix/dltest/Makefile.in: replaced EXTRA_CFLAGS with DEFS.

	* macosx/tclMacOSXBundle.c: dynamically acquire address for
	CFBundleOpenBundleResourceMap symbol, since it is only present in
	full CoreFoundation on Mac OS X and not in CFLite on pure Darwin.

2004-07-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in, unix/tcl.m4:     move (C|LD)FLAGS after their
	* unix/configure.in, unix/configure: _DEFAULT to allow for env setting
	to override m4 switches.
	Consolidate header checks to limit redundancy in configure.
	(CFLAGS_WARNING): Remove -Wconversion, add -fno-strict-aliasing for
	gcc builds (need to suppress 3.x type puning warnings).
	(SC_ENABLE_THREADS): Set m4 to force threaded build when built against
	a threaded Tcl core.
	Reorder configure.in for better 64-bit build configuration, replacing
	EXTRA_CFLAGS with CFLAGS. [Bug 874058]

2004-07-19  Zoran Vasiljevic <vasiljevic@users.sf.net>

	* win/tclwinThrd.c: redefined MASTER_LOCK to call TclpMasterLock.
	Fixes [Bug 987967]

2004-07-16  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIOCmd.c (Tcl_FcopyObjCmd): Corrected a typo in the
	generation of error messages and simplified by reusing data in a
	variable instead of retrieving the string again. Fixes [Bug 835289]

	* doc/OpenFileChnl.3: Added description of the behaviour of
	Tcl_ReadChars when its 'charsToRead' argument is set to -1. Fixes [Bug
	934511]

	* doc/CrtCommand.3: Added note that the arguments given to the command
	proc of a Tcl_CreateCommand are in utf8 since Tcl 8.1. Closing [Patch
	414778]

	* doc/ChnlStack.3: Removed the declaration that the interp argument to
	Tcl_(un)StackChannel can be NULL. This fixes [Bug 881220], reported by
	Marco Maggi <marcomaggi@users.sourceforge.net>.

	* tests/socket.test: Accepted two new testcases by Stuart Casoff
	<stwo@users.sourceforge.net> checking that -server and -async don't go
	together [Bug 796534]

	* unix/tclUnixNotfy.c (NotifierThreadProc): Accepted Joe Mistachkin's
	patch for [Bug 990500], properly closing the notifier thread when its
	exits.

2004-07-15  Andreas Kupries  <andreask@activestate.com>

	* unix/tclUnixThrd.c (TclpFinalizeMutex): Accepted Joe Mistachkin's
	patch for [Bug 990453], closing leakage of mutexes. They were not
	destroyed properly upon finalization.

2004-07-15  Zoran Vasiljevic <vasiljevic@users.sf.net>

	* generic/tclEvent.c (NewThreadProc): Backout of changes to fix [Bug
	770053]. See SF bugreport for more info.

	* generic/tclNotify.c (TclFinalizeNotifier): Added conditional
	notifier finalization based on the fact that an TclInitNotifier has
	been called for the current thread. This fixes [Bug 770053] again.
	Hopefully this time w/o unwanted side-effects.

2004-07-14  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.h (CHANNEL_INCLOSE):	   New flag. Set in Tcl_Close
	* generic/tclIO.c (Tcl_UnregisterChannel): while the close callbacks
	* generic/tclIO.c (Tcl_Close):		   are run. Checked in
	Tcl_Close and Tcl_Unregister to prevent recursive call of [close] in
	the close-callbacks. This is a possible error made by implementors of
	virtual filesystems based on 'tclvfs', thinking that they have to
	close the channel in the close handler for the filesystem.

2004-07-14  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c:
	* generic/tclIO.h:
	Not reverting, but #ifdef'ing the changes from May 19, 2004 out of the
	core. This removes the ***POTENTIAL INCOMPATIBILITY*** for channel
	drivers it introduced. This has become possible due to Expect gaining
	a BlockModeProc and now handling blockingg and non-blocking modes
	correctly. Thus [Bug 943274] is still fixed if a recent enough version
	of Expect is used.

	* doc/CrtChannel.3: Added warning about usage of a channel without a
	BlockModeProc.

2004-07-15  Andreas Kupries  <andreask@pliers.activestate.com>

	* generic/tclIOCmd.c (Tcl_PutsObjCmd): Added length check to the old
	depreceated newline syntax, to ensure that only "nonewline" is
	accepted. [Bug 985869] (mistachkin)

2004-07-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* README, generic/tcl.h, tools/tcl.wse.in:	      bumped to
	* unix/configure, unix/configure.in, unix/tcl.spec:   patchlevel
	* win/README.binary, win/configure, win/configure.in: 8.4.7

2004-07-13  Zoran Vasiljevic <vasiljevic@users.sf.net>

	* generic/tclEvent.c (NewThreadProc): Fixed broken build on Windows
	caused by missing TCL_THREAD_CREATE_RETURN. This is backported from
	HEAD. Thnx to Kevin Kenny for spotting this.

2004-07-03  Miguel Sofer <msofer@users.sf.net>

	* generic/tclExecute.c (ExprRoundFunc):
	* tests/expr-old.test (39.1): added support for wide integers to
	round(); [Bug 908375], reported by Hemang Lavana.

2004-07-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/regcomp.c (stid): correct minor pointer size error

	* generic/tclPipe.c (TclCreatePipeline): Add 2>@1 as a special
	* tests/exec.test: case redir of stderr to the result output.

2004-07-02  Vince Darley  <vincentdarley@users.sourceforge.net>

	* tests/fileSystem.test: new tests backported
	* win/tclWin32Dll.c: compilation fix for VC++5.2

2004-06-29  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* library/safe.tcl: Make sure that the temporary variable is
	local to the namespace and not inadvertently global. [Bug 981733]

2004-06-22  Zoran Vasiljevic <vasiljevic@users.sf.net>

	* generic/tclEvent.c:
	* generic/tclInt.h:
	* unix/tclUnixNotfy.c:
	* unix/tclUnixThrd.c:
	* win/tclWinThrd.c: See bug report for more information about what it
	does. [Bug 770053]

	* tests/unixNotfy.test: rewritten to use tcltest::threadReap to
	gracefully wait for the test thread to exit. Otherwise we got a race
	condition with main thread exiting before the test thread. This
	exposed the long-standing Tcl lib issue with resource
	garbage-collection on application exit.

2004-06-21  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tclWin32Dll.c (DllMain, _except_dllmain_detach_handler)
	(TclpCheckStackSpace, _except_checkstackspace_handler, TclWinCPUID)
	(_except_TclWinCPUID_detach_handler):
	* win/tclWinChan.c (Tcl_MakeFileChannel)
	(_except_makefilechannel_handler):
	* win/tclWinFCmd.c (DoRenameFile, _except_dorenamefile_handler)
	(DoCopyFile, _except_docopyfile_handler):
	Rework pushing of exception handler function pointer so that compiling
	with gcc -O3 works. Remove empty function call to avoid compiler
	warning. Mark the DllMain function as noinline to avoid compiler error
	from duplicated asm labels in generated code.

2004-06-14  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* tests/winDde.test: Fixed -async test
	* win/tclWinDde.c: Backported the fix from 8.5 to avoid hanging in the
	presence of applications that do not process Window messages.

2004-06-10  Andreas Kupries  <andreask@activestate.com>

	* generic/tclDecls.h:	     Regenerated on a unix box. The Win/DOS
	* generic/tclIntDecls.h:     EOLs from the last regen screwed up
	* generic/tclIntPlatDecls.h: compilation with an older gcc.
	* generic/tclPlatDecls.h:
	* generic/tclStubInit.c:

2004-06-10  Zoran Vasiljevic <vasiljevic@users.sf.net>

	* generic/tclIOUtil.c: partially corrected [Bug 932314]. Also,
	corrected return values of Tcl_FSChdir() to reflect those of the
	underlying platform-specific call. Originally, return codes were mixed
	with those of Tcl.

2004-06-08  Miguel Sofer <msofer@users.sf.net>

	* generic/tclCompile.c: handle warning [Bug 969066]

2004-06-05  Kevin B. Kenny  <kennykb@acm.org>

	* generic/tcl.h: Corrected Tcl_WideInt declarations so that the mingw
	build works again.
	* generic/tclDecls.h:			Changes to the tests for
	* generic/tclInt.decls:			clock frequency in Tcl_WinTime
	* generic/tclIntDecls.h:		so that any clock frequency is
	* generic/tclIntPlatDecls.h:		accepted provided that all
	* generic/tclPlatDecls.h:		CPU's in the system share a
	* generic/tclStubInit.c:		common chip, and hence,
	* tests/platform.test (platform-1.3):	presumably, a common clock.
	* win/tclWin32Dll.c (TclWinCPUID):	This change necessitated a
	* win/tclWinTest.c (TestwincpuidCmd)	small burst of assembly code
	* win/tclWinTime.c (Tcl_GetTime):	to read CPU ID information,
	which was added as TclWinCPUID in the internal Stubs. To test this
	code in the common case of a single-processor machine, a
	'testwincpuid' command was added to tclWinTest.c, and a test case in
	platform.test. Thanks to Jeff Godfrey and Richard Suchenwirth for
	reporting this bug. [Bug 976722]

2004-05-27  Kevin B. Kenny  <kennykb@acm.org>

	* tests/clock.test: Added a single test for the presence of %G in
	[clock format], and conditioned out the clock-10.x series if they're
	all going to fail because of a broken strftime() call. [Bug 961714]

2004-05-27  Reinhard Max  <max@suse.de>

	* generic/tclEncoding.c:
	* tests/encoding.test: added support and tests for translating
	embedded null characters between real nullbytes and the internal
	representation on input/output. [Bug 949905]

2004-05-26  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl:	Correction to debug prints and testing
	* library/tcltest/pkgIndex.tcl:	if TCLTEST_OPTIONS value. Corrected
	* tests/tcltest.test:		double increment of numTestFiles in
	-singleproc 1 configurations. Updated tcltest-19.1 to tcltest 2.1
	behavior. Corrected tcltest-25.3 to not falsely report a failure in
	tcltest.test. Bumped to tcltest 2.2.6. [Bugs 960560, 960926]

2004-05-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/http.n (http::config): add -urlencoding option (default utf-8)
	* library/http/http.tcl:     that specifies encoding conversion of
	* library/http/pkgIndex.tcl: args for http::formatQuery.  Previously
	* tests/http.test:	     undefined, RFC 2718 says it should be
	utf-8. 'http::config -urlencoding {}' returns previous behavior,
	which will throw errors processing non-latin-1 chars. Bumped http
	package to 2.5.0.

2004-05-25  Kevin Kenny  <kennykb@acm.org>

	* tests/winFCmd.test: Correct test for the presence of a CD-ROM so
	that it doesn't misdetect some other sort of filesystem with a
	write-protected root as being a CD-ROM drive. [Bug 918267]

2004-05-24  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclExecute.c (VerifyExprObjType): use GET_WIDE_OR_INT to
	properly have tclIntType used for smaller values. This corrects TclX
	bug 896727 and any other 3rd party extension that created math
	functions but was not yet WIDE_INT aware in them.

2004-05-24  Miguel Sofer  <msofer@users.sf.net>

	* doc/set.n: accurate description of name resolution process,
	referring to namespace.n for details [Bug 959180]

2004-05-22  Miguel Sofer  <msofer@users.sf.net>

	* generic/tclVar.c (TclObjUnsetVar2): backported fix [Bug 735335] and
	new (in tcl8.4) exteriorisations of [Bug 736729] due to the use of
	tclNsVarNameType obj types. The consequences of [Bug 736729] should be
	the same as in tcl8.3 and previous versions. The use of
	tclNsVarNameType objs is still disabled, pending a decision by the
	release manager.

2004-05-19  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* win/tclWinFile.c (TclpMatchInDirectory): fix for an issue where
	there was a sneak path from Tcl_DStringFree to SetErrorCode(0). The
	result was that the error code could be reset between a call to
	FindFirstFile and the check of its status return, leading to a bizarre
	error return of {POSIX unknown {No error}}. (Found in unplanned test -
	no incident logged at SourceForge.)

2004-05-19  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c: Fixed [SF Tcl Bug 943274]. This is the same problem
	* generic/tclIO.h: as [SF Tcl Bug 462317], see ChangeLog entry
	2001-09-26. The fix done at that time is incomplete. It is possible to
	get around it if the actual read operation is defered and not executed
	in the event handler itself. Instead of tracking if we are in an read
	caused by a synthesized fileevent we now track if the OS has delivered
	a true event = actual data and bypass the driver if a read finds that
	there is no actual data waiting. The flag is cleared by a short or
	full read. [[this bug amended 2004-07-14]]

2004-05-18  Kevin B. Kenny  <kennykb@acm.org>

	* compat/strftime.c (_fmt, ISO8601Week):
	* doc/clock.n:
	* tests/clock.test: Major rework to the handling of ISO8601 week
	numbers. Now passes all the %G and %V test cases on Windows, Linux and
	Solaris [Bugs 500285, 500389, and 852944]

2004-05-17  Kevin B. Kenny  <kennykb.@acm.org>

	* generic/tclInt.decls:	     Restored TclpTime_t kludge to all places
	* generic/tclIntPlatDecls.h: where it appeared before the changes of
	* unix/tclUnixPort.h	     14 May, because use of native time_t in
	* unix/tclUnixTime.h	     its place requires the 8.5 header
	* win/tclWinTime.h:	     reforms. [Bug 955146]

2004-05-17  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/OpenFileChnl.3: Documented type of 'offset' argument to Tcl_Seek
	was wrong. [Bug 953374]

2004-05-14  Kevin B. Kenny  <kennykb@acm.org>

	* generic/tclInt.decls:	     Promoted TclpLocaltime and TclpGmtime
	* generic/tclIntDecls.h:     from Unix-specific stubs to the generic
	* generic/tclIntPlatDecls.h: internal Stubs table. Reran 'genstubs'
	* generic/tclStubInit.c:
	* unix/tclUnixPort.h:

	* generic/tclClock.c: Changed a buggy 'GMT' timezone specification to
			      the correct 'GMT0'. [Bug 922848]

	* unix/tclUnixThrd.c: Moved TclpGmtime and TclpLocaltime to
			      unix/tclUnixTime.c where they belong.

	* unix/tclUnixTime.c (TclpGmtime, TclpLocaltime, TclpGetTimeZone,
	(ThreadSafeGMTime[removed], ThreadSafeLocalTime[removed],
	(SetTZIfNecessary, CleanupMemory): Restructured to make sure that the
	same mutex protects all calls to localtime, gmtime, and tzset. Added a
	check in front of those calls to make sure that the TZ env var hasn't
	changed since the last call to tzset, and repeat tzset if necessary.
	[Bug 940278] Removed a buggy test of the Daylight Saving Time
	information in 'gettimeofday' in favor of applying 'localtime' to a
	known value. [Bug 922848]

	* tests/clock.test (clock-3.14): Added test to make sure that changes
	to $env(TZ) take effect immediately.

	* win/tclWinTime.c (TclpLocaltime, TclpGmtime): Added porting layer
	for 'localtime' and 'gmtime' calls.

2004-05-10  David Gravereaux <davygrvy@pobox.com>

	* win/tclWinPipe.c (BuildCommandLine): Append a space when the path
	got primed.
	(TclpCreateProcess): When under NT, with no console, and executing a
	DOS application, the path priming does not need an ending space as
	BuildCommandLine() will append one for us.

2004-05-07  Miguel Sofer <msofer@users.sf.net>

	* doc/unset.n: added upvar.n to the "see also" list

2004-05-05  David Gravereaux <davygrvy@pobox.com>

	* generic/tclEvent.c: TclSetLibraryPath's use of caching the stringrep
	of the pathPtr object to TclGetLibraryPath called from another thread
	was ineffective if the original's stringrep had been invalidated as
	what happens when it gets muted to a list.

	* generic/tclEncoding.c: Added FreeEncoding(systemEncoding) in
	TclFinalizeEncodingSubsystem because its ref count was incremented in
	TclInitEncodingSubsystem.

	* win/tclWin32Dll.c: Structured Exception Handling added around
	Tcl_Finalize called from DllMain's DLL_PROCESS_DETACH. We can't be
	100% assured that Tcl is being unloaded by the OS in a stable
	condition and we need to protect the exit handlers should the stack be
	in a hosed state. AT&T style assembly for SEH under MinGW included,
	too. [Patch 858493]

	Also added DisableThreadLibraryCalls() for the DLL_PROCESS_ATTACH
	case. We're not interested in knowing about DLL_THREAD_ATTACH, so
	disable the notices.

	* generic/tclInt.h:
	* generic/tclThread.c:
	* generic/tclEvent.c:
	* unix/tclUnixThrd.c:
	* win/tclWinThrd.c:  Provisions made so masterLock, initLock,
	allocLock and joinLock mutexes can be recovered during Tcl_Finalize.

	* win/tclWinSock.c:
	(SocketThreadExitHandler): Don't call TerminateThread when
	WaitForSingleObject returns a timeout. Tcl_Finalize called from
	DllMain will pause all threads. Trust that the thread will get the
	close notice at a later time if it does ever wake up before being
	cleaned up by the system anyway.
	(SocketEventProc): connect errors should fire both the readable and
	writable handlers because this is how it works on UNIX. [Bug 794839]

	* win/coffbase.txt: Added the tls extension to the list of preferred
	load addresses.

2004-05-05  Don Porter  <dgp@users.sourceforge.net>

	* tests/unixInit.test (unixInit-2.10): Test correction for Mac OSX.
	Be sure to consistently compare normalized path names. Thanks to
	Steven Abner (tauvan). [Bug 948177]

2004-05-05  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/CrtObjCmd.3: Remove reference to Tcl_RenameCommand; there is no
	such API. [Bug 848440]

2004-05-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIOUtil.c (Tcl_FSChdir):  Work-around crash condition
	* tests/winFCmd.test (winFCmd-16.12): triggered when $HOME is
	volumerelative (ie 'C:').

	* tests/fileName.test (filename-12.9): use C:/ instead of the first
	item in file volumes - that's usually A:/, which for most will have
	nothing in it.

2004-05-04  Don Porter  <dgp@users.sourceforge.net>

	* tests/tcltest.test: Test corrections for Mac OSX.  Thanks to Steven
	Abner (tauvan). [Bug 947440]

2004-05-03  Andreas Kupries  <andreask@activestate.com>

	Applied [SF Tcl Patch 868853], fixing a mem leak in TtySetOptionProc.
	Report and Patch provided by Stuart Cassoff <stwo@users.sf.net>.

2004-05-03  Kevin Kenny  <kennykb@acm.org>

	* win/tclWin32Dll.c (TclpCheckStackSpace):
	* tests/stack.test (stack-3.1): Fix for undetected stack overflow in
	TclReExec on Windows. [Bug 947070]

2004-05-03  Don Porter  <dgp@users.sourceforge.net>

	* library/init.tcl:	Corrected unique prefix matching of
	interactive command completion in [unknown]. [Bug 946952]

2004-05-02  Miguel Sofer <msofer@users.sf.net>

	* generic/tclProc.c (TclObjInvokeProc):
	* tests/proc.test (proc-3.6): fix for bad quoting of multi-word proc
	names in error messages [Bug 942757]

2004-04-23  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c (Tcl_SetChannelOption): Fixed [Bug 930851]. When
	changing the eofchar we have to zap the related flags to prevent them
	from prematurely aborting the next read.

2004-04-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/configure:
	* win/configure.in: define TCL_LIB_FLAG, TCL_BUILD_LIB_SPEC,
	TCL_LIB_SPEC and TCL_PACKAGE_PATH in tclConfig.sh.

2004-04-06  Don Porter  <dgp@users.sourceforge.net>

	* tests/unixInit.test (unixInit-3.1):	Default encoding on Darwin
	systems is utf-8. Thanks to Steven Abner (tauvan). [Bug 928808]

2004-04-06  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* tests/cmdAH.test (cmdAH-18.2): Added constraint because
	access(...,X_OK) is defined to be permitted to be meaningless when
	running as root, and OSX exhibits this. [Bug 929892]

2004-04-02  Don Porter  <dgp@users.sourceforge.net>

	* tests/tcltest.test: Corrected constraint typos: "nonRoot" ->
	"notRoot". Thanks to Steven Abner (tauvan). [Bug 928353]

2004-03-31  Don Porter  <dgp@users.sourceforge.net>

	* doc/msgcat.n: Clarified message catalog file encodings. [Bug 811457]
	* library/msgcat/msgcat.tcl ([mcset], [ConvertLocale], [Init]):
	Corrected [mcset] to be able to successfully set a translation to
	the empty string. [mcset $loc $src {}] was incorrectly set the $loc
	translation of $src back to $src. Also changed [ConvertLocale] to
	minimally require a non-empty "language" part in the locale value. If
	not, an error raised prompts [Init] to keep looking for a valid locale
	value, or ultimately fall back on the "C" locale. [Bug 811461]
	* library/msgcat/pkgIndex.tcl:	Bump to msgcat 1.3.2.

2004-03-31  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclObj.c (HashObjKey): Make sure this hashes the whole
	string rep of the object, instead of missing the last character.

2004-03-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclInt.h:
	* generic/tclEncoding.c (TclFindEncodings, Tcl_FindExecutable):
	* mac/tclMacInit.c (TclpInitLibraryPath):   Correct handling of UTF
	* unix/tclUnixInit.c (TclpInitLibraryPath): data that is actually
	* win/tclWinFile.c (TclpFindExecutable):    "clean", allowing the
	* win/tclWinInit.c (TclpInitLibraryPath):   loading of Tcl from paths
	that contain multi-byte chars on Windows [Bug 920667]

2004-03-28  Miguel Sofer <msofer@users.sf.net>

	* generic/tclCompile.c (TclCompileScript): corrected possible segfault
	when a compilation returns TCL_OUTLINE_COMPILE after having grown the
	compile environment. [Bug 925121]

2004-03-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinInt.h: define VER_PLATFORM_WIN32_CE if not already set.
	* win/tclWinInit.c (TclpSetInitialEncodings): recognize WIN32_CE
	as a unicode (WCHAR) platform.

2004-03-15  Miguel Sofer <msofer@users.sf.net>

	* generic/tclCompile.c (TclCompileScript):
	* tests/compile.test (compile-3.5): corrected wrong test and behaviour
	in the earlier fix for [Bug 705406]; Don Porter reported this as [Bug
	735055], and provided the solution. Fixed in HEAD on 2003-05-09, but
	backport to 8-4-branch was wrongly omitted; re-reported as [Bug
	916795] by Roy Terry, diagnosed by dgp.

2004-03-08  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclFileName.c:  Fix to 'glob -path' near the root
	* tests/fileName.test:	  of the filesystem. [Bug 910525]

2004-03-01  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.6 TAGGED FOR RELEASE ***

	* unix/tcl.m4 (SC_CONFIG_CFLAGS):	Allow 64-bit enabling on
	IRIX64-6.5* systems. [Bug 218561]
	* unix/configure:	autoconf-2.13

	* generic/tclCmdMZ.c (TclCheckInterpTraces):	The TIP 62
	* generic/tclTest.c (TestcmdtraceCmd):	implementation introduced a
	* tests/basic.test (basic-39.10):	bug by testing the CallFrame
	level instead of the iPtr->numLevels level when deciding what traces
	created by Tcl_Create(Obj)Trace to call. Added test to expose the
	error, and made fix. [Request 462580]

2004-02-26  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: fixed copyright year in Tcl.framework Info.plist

2004-02-25  Don Porter  <dgp@users.sourceforge.net>

	* tests/basic.test:	Made several tests more robust to the
	* tests/cmdMZ.test:	list-quoting of path names that might
	* tests/exec.test:	contain Tcl-special chars like { or [.
	* tests/io.test:	Should help us sort out Tcl Bug 554068.
	* tests/pid.test:
	* tests/socket.test:
	* tests/source.test:
	* tests/unixInit.test:

2004-02-25  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tclUnixChan.c (TcpGetOptionProc): Stop memory leak with very
	long hostnames. [Bug 888777]

2004-02-25  David Gravereaux <davygrvy@pobox.com>

	* tests/winPipe.test:
	* win/tclWinPipe.c: backport of BuildCommandLine changes to mirror
	msvcrt's parse_cmdline() rules of quoting.

2004-02-19  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tclWinInit.c (AppendEnvironment): Use the tail component of the
	passed in lib path instead of just blindly using lib+4. That worked
	when lib was "lib/..." but fails for other values. Thanks go to
	Patrick Samson for pointing this out.

2004-02-17  Don Porter  <dgp@users.sourceforge.net>

	* doc/tcltest.n:
	* library/tcltest/tcltest.tcl:	Changed -verbose default value to
	{body error} so that detailed information on unexpected errors in
	tests is provided by default, even after the fix for [Bug 725253]

2004-02-17  Jeff Hobbs  <jeffh@ActiveState.com>

	(reverted due to test failures on Solaris, but not Win/Lin :/)
	* generic/tclIOUtil.c: backport of rewrite of generic file
	normalization code to cope with links followed by '..'. [Bug 849514],
	and parts of [859251]

	* tests/unixInit.test: unixInit-7.1
	* unix/tclUnixInit.c (TclpInitPlatform): ensure the std fds exist to
	prevent crash condition [Bug 772288]

2004-02-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclCmdMZ.c (TclTraceExecutionObjCmd)
	(TclTraceCommandObjCmd): fix possible mem leak in trace info.

2004-02-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:	    update patchlevel to 8.4.6
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure, unix/configure.in, unix/tcl.spec:
	* win/README.binary, win/configure, win/configure.in:

	* unix/tcl.m4: update HP-11 build libs setup

2004-02-06  Don Porter  <dgp@users.sourceforge.net>

	* doc/clock.n:	Removed reference to non-existent [file ctime].

2004-02-04  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl:	Corrected references to
	non-existent $name variable in [cleanupTests]. [Bug 833637]

2004-02-03  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl:	Corrected parsing of single
	command line argument (option with missing value) [Bug 833910]
	* library/tcltest/pkgIndex.tcl: Bump to version 2.2.5.

2004-02-02  David Gravereaux <davygrvy@pobox.com>

	* generic/tclIO.c (Tcl_Ungets): fixes improper filling of the channel
	buffer. [Bug 405995]

2004-01-13  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclFileName.c (Tcl_GlobObjCmd):  Latest changes to
	management of the interp result by Tcl_GetIndexFromObj() exposed
	improper interp result management in the [glob] command procedure.
	Corrected by adopting the Tcl_SetObjResult(Tcl_NewStringObj) pattern.
	This stopped a segfault in test filename-11.36.

2004-01-13  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclIndexObj.c (Tcl_GetIndexFromObjStruct, Tcl_WrongNumArgs):
	Create fresh objects instead of using the one currently in the
	interpreter, which isn't guaranteed to be fresh and unshared. The
	cost for the core will be minimal because of the object cache, and
	this fixes. [Bug 875395]

2004-01-09  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclIOUtil.c: fix to infinite loop in TclFinalizeFilesystem.
	[Bug 873311]

2003-12-17  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tclBinary.c (DeleteScanNumberCache): fixed crashing bug when
	numeric scan-value cache contains NULL value.

2003-12-17  Zoran Vasiljevic  <zv@archiware.com>

	* generic/tclIOUtil.c: fixed 2 memory (object) leaks. This fixes [Bug
	839519]

2003-12-12  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclCmdAH.c: fix to normalization of non-existent user name
	('file normalize ~nobody') [Bug 858937]

2003-12-09  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/tclUnixPort.h:	#ifdef'd out declarations of errno which
	* tools/man2tcl.c:	are known to cause problems with recent
				glibc. [Bug 852369]

2003-12-03  Don Porter  <dgp@users.sourceforge.net>

	* generic/tcl.h:	Bumped patch level to 8.4.5.1 to distinguish
	* unix/configure.in:	CVS snapshots from 8.4.5 release.
	* unix/tcl.spec:
	* win/configure.in:

	* unix/configure:	autoconf (2.13)
	* win/configure:

2003-12-02  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tclBinary.c (DeleteScanNumberCache, ScanNumber): Made
	the numeric scan-value cache have proper references to the objects
	within it so strange patterns of writes won't cause references to
	freed objects. Thanks to Paul Obermeier for the report. [Bug 851747]

2003-12-01  Miguel Sofer <msofer@users.sf.net>

	* doc/lset.n: fix typo [Bug 852224]

2003-11-21  Don Porter  <dgp@users.sourceforge.net>

	*** 8.4.5 TAGGED FOR RELEASE ***

	* tests/windFCmd.test (winFCmd-16.10):	Corrected failure to
	initialize variable $dd that caused test suite failure.

2003-11-20  Miguel Sofer <msofer@users.sf.net>

	* generic/tclVar.c: fix flag bit collision between LOOKUP_FOR_UPVAR
	and TCL_PARSE_PART1 (deprecated) [Bug 835020]

2003-11-20  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclIOUtil.c:
	* tests/winFCmd.test: fix to [Bug 845778] - Infinite recursion on [cd]
	(Windows only bug).

2003-11-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* changes: updated for 8.4.5 release

2003-11-17  Don Porter  <dgp@users.sourceforge.net>

	* generic/regcomp.c:	Backported regexp bug fixes and tests. Thanks
	* generic/tclTest.c:	to Pavel Goran and Vince Darley.
	* tests/reg.test:	[Bugs 230589, 504785, 505048, 703709, 840258]

2003-11-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/cmdMZ.test (cmdMZ-1.4): change to nonPortable as more
	systems are using permissions caching, and this isn't really a Tcl
	controlled issue.

2003-11-11  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/configure:
	* unix/tcl.m4: improve AIX --enable-64bit handling

2003-11-10  Don Porter  <dgp@users.sourceforge.net>

	* tests/unixInit.test (unixInit-2.10): re-enabled.
	* unix/tclUnixInit.c (TclpInitLibraryPath):	Alternative fix
	* win/tclWinInit.c (TclpInitLibraryPath):	for [Bug 832657]
	that should not run afoul of startup constraints.

	* library/dde/pkgIndex.tcl:	Added safeguards so that registry
	* library/reg/pkgIndex.tcl:	and dde packages are not offered
	* win/tclWinDde.c:	on non-Windows platforms.  Bumped to
	* win/tclWinReg.c:	registry 1.1.3 and dde 1.2.2.

2003-11-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/unixInit.test (unixInit-2.10): mark as knownBug
	* generic/tclEncoding.c (TclFindEncodings): revert patch from
	2003-11-05.  It wasn't valid in the sensitive startup init phase
	and broke Windows from working at all.

2003-11-07  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: optimized builds define NDEBUG to turn off
	ThreadAlloc range checking.

2003-11-05  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclEncoding.c (TclFindEncodings):	Normalize the path
	of the executable before passing to TclpInitLibraryPath() to avoid
	buggy handling of paths containing "..". [Bug 832657]
	* tests/unixInit.test (unixInit-2.10): New test for fixed bug.

2003-11-04  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: added 'test' target.

2003-10-31  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclTest.c: fix test suite memory leak (backport error)
	* unix/tclUnixFile.c: ensure translated path (required for correct
	error messages) is freed in both code paths.

2003-10-23  Andreas Kupries  <andreask@activestate.com>

	* unix/tclUnixChan.c (Tcl_MakeFileChannel): Applied [Patch 813606]
	fixing [Bug 813087]. Detection of sockets was off for Mac OS X which
	implements pipes as local sockets. The new code ensures that only IP
	sockets are detected as such.

2003-10-22  Andreas Kupries  <andreask@activestate.com>

	* win/tclWinSock.c (TcpWatchProc): Watch for FD_CLOSE too when asked
	for writable events by the generic layer.
	(SocketEventProc): Generate a writable event too when a close is
	detected.

	Together the changes fix [Bug 599468].

2003-10-22  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIOUtil.c (FsListMounts, FsAddMountsToGlobResult): New
	functions. See below for context.
	(Tcl_FSMatchInDirectory): Modified to call on the new functions
	(above) to handle the mountpoints in the glob'bed directory correctly.
	Part of the patch by Vincent Darley to solve the [Bug 800106] for the
	8.4.x series.

	* generic/tcl.h (TCL_GLOB_TYPE_MOUNT): New definition. Part of the
	patch by Vincent Darley to solve [Bug 800106] for the 8.4.x series.

2003-10-22  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tclCmdAH.c (Tcl_FileObjCmd): Changed FILE_ prefix for option
	enumeration to FCMD_ to prevent collision with symbols defined by
	Cygwin/Mingw32 on NT. [Bug 822528]

2003-10-21   Daniel Steffen  <das@users.sourceforge.net>

	* tools/tcltk-man2html.tcl: fixed incorrect html generated for .IP/.TP
	lists, now use <DL><DT>...<DD>...<P><DT>...<DD>...</DL> instead of
	illegal <DL><P><DT>...<DD>...<P><DT>...<DD>...</DL>. Added skipping of
	directives directly after .TP to avoid them being used as item
	descriptions, e.g. .TP\n.VS in clock.n.

2003-10-21  Andreas Kupries  <andreask@activestate.com>

	* win/tclWinPipe.c (BuildCommandLine): Applied the patch coming with
	[Bug 805605] to the code, fixing the incorrect use of ispace noted by
	Ronald Dauster <ronaldd@users.sourceforge.net>.

2003-10-14  David Gravereaux <davygrvy@pobox.com>

	* win/tclAppInit.c (sigHandler): Punt gracefully if exitToken has
	already been destroyed.

2003-10-13  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclCmdMZ.c:
	* tests/regexp.test: fix to [Bug 823524] in regsub; added three new
	tests.

2003-10-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tclUnixTest.c (TestalarmCmd): don't bother checking return
	value of alarm. [Bug 664755] (english)

2003-10-08  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclBasic.c:	Save and restore the iPtr->flag bits that
	control the state of errorCode and errorInfo management when calling
	"leave" execution traces, so that all error information of the traced
	command is still available whether traced or not. Thanks to Yahalom
	Emet. [Bug 760947]

2003-10-08  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tclTest.c (TestNumUtfCharsCmd): Command to allow finer
	access to Tcl_NumUtfChars for testing.
	* generic/tclUtf.c (Tcl_NumUtfChars): Corrected string length
	determining when the length parameter is negative; the terminator is a
	zero byte, not (necessarily) a \u0000 character. [Bug 769812]

2003-10-07  Don Porter  <dgp@users.sourceforge.net>

	* tests/exec.test:		Corrected temporary file management
	* tests/fileSystem.test:	issues uncovered by -debug 1 test
	* tests/io.test:		operations.  Also backported some
	* tests/ioCmd.test:		other fixes from the HEAD.
	* tests/pid.test:		[Bugs 675605, 675655, 675659]
	* tests/socket.test:
	* tests/source.test:

	* tests/fCmd.test:	Run tests with the [temporaryDirectory] as
	the current directory, so that tests can depend on ability to write
	files.	[Bug 575837]

	* doc/OpenFileChnl.3:	Updated Tcl_Tell and Tcl_Seek documentation
	to reflect that they now return Tcl_WideInt (TIP 72) [Bug 787537]

	* tests/io.test:	Corrected several tests that failed when paths
	* tests/ioCmd.test:	included regexp-special chars. [Bug 775394]

2003-10-06  Don Porter  <dgp@users.sourceforge.net>

	* tests/regexp.test:		Matched [makeFile] with [removeFile].
	* tests/regexpComp.test:	[Bug 675652]

	* tests/fCmd.test (fCmd-8.2):	Test only that tilde-substitution
	happens, not for any particular result. [Bug 685991]

	* unix/tcl.m4 (SC_PATH_TCLCONFIG):	Corrected search path so
	that alpha and beta releases of Tcl are not favored. [Bug 608698]

	* tests/reg.test:	Corrected duplicate test names.
	* tests/resource.test:	[Bugs 710370, 710358]

	* tests/cmdMZ.test:	Updated [package require tcltest] lines to
	* tests/fileSystem.test:	indiciate that these test files
	* tests/notify.test:	use features of tcltest 2. [Bug 706114]
	* tests/parseExpr.test:
	* tests/unixNotfy.test:

2003-10-06  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclFileName.c:
	* generic/tclIOUtil.c: backport of volumerelative file normalization
	and 'file join' inconsistency fixes [Bug 767834, 813273].

2003-10-04  Chengye Mao <chengye.geo@yahoo.com>

	* win/tclWinPipe.c: fixed a bug in BuildCommandLine.
	This bug built a command line with a missing space between
	tclpipe.dll and the following arguments.  It caused error
	in Windows 98 when exec command.com (e.g. dir) [Bug 789040]

2003-10-03  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclBasic.c:	Fixed error in ref count management of command
	* generic/tclCmdMZ.c:	and execution traces that caused access to
	freed memory in trace-32.1. [Bug 811483]

2003-10-03  Vince Darley  <vincentdarley@users.sourceforge.net>

	* tests/fileName.test:
	* tests/winFCmd.test:
	* doc/FileSystem.3: backported various test and documentation changes
	from HEAD. Backport of actual code fixes to follow.

2003-10-02  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bumped patch level to 8.4.5 to prepare
	* generic/tcl.h:	for next patch release.
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf (2.13)
	* win/configure:

	* library/http/http.tcl:	Bumped to http 2.4.5
	* library/http/pkgIndex.tcl:

2003-10-01  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: fixed redo prebinding bug when DESTDIR="".
	* mac/tclMacResource.c: fixed possible NULL dereference (bdesgraupes).

2003-09-29  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclBasic.c (CallCommandTraces):	Added safety bit
	* tests/trace.test:	masking to prevent any of the bit values
	TCL_TRACE_*_EXEC from leaking into the flags field of any Command
	struct. This does not fix [Bug 811483] but helps to contain some of
	its worst symptoms. Also backported the corrections to test trace-28.4
	from Vince Darley.

2003-09-29  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* library/http/http.tcl (geturl): Correctly check the type of
	boolean-valued options. [Bug 811170]

	* unix/tcl.m4 (SC_ENABLE_FRAMEWORK): Added note to make it clearer
	that this is an OSX feature, not a general Unix feature. [Bug 619440]

2003-09-28  David Gravereaux <davygrvy@pobox.com>

	* win/tclWinPipe.c: The windows port of expect can call
	TclWinAddProcess before any of the other pipe functions. Added a
	missing PipeInit() call to make sure the initialization happens.

2003-09-25  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: ensure SYMROOT exists if OBJROOT is overridden on
	command line. Replaced explict use of /usr/bin by ${BINDIR}.

2003-09-23  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c:			Fixed [Bug 807243] where
	* tests/trace.test (trace-31,32.*):	the introspection results
	of both [trace info command] and [trace info execution] were getting
	co-mingled.  Thanks to Mark Saye for the report.

	* library/init.tcl (auto_load, auto_import):  Expanded Eric Melski's
	2000-01-28 fix for [Bug 218871] to all potentially troubled uses of
	[info commands] on input data, where glob-special characters could
	cause problems.

2003-09-19  Miguel Sofer <msofer@users.sf.net>

	* generic/tclExecute.c: adding (DE)CACHE_STACK_INFO() pairs to protect
	all calls that may cause traces on ::errorInfo or ::errorCode to
	corrupt the stack [Bug 804681]

2003-09-10  Don Porter  <dgp@users.sourceforge.net>

	* library/opt/optparse.tcl:	Overlooked dependence of opt 0.4.4
	* library/opt/pkgIndex.tcl:	on Tcl 8.2.  Bumped to opt 0.4.4.1.

2003-09-01  Zoran Vasiljevic <zoran@archiware.com>

	* generic/tclIOUtil.c: backported fix from HEAD [Bug 788780]

2003-08-27  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclUtil.c:	Corrected [Bug 411825] and other bugs in
	TclNeedSpace() where non-breaking space (\u00A0) and backslash-escaped
	spaces were handled incorrectly.
	* tests/util.test:	Added new tests util-8.[2-6].

2003-08-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinInit.c: recognize amd64 and ia32_on_win64 cpus and
	Windows CE platform.

2003-08-06  Don Porter  <dgp@users.sourceforge.net>

	* library/msgcat/msgcat.tcl:	Added escape so that non-Windows
	* library/msgcat/pkgIndex.tcl:	platforms do not try to use the
	registry package.  This can save a costly and pointless package
	search. Bumped to 1.3.1. Thanks to Dave Bodenstab. [Bug 781609]

2003-08-05  Miguel Sofer <msofer@users.sf.net>

	* generic/tclExecute.c (INST_INVOKE, INST_EVAL, INST_PUSH_RESULT):
	added a Tcl_ResetResult(interp) at each point where the interp's
	result is pushed onto the stack, to avoid keeping an extra reference
	that may cause costly Tcl_Obj duplication. Detected by Franco Violi,
	analyzed by Peter Spjuth and Donal Fellows. [Bug 781585]

2003-07-24  Reinhard Max  <max@suse.de>

	* library/package.tcl: Fixed a typo that broke pkg_mkIndex -verbose.

	* tests/pkgMkIndex.test: Added a test for [pkg_mkIndex -verbose].

2003-07-23  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in: changes to html-tcl & html-tk targets for
	compatibility with non-gnu makes.

	* unix/Makefile.in: added macosx/README to dist target.

2003-07-23  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tclWinReg.c (OpenSubKey): Backported fix for [Bug 775976] which
	causes the registry set command to fail when built with VC7.
	* library/reg/pkgIndex.tcl: Incremented the version to 1.1.2.

2003-07-21  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.4 TAGGED FOR RELEASE ***

	* changes: updated for 8.4.4 release

2003-07-18  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: added option to allow installing manpages in
	addition to default html help.

2003-07-18  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/Utf.3: Tightened up documentation of Tcl_UtfNext and Tcl_UtfPrev
	to better match the behaviour. [Bug 769895]

2003-07-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIOUtil.c: correct MT-safety issues with filesystem
	records. [Bug 753315] (vasiljevic)

	* library/http/pkgIndex.tcl: merged to v2.4.4 from head
	* library/http/http.tcl: add support for user:pass info in URL.
	* tests/http.test:	 [Bug 759888] (shiobara)

2003-07-18  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclBasic.c:	Corrected several instances of unsafe
	* generic/tclCompile.c:	truncation of UTF-8 strings that might break
	* generic/tclProc.c:	apart a multi-byte character. [Bug 760872]
	* library/init.tcl:
	* tests/init.test:

	* doc/tcltest.n:		Restored the [Eval] proc to replace
	* library/tcltest/tcltest.tcl:	the [::puts] command when either the
	-output or -error option for [test] is in use, in order to capture
	data written to the output or error channels for comparison against
	what is expected. This is easier to document and agrees better with
	most user expectations than the previous attempt to replace [puts]
	only in the caller's namespace. Documentation made more precise on the
	subject. [Bug 706359]

	* doc/AddErrInfo.3:	Improved consistency of documentation by using
	* doc/CrtTrace.3:	"null" everywhere to refer to the character
	* doc/Encoding.3:	'\0', and using "NULL" everywhere to refer to
	* doc/Eval.3:		the value of a pointer that points to nowhere.
	* doc/GetIndex.3:	Also dropped references to ASCII that are no
	* doc/Hash.3:		longer true, and standardized on the
	* doc/LinkVar.3:	hyphenated spelling of "null-terminated".
	* doc/Macintosh.3:
	* doc/OpenFileChnl.3:
	* doc/SetVar.3:
	* doc/StringObj.3:
	* doc/Utf.3:

	* doc/CrtSlave.3 (Tcl_MakeSafe):  Removed warning about possible
	deprecation (no TIP on that).

2003-07-17  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: added var to allow overriding of tclsh used during
	html help building (Landon Fuller).

2003-07-16  Mumit Khan  <khan@nanotech.wisc.edu>

	* generic/tclIOUtil.c (SetFsPathFromAny): Add Cygwin specific code to
	convert POSIX filename to native format.
	* generic/tclFileName.c (Tcl_TranslateFileName): And remove from here.
	(TclDoGlob): Adjust for cygwin and append / for dirs instead of \
	* win/tclWinFile.c (TclpObjChdir): Use chdir on Cygwin. [Patch 679315]

2003-07-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/safe.tcl (FileInAccessPath): normalize paths before
	comparison. [Bug 759607] (myers)

	* unix/tclUnixNotfy.c (NotifierThreadProc): correct size of found and
	word vars from int to long. [Bug 767578] (hgo)

2003-07-16  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/CrtSlave.3 (Tcl_MakeSafe): Updated documentation to strongly
	discourage use. IMHO code outside the core that uses this function is
	a bug... [Bug 655300]

2003-07-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tcl.h:       Add recognition of -DTCL_UTF_MAX=6 on the
	* generic/regcustom.h: make line to support UCS-4 mode. No config arg
	at this time, as it is not the recommended build mode.

	* generic/tclPreserve.c: In Result and Preserve'd routines, do not
	* generic/tclUtil.c:	 assume that ckfree == free, as that is not
	* generic/tclResult.c:	 always true. [Bug 756791] (fuller)

2003-07-16  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/Makefile.in: Don't define TCL_DBGX symbol for every compile.
	Instead, define TCL_PIPE_DLL only when compiling tclWinPipe.c. This
	will break other build systems, so they will need to remove the
	TCL_DBGX define and replace it with a define for TCL_PIPE_DLL.
	* win/makefile.vc: Ditto.
	* win/tclWinPipe.c (TclpCreateProcess): Remove PREFIX_IDENT and
	DEBUG_IDENT from top of file. Use TCL_PIPE_DLL passed in from build
	env instead of trying to construct the dll name from already defined
	symbols. This approach is more flexible and better in the long run.

2003-07-16  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclFileName.c (Tcl_GlobObjCmd):	[Bug 771840]
	* generic/tclIOUtil.c (Tcl_FSConvertToPathType):[Bug 771947]
	* unix/tclUnixFCmd.c (GetModeFromPermString):	[Bug 771949]
	Silence compiler warnings about unreached lines.

	* library/tcltest/tcltest.tcl (ProcessFlags):	Corrected broken call
	* library/tcltest/pkgIndex.tcl:			to [lrange]. Bumped to
	version 2.2.4. [Bug 772333]

2003-07-15  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/dltest/pkga.c (Pkga_EqObjCmd): Fix typo that was causing a
	crash in load.test.

2003-07-15  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/array.n: Added some examples from David Welton [Patch 763312]

2003-07-15  Don Porter  <dgp@users.sourceforge.net>

	* doc/http.n:  Updated SYNOPSIS to match actual syntax of commands.
	[Bug 756112]

	* unix/dltest/pkga.c:	Updated to not use Tcl_UtfNcmp and counted
	strings instead of strcmp (not defined in any #include'd header) and
	presumed NULL-terminated strings.

	* README:		Bumped patch level to 8.4.4 in anticipation
	* generic/tcl.h:	of another patch release.
	* tools/tcl.wse.in:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure.in:

	* unix/configure:	autoconf (2.13)
	* win/configure:

	* generic/tclCompCmds.c (TclCompileIfCmd):  Prior fix of Bug 711371
	on 2003-04-07 introduced a buffer overflow. Corrected. [Bug 771613]

2003-07-15  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tclCmdIL.c (SortCompare): Cleared up confusing error
	message. [Bug 771539]

2003-07-15  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Makefile: Rewrote buildsystem for Mac OS X framework build to
	be purely make driven; in order to become independent of Apple's
	closed-source IDE and build tool. The changes are intended to be
	transparent to the Makefile user, all existing make targets and cmd
	line variable overrides should continue to work. Changed build to only
	include tcl specific html help in Tcl.framework, the tk specific html
	help is now included in Tk.framework.

	* macosx/Tcl.pbproj/project.pbxproj:
	* macosx/Tcl.pbproj/jingham.pbxuser: Changed to purely call through to
	the make driven buildsystem; Tcl.framework is no longer assembled by
	ProjectBuilder. Set default SYMROOT in target options to simplify
	setting up PB (manually setting common build folder for tcl & tk no
	longer needed).

	* tools/tcltk-man2html.tcl: Added options to allow building only the
	tcl or tk html help files; the default behaviour with none of the new
	options is to build both, as before.

	* unix/Makefile.in: Added targets for building only the tcl or tk help.

	* macosx/README (new): Tcl specific excerpts of tk/macosx/README.

	* generic/tcl.h: Updated reminder comment about editing
	macosx/Tcl.pbproj/project.pbxproj when version number changes.

2003-07-11  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/binary.test (binary-46.*): Tests to help enforce the current
	behaviour.
	* doc/binary.n: Documented that [binary format a] and [binary scan a]
	do encoding conversion by dropping high bytes, unlike the rest of
	the core. [Bug 735364]

2003-07-11  Don Porter  <dgp@users.sourceforge.net>

	* library/package.tcl:	Corrected [pkg_mkIndex] bug reported on
	comp.lang.tcl. The indexer was searching for newly indexed packages
	instead of newly provided packages.

2003-07-04  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/expr.n: Tighten up the wording of some operations. [Bug 758488]

	* tests/cmdAH.test: Made tests of [file mtime] work better on FAT
	filesystems. [Patch 760768]  Also a little general cleanup.

2003-06-25  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4 (SC_CONFIG_CFLAGS): Add -ieee when compiling with cc and
	add -mieee when compiling with gcc under OSF1-V5 "Tru64" systems. [Bug
	748957]

2003-06-24  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/encoding.n: Corrected the docs to say that [source] uses the
	system encoding, which it always did anyway (since 8.1) [Bug 742100]

2003-06-23  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclFCmd.c: fix to bad error message when trying to do 'file
	copy foo ""'. [Bug 756951]
	* tests/fCmd.test: added two new tests for the bug.

	* doc/FileSystem.3: documentation fix [Bug 720634]

2003-06-18  Miguel Sofer <msofer@users.sf.net>

	* generic/tclNamesp.c (Tcl_Export): removed erroneous comments [Bug
	756744]

2003-06-17  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclCmdMZ.c:
	* tests/regexp.test: fixing of bugs related to regexp and regsub
	matching of empty strings. Addition of a number of new tests.

2003-06-10  Miguel Sofer <msofer@users.sf.net>

	* generic/tclBasic.c:
	* generic/tclExecute.c: let TclEvalObjvInternal call TclInterpReady
	instead of relying on its callers to do so; fix for the part of [Bug
	495830] that is new in 8.4.
	* tests/interp.test: Added tests 18.9 (knownbug) and 18.10

2003-06-09  Don Porter  <dgp@users.sourceforge.net>

	* tests/string.test (string-4.15): Added test for [string first] bug
	reported in Tcl 8.3, where test for all-single-byte-encoded strings
	was not reliable.

2003-06-04  Joe Mistachkin  <joe@mistachkin.com>

	* tools/man2help.tcl: Added duplicate help section checking and
	* tools/index.tcl:    corrected a comment typo for the getTopics proc
	in index.tcl. [Bug 748700]

2003-05-23  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclObj.c (tclCmdNameType):  Converted internal rep
	management of the cmdName Tcl_ObjType the opposite way, to always use
	the twoPtrValue instead of always using the otherValuePtr. Previous
	fix on 2003-05-12 broke several extensions that wanted to poke around
	with the twoPtrValue.ptr2 value of a cmdName Tcl_Obj, like TclBlend
	and e4graph. [Bug 726018] Thanks to George Petasis for the bug report
	and Jacob Levy for testing assistance.

2003-05-22  Daniel Steffen  <das@users.sourceforge.net>

	*** 8.4.3 TAGGED FOR RELEASE ***

	* macosx/tclMacOSXBundle.c: fixed a problem that caused only the first
	call to Tcl_MacOSXOpenVersionedBundleResources() for a given bundle
	identifier to succeed. This caused the tcl runtime library not to be
	found in all interps created after the inital one.

2003-05-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* changes: updated for 8.4.3

	* unix/Makefile.in: do not run autoconf during 'make dist' as the
	configure is now a CVS-maintained file and should be up-to-date.

2003-05-19  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Tcl.pbproj/project.pbxproj: changed tclConfig.sh location in
	versioned framework subdirectories to be identical to location in
	framework toplevel; fixed stub library symbolic links to be Tcl
	version specific.

2003-05-16  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Tcl.pbproj/project.pbxproj: updated copyright year.

2003-05-15  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tclWinFile.c (TclpMatchInDirectory): revert glob code to r1.44
	as 2003-04-14 optimizations broke Windows98 glob'ing.

	* README:	    bumped version to 8.4.3
	* generic/tcl.h:
	* macosx/Tcl.pbproj/project.pbxproj:
	* tools/tcl.wse.in:
	* unix/configure:
	* unix/configure.in:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure:
	* win/configure.in:

	* doc/socket.n: nroff font handling correction.

	* library/encoding/gb2312-raw.enc (new): This is the original
	gb2312.enc renamed to allow for it to still be used. This is needed by
	Tk (unix) because X fonts with gb2312* charsets really do want the
	original gb2312 encoding. [Bug 557030]

2003-05-14  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tclCmdAH.c (Tcl_FormatObjCmd): Values which can't be
	anything but wide shouldn't be demoted to long. [consequence of HEAD
	fixes for Bug 699060]

2003-05-14  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/encoding/gb2312.enc: copy euc-cn.enc over original
	gb2312.enc. gb2312.enc appeared to not work as expected, and most uses
	of gb2312 really mean euc-cn (which may be the cause of the problem).
	[Bug 557030]

	* generic/tclEnv.c (TclUnsetEnv): Another putenv() copy behavior
	problem repaired when compiling on windows and using microsoft's
	runtime. [Bug 736421] (gravereaux)

2003-05-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIOUtil.c: add decl for FsThrExitProc to suppress warnings

2003-05-13  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tclEvent.c (Tcl_Finalize): Removed unused variable to reduce
	compiler warnings. [Bug 664745]

2003-05-13  Joe Mistachkin  <joe@mistachkin.com>

	* generic/tcl.decls:  Changed Tcl_JoinThread parameter name from "id"
	* generic/tclDecls.h: to "threadId". [Bug 732477]
	* unix/tclUnixThrd.c:
	* win/tclWinThrd.c:
	* mac/tclMacThrd.c:

2003-05-13  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tcl.decls:
	* macosx/tclMacOSXBundle.c: added extended version of the
	Tcl_MacOSXOpenBundleResources() API taking an extra version number
	argument: Tcl_MacOSXOpenVersionedBundleResources(). This is needed to
	be able to access bundle resources in versioned frameworks such as Tcl
	and Tk, otherwise if multiple versions were installed, only the latest
	version's resources could be accessed. [Bug 736774]

	* unix/tclUnixInit.c (Tcl_MacOSXGetLibraryPath): use new versioned
	bundle resource API to get tcl runtime library for TCL_VERSION.
	[Bug 736774]

	* generic/tclPlatDecls.h:
	* generic/tclStubInit.c: regen.

	* unix/tclUnixPort.h: worked around the issue of realpath() not being
	thread-safe on Mac OS X by defining NO_REALPATH for threaded builds on
	Mac OS X. [Bug 711232]

2003-05-12  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclInterp.c: (AliasObjCmd):	Added refCounting of the words
	* tests/interp.test (interp-33.1):	of the target of an interp
	alias during its execution. Also added test. [Bug 730244].

	* generic/tclBasic.c (TclInvokeObjectCommand):	objv[argc] is no
	longer set to NULL (Tcl_CreateObjCommand docs already say that it
	should not be accessed).

	* generic/tclObj.c (tclCmdNameType):  Corrected variable use of the
	otherValuePtr or the twoPtrValue.ptr1 fields to store a
	(ResolvedCmdName *) as the internal rep. [Bug 726018].

	* doc/Eval.3:  Corrected prototype for Tcl_GlobalEvalObj [Bug 727622].

2003-05-12  Miguel Sofer <msofer@users.sf.net>

	* generic/tclVar.c (TclObjLookupVar): [Bug 735335] temporary fix,
	disabling usage of tclNsVarNameType.
	* tests/var.test (var-15.1): test for [Bug 735335]

2003-05-10  Zoran Vasiljevic <zoran@archiware.com>

	* unix/tclUnixThrd.c: corrected [Bug 723502]

2003-05-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIOUtil.c: ensure cd is thread-safe.
	[Bug 710642] (vasiljevic)

	* win/tclWinSerial.c (SerialCloseProc): correct mem leak on closing a
	Windows serial port [Bug 718002] (schroedter)

	* generic/tclCmdMZ.c (Tcl_StringObjCmd): prevent string repeat crash
	when overflow sizes were given (throws error). [Bug 714106]

2003-05-09  Joe Mistachkin <joe@mistachkin.com>

	* generic/tclThreadAlloc.c (TclFreeAllocCache): Fixed memory leak
	caused by treating cachePtr as a TLS index [Bug 731754].

	* win/tclAppInit.c (Tcl_AppInit): Fixed memory leaks caused by not
	freeing the memory allocated by setargv and the async handler created
	by Tcl_AppInit. An exit handler has been created that takes care of
	both leaks. In addition, Tcl_AppInit now uses ckalloc instead of
	Tcl_Alloc to allow for easier leak tracking and to be more consistent
	with the rest of the Tcl core [Bugs 733156, 733221].

	* tools/encoding/txt2enc.c (main): Fixed memory leak caused by failing
	to free the memory used by the toUnicode array of strings [Bug 733221]

2003-05-05  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl: The -returnCodes option to [test]
	failed to recognize the symbolic name "ok" for return code 0.

2003-05-05  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tclBasic.c (Tcl_HideCommand): Fixed error message grammar
	and spelling.

2003-04-29  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclFileName.c: fix to bug reported privately by Jeff where,
	for example, 'glob -path {[tcl]} *' gets confused by the leading
	special character (which is escaped internally), and instead lists
	files in '/'. Bug only occurs on Windows where '\' is also a
	directory separator. (Bug has been around at least since Tcl 8.3.)
	* tests/fileName.test: added test for the above bug.

2003-04-25  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclBasic.c:  Tcl_EvalObjv() failed to honor the
	TCL_EVAL_GLOBAL flag when resolving command names. Tcl_EvalEx passed a
	string rep including leading whitespace and comments to
	TclEvalObjvInternal().

2003-04-25  Andreas Kupries  <andreask@activestate.com>

	* win/tclWinThrd.c: Applied [Patch 727271]. This patch changes the
	code to catch any errors returned by the windows functions handling
	TLS ASAP instead of waiting to get some mysterious crash later on due
	to bogus pointers. Patch provided by Joe Mistachkin.

	This is a stop-gap measure to deal with the low number of ?TLS slots
	provided by some of the variants of Windows (60-80).

2003-04-21  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl:	When the return code of a test does
	not meet expectations, report that as the reason for test failure,
	and do not attempt to check the test result for correctness. [Bug
	725253]

2003-04-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclExecute.c (ExprCallMathFunc): remove incorrect
	extraneous cast from Tcl_WideAsDouble.

2003-04-18  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/open.n:		Moved serial port options from [fconfigure]
	* doc/fconfigure.n:	to [open] as it is up to the creator of a
				channel to describe the channel's special
				config options. [Bug 679010]

2003-04-16  Don Porter  <dgp@users.sourceforge.net>

	* generic/tcl.h		Made changes so that the "wideInt" Tcl_ObjType
	* generic/tclObj.c	is defined on all platforms, even those where
	* generic/tclPort.h	TCL_WIDE_INT_IS_LONG is defined.  Also made
	the Tcl_Value struct have a wideValue field on all platforms.  This is
	a ***POTENTIAL INCOMPATIBILITY*** for TCL_WIDE_INT_IS_LONG platforms
	because that struct changes size.  This is the same TIP 72
	incompatibility that was seen on other platforms at the 8.4.0 release,
	when this change should have happened as well.	[Bug 713562]

	* generic/tclInt.h:  New internal macros TclGetWide() and
	TclGetLongFromWide() to deal with both forms of the "wideInt"
	Tcl_ObjType, so that conditional TCL_WIDE_INT_IS_LONG code
	is confined to the header file.

	* generic/tclCmdAH.c:	Replaced most coding that was conditional
	* generic/tclCmdIL.c:	on TCL_WIDE_INT_IS_LONG with code that
	* generic/tclExecute.c: works across platforms, sometimes using
	* generic/tclTest.c:	the new macros above to do it.
	* generic/tclUtil.c:
	* generic/tclVar.c:

2003-04-17  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/socket.n: Added a paragraph to remind people to specify
	their encodings when using sockets. [Bug 630621]

2003-04-16  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/CrtMathFnc.3: Functions also have to deal with wide ints,
	but this was not documented. [Bug 709720]

2003-04-15  Kevin Kenny  <kennykb@acm.org>

	* win/tclWinTime.c: Corrected use of types to make compilation
	compatible with VC++5.

2003-04-14  Kevin Kenny  <kennykb@acm.org>

	* win/tclWinFile.c: added conditionals to restore compilation on
	VC++6, which was broken by recent changes.

2003-04-14  Vince Darley  <vincentdarley@users.sourceforge.net>

	Merged various bug fixes from current cvs head:

	* tests/cmdAH.test: better fix to test suite problem if /home is a
	symlink [Bug 703264]

	* generic/tclIOUtil.c: fix bad error message with 'cd ""' [Bug 704917]
	* win/tclWinFile.c:
	* win/tclWin32Dll.c:
	* win/tclWinInt.h: allow Tcl to differentiate between reparse points
	which are symlinks and mounted volumes, and correctly handle the
	latter. This involves some elaborate code to find the actual drive
	letter (if possible) corresponding to a mounted volume. [Bug 697862]
	* tests/fileSystem.test: add constraints to stop tests running in
	ordinary tcl interpreter. [Bug 705675]
	* generic/tclIOUtil.c: Some re-arrangement of code to bring it closer
	to CVS HEAD. No functional changes.

	* tests/fCmd.test:
	* win/tclWinFile.c: added some filesystem optimisation to the
	'glob' implementation, and some new tests.

	* tests/winFile.test:
	* tests/ioUtil.test:
	* tests/unixFCmd.test: renumbered tests with duplicate numbers. [Bug
	710361]

2003-04-12  Kevin Kenny  <kennykb@acm.org>

	* tests/clock.test: Renumbered test cases to avoid duplicates [Bug
	710310].
	* tests/winTime.test:
	* win/tclWinTest.c (TestwinclockCmd, TestwinsleepCmd):
	* win/tclWinTime.c (Tcl_WinTime, UpdateTimeEachSecond,
	(ResetCounterSamples, AccumulateSample, SAMPLES, TimeInfo): Made
	substantial changes to the phase-locked loop (replaced an IIR filter
	with an FIR one) in a quest for improved loop stability (Bug not
	logged at SF, but cited in private communication from Jeff Hobbs).

2003-04-11  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCmdMZ.c (Tcl_StringObjCmd,STR_IS_INT):  Corrected
	inconsistent results of [string is integer] observed on systems
	where sizeof(long) != sizeof(int). [Bug 718878]
	* tests/string.test: Added tests for Bug 718878.
	* doc/string.n: Clarified that [string is integer] accepts
	32-bit integers.

2003-04-11  Andreas Kupries  <andreask@activestate.com>

	* generic/tclIO.c (UpdateInterest): When dropping interest in
	TCL_READABLE now dropping interest in TCL_EXCEPTION too. This fixes a
	bug where Expect detects eof on a file prematurely on Solaris 2.6 and
	higher. A much more complete explanation is in the code itself (40
	lines of comments for a one-line change :)

2003-04-10  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/binary.n: Fixed typo in [binary format w] desc. [Bug 718543]

2003-04-08  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tclCmdAH.c (Tcl_ErrorObjCmd): Strings are only empty if they
	have zero length, not if their first byte is zero, so fix test
	guarding Tcl_AddObjErrorInfo to take this into account. [Bug reported
	by Don Porter; no bug-id.]

2003-04-07  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclCompCmds.c (TclCompileIfCmd):  Corrected string limits of
	arguments interpolated in error messages. [Bug 711371]

	* generic/tclCmdMZ.c (TraceExecutionProc):  Added missing
	Tcl_DiscardResult() call to avoid memory leak.

2003-04-07  Donal K. Fellows  <zzcgudf@ernie.mvc.mcc.ac.uk>

	* generic/tclObj.c (tclWideIntType, TclInitObjSubsystem):
	(SetBooleanFromAny): Make sure that tclWideIntType is defined and
	somewhat sensible everywhere. [Bug 713562]

2003-04-02  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/configure: Regen.
	* win/configure.in: Set stub lib flag based on new LIBFLAGSUFFIX
	variable.
	* win/tcl.m4 (SC_CONFIG_CFLAGS): Set new LIBFLAGSUFFIX that works like
	LIBSUFFIX, it is used when creating library names. The previous
	implementation would generate -ltclstub85 instead of -ltclstub85s when
	configured with --disable-shared.

2003-04-01  Don Porter  <dgp@users.sourceforge.net>

	* tests/README: Direct [source] of *.test files is no longer
	recommended. The tests/*.test files should only be evaluated under the
	control of the [runAllTests] command in tests/all.tcl.

2003-03-27  Miguel Sofer <msofer@users.sf.net>

	* tests/encoding.test:
	* tests/proc-old.test:
	* tests/set-old.test: Altered test numers to eliminate duplicates,
	[Bugs 710313, 710320, 710352]

2003-03-27  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/parseOld.test:	Altered test numers to eliminate duplicates.
	* tests/parse.test:	[Bugs 710365, 710369]
	* tests/expr-old.test:
	* tests/expr.test:

	* tests/utf.test:	Altered test numers to eliminate duplicates.
	* tests/trace.test:	[Bugs 710322, 710327, 710349, 710363]
	* tests/lsearch.test:
	* tests/list.test:
	* tests/info.test:
	* tests/incr-old.test:
	* tests/if-old.test:
	* tests/format.test:
	* tests/foreach.test:

2003-03-26  Don Porter  <dgp@users.sourceforge.net>

	* doc/tcltest.n:
	* library/tcltest/tcltest.tcl:	Added reporting during [configure
	-debug 1] operations to warn about multiple uses of the same test
	name. [FR 576693]  Replaced [regexp] and [regsub] with [string map]
	where possible. Thanks to David Welton. [Bugs 667456,667558]
	* library/tcltest/pkgIndex.tcl: Bumped to tcltest 2.2.3

	* tests/msgcat.test (msgcat-2.2.1): changed test name to avoid
	duplication. [Bug 710356]

	* unix/dltest/pkg?.c: Changed all Tcl_InitStubs calls to pass argument
	exact = 0, so that rebuilds are not required when Tcl bumps to a new
	version. [Bug 701926]

2003-03-24  Miguel Sofer <msofer@users.sf.net>

	* generic/tclVar.c:
	* tests/var.test: fixing ObjMakeUpvar's lookup algorithm for the
	created local variable, [Bugs 631741] (Chris Darroch) and [696893]
	(David Hilker).

2003-03-22  Kevin Kenny  <kennykb@acm.org>

	* library/dde/pkgIndex.tcl:
	* library/reg/pkgIndex.tcl: Fixed a bug where [package require dde] or
	[package require registry] attempted to load the release version of
	the DLL into a debug build. [Bug 708218] Thanks to Joe Mistachkin for
	the patch.
	* win/makefile.vc: Added quoting around the script name in the 'test'
	target; Joe Mistachkin insists that he has a configuration that fails
	to launch tcltest without it, and it appears harmless otherwise.

2003-03-20  Don Porter  <dgp@users.sourceforge.net>

	* generic/tclInt.h (tclOriginalNotifier):
	* generic/tclStubInit.c (tclOriginalNotifier):
	* mac/tclMacNotify.c (Tcl_SetTimer,Tcl_WaitForEvent):
	* unix/tclUnixNotfy.c (Tcl_SetTimer,Tcl_WaitForEvent,
	(Tcl_CreateFileHandler,Tcl_DeleteFileHandler):
	* win/tclWinNotify.c (Tcl_SetTimer,Tcl_WaitForEvent): Some linkers
	apparently use a different representation for a pointer to a function
	within the same compilation unit and a pointer to a function in a
	different compilation unit. This causes checks like those in the
	original notifier procedures to fall into infinite loops. The fix is
	to store pointers to the original notifier procedures in a struct
	defined in the same compilation unit as the stubs tables, and compare
	against those values. [Bug 707174]

	* generic/tclInt.h: Removed definition of ParseValue struct that is no
	longer used.

2003-03-19  Miguel Sofer <msofer@users.sf.net>

	* generic/tclCompile.c:
	* tests/compile.test: bad command count on TCL_OUT_LINE_COMPILE
	[Bug 705406] (Don Porter).

2003-03-19  Don Porter  <dgp@users.sourceforge.net>

	* doc/Eval.3 (Tcl_EvalObjEx):			Corrected CONST and
	* doc/ParseCmd.3 (Tcl_EvalTokensStandard):	return type errors in
	documentation. [Bug 683994]

2003-03-18  Kevin Kenny  <kennykb@users.sourceforge.net>

	* tests/registry.test: Changed the conditionals to avoid an abort if
	[testlocale] is missing, as when running the test in tclsh rather than
	tcltest. [Bug 705677]

2003-03-18  Daniel Steffen  <das@users.sourceforge.net>

	* tools/tcltk-man2html.tcl: added support for building 'make html'
	from inside distribution directories named with 8.x.x version numbers.
	tcltk-man2html now uses the latest tcl8.x.x resp. tk8.x.x directories
	found inside its --srcdir argument.

2003-03-18  Vince Darley  <vincentdarley@users.sourceforge.net>

	* tests/cmdAH.test: fix test suite problem if /home is a symlink
	* generic/tclIOUtil.c: fix bad error message with 'cd ""'
	* win/tclWinFile.c: allow Tcl to differentiate between reparse points
	which are symlinks and mounted drives.

	These changes fix [Bugs 703264, 704917, 697862] respectively.

2003-03-17  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/lsearch.n:	Altered documentation of -ascii options so
	* doc/lsort.n:		they don't specify that they operate on
				ASCII strings, which they never did
				anyway. [Bug 703807]

2003-03-14  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* generic/tclCmdAH.c (Tcl_FileObjCmd): Remove assumption that file
	times and longs are the same size. [Bug 698146]
	(Tcl_FormatObjCmd): Stop surprising type conversions from
	happening when working with integer and wide values. [Bug 699060]

	* generic/tclCmdAH.c (Tcl_FormatObjCmd): Only add the modifier that
	indicates we've got a wide int when we're formatting in an integer
	style. Stops some libc's from going mad. [Bug 702622]
	Also tidied whitespace.

2003-03-13  Kevin Kenny  <kennykb@users.sourceforge.net>

	* win/makefile.vc: Backed the version to 8.4 on the 8.4 branch. (I
	just loathe sticky tags).

2003-03-12  Don Porter  <dgp@users.sourceforge.net>

	* generic/tcl.h:	Removed TCL_PREFIX_IDENT and TCL_DEBUG_IDENT
	* win/tclWinPipe.c:	from tcl.h -- they are not part of Tcl's
	public interface.  Put them in win/tclWinPipe.c where they are used.

	* generic/tclCmdMZ.c (Tcl_SubstObj):	Corrected and added test for
	* tests/subst.test (subst-2.4):		Tcl_SubstObj's incorrect
	halting of substitution at the first \x00 byte. [Bug 685106]

	* generic/tclInterp.c (Tcl_InterpObjCmd):	Corrected and added
	* tests/interp.test (interp-2.13):		test for option
	parsing beyond objc for [interp create --].  Thanks to Marco Maggi.
	[Bug 702383]

2003-03-11  Kevin Kenny  <kennykb@users.sourceforge.net>

	* win/makefile.vc: Added two missing uses of $(DBGX) so that
	tclpip8x.dll loads without panicking on Win9x.

2003-03-08  Don Porter  <dgp@users.sourceforge.net>

	* doc/tcltest.n:  Added missing "-body" to example.  Thanks to
	Helmut Giese. [Bug 700011]

2003-03-06  Don Porter  <dgp@users.sourceforge.net>

	* generic/TclUtf.c (Tcl_UniCharNcasecmp):	Corrected failure to
	* tests/utf.test (utf-25.*):	properly compare Unicode strings of
	different case in a case insensitive manner. [Bug 699042]

2003-03-03  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.4.2 TAGGED FOR RELEASE ***

2003-03-03  Daniel Steffen  <das@users.sourceforge.net>

	Mac OS Classic specific fixes:
	* generic/tclIOUtil.c (TclNewFSPathObj): on TCL_PLATFORM_MAC,
	skip potential directory separator at the beginning of addStrRep.
	* mac/tclMacChan.c (OpenFileChannel, CommonWatch): followup
	fixes to cut and splice implementation for file channels.
	* mac/tclMacFile.c (TclpUtime): pass native path to utime().
	* mac/tclMacFile.c (TclpObjLink): correctly implemented creation
	of alias files via new static proc CreateAliasFile().
	* mac/tclMacPort.h: define S_ISLNK macro to fix stat'ing of links.
	* mac/tclMacUtil.c (FSpLocationFromPathAlias): fix to enable
	stat'ing of broken links.

2003-03-03  Kevin Kenny  <kennykb@users.sourceforge.net>

	* win/Makefile.vc: corrected bug introduced by 'g' for debug builds.

2003-03-03  Don Porter  <dgp@users.sourceforge.net>

	* library/dde/pkgIndex.tcl:	dde bumped to version 1.2.1 for
	* win/tclWinDde.c:		bundled release with Tcl 8.4.2

	* library/reg/pkgIndex.tcl:	registry bumped to version 1.1.1 for
	* win/tclWinReg.c:		bundled release with Tcl 8.4.2

	* library/opt/pkgIndex.tcl:	updated package index to version 0.4.4

2003-02-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/configure:
	* win/configure.in: check for 'g' for debug build type, not 'd'.
	* win/rules.vc (DBGX): correct to use 'g' for nmake win makefile
	to match the cygwin makefile for debug builds. [Bug 635107]

2003-02-28  Vince Darley  <vincentdarley@users.sourceforge.net>

	* doc/file.n: subcommand is 'file volumes' not 'file volume'

2003-02-27  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIOUtil.c (MakeFsPathFromRelative): removed dead code
	check of typePtr (darley).

	* tests/winTime.test: added note about PCI hardware dependency
	issues with high performance clock.

2003-02-27  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/lsearch.test (lsearch-10.7):
	* generic/tclCmdIL.c (Tcl_LsearchObjCmd): Stopped -start option from
	causing an option when used with an empty list. [Bug 694232]

2003-02-26  Chengye Mao <chengye.geo@yahoo.com>

	* win/tclWinInit.c: fixed a bug in TclpSetVariables by initializing
	dwUserNameLen with the sizeof(szUserName) before calling GetUserName.
	Don't know if this bug has been recorded: it caused crash in starting
	Tcl or wish in Windows.

2003-02-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclCmdMZ.c (TraceCommandProc): Fix mem leak when
	deleting a command that had trace on it. [Bug 693564] (sofer)

2003-02-25  Don Porter  <dgp@users.sourceforge.net>

	* doc/pkgMkIndex.n:	Modified [pkg_mkIndex] to use -nocase matching
	* library/package.tcl:	of -load patterns, to better accomodate
	common user errors due to confusion between [package names] names
	and [info loaded] names.

2003-02-25  Andreas Kupries  <andreask@activestate.com>

	* tests/pid.test: See below [Bug 678412].
	* tests/io.test: Made more robust against spaces in paths [Bug 678400]

2003-02-25  Miguel Sofer <msofer@users.sf.net>

	* tests/execute.test: cleaning up testobj's at the end, to avoid leak
	warning by valgrind.

2003-02-22  Zoran Vasiljevic  <zoran@archiwrae.com>

	* generic/tclEvent.c (Tcl_FinalizeThread): Fix [Bug 571002]

2003-02-21  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* tests/binary.test (binary-44.[34]):
	* generic/tclBinary.c (ScanNumber): Fixed problem with unwanted
	sign-bit propagation when scanning wide ints. [Bug 690774]

2003-02-21  Daniel Steffen  <das@users.sourceforge.net>

	* mac/tclMacChan.c (TclpCutFileChannel, TclpSpliceFileChannel):
	Implemented missing cut and splice procs for file channels.

2003-02-21  Don Porter  <dgp@users.sourceforge.net>

	* library/package.tcl (tclPkgUnknown):	Minor performance tweaks to
	reduce the number of [file] invocations. Meant to improve startup
	times, at least a little bit. [Patch 687906]

2003-02-20  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4:
	* unix/tclUnixPipe.c: (macosx) use vfork() instead of fork() to create
	new processes, as recommended by Apple (vfork can be up to 100 times
	faster thank fork on macosx).
	* unix/configure: regen.

2003-02-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclEncoding.c (LoadTableEncoding):
	* library/encoding/cp932.enc:	   Correct jis round-trip encoding
	* library/encoding/euc-jp.enc:	   by adding 'R' type to .enc files.
	* library/encoding/iso2022-jp.enc: [Patch 689341] (koboyasi, taguchi)
	* library/encoding/jis0208.enc:
	* library/encoding/shiftjis.enc:
	* tests/encoding.test:

	* unix/tclUnixChan.c (Tcl_MakeTcpClientChannel): add
	MakeTcpClientChannelMode that takes actual mode flags to avoid
	hang on OS X (may be OS X bug, but patch works x-plat).
	[Bug 689835] (steffen)

2003-02-20  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/regsub.n: Typo fix [Bug 688943]

2003-02-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tclUnixThrd.c (TclpReaddir):
	* unix/tclUnixPort.h: update to Bug 689100 patch to ensure that
	there is a defined value of MAXNAMLEN (aka NAME_MAX in POSIX) and
	that we have some buffer allocated.

2003-02-19  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tclStringObj.c: restored Tcl_SetObjLength() side-effect of
	always invalidating unicode rep (if the obj has a string rep). Added
	hasUnicode flag to String struct, allows decoupling of validity of
	unicode rep from buffer size allocated to it (improves memory
	allocation efficiency). [Bugs 686782, 671138, 635200]

	* macosx/Tcl.pbproj/project.pbxproj:
	* macosx/Makefile: reworked embedded build to no longer require
	relinking but to use install_name_tool instead to change the
	install_names for embedded frameworks. [Bug 644510]

	* macosx/Tcl.pbproj/project.pbxproj: preserve mod dates when running
	'make install' to build framework (avoids bogus rebuilds of dependent
	frameworks because tcl headers appear changed).

	* tests/ioCmd.test (iocmd-1.8): fix failure when system encoding is
	utf-8: use iso8859-1 encoding explicitly.

2003-02-18  Miguel Sofer <msofer@users.sf.net>

	* generic/tclCompile.c (TclCompileExprWords): remove unused variable
	"range" [Bug 664743]
	* generic/tclExecute.c (ExprSrandFunc): remove unused variable
	"result" [Bug 664743]
	* generic/tclStringObj.c (UpdateStringOfString): remove unused
	variable "length" [Bug 664751]
	* tests/execute.test (execute-7.30): fix for [Bug 664775]

2003-02-18  Andreas Kupries  <andreask@activestate.com>

	* unix/tcl.m4: [Bug 651811] Added definition of _XOPEN_SOURCE and
	linkage of 'xnet' library to HP 11 branch. This kills a lot of
	socket-related failures in the testsuite when Tcl was compiled in 64
	bit mode (both PA-RISC 2.0W, and IA 64).

	* unix/configure: Regenerated.

2003-02-18  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIO.c (HaveVersion): correctly decl static

	* unix/tclUnixThrd.c (TclpReaddir): reduce size of name string in
	tsd to NAME_MAX instead of PATH_MAX. [Bug 689100] (waters)

2003-02-18  Mo DeJong  <mdejong@users.sourceforge.net>

	* unix/configure: Regen.
	* unix/tcl.m4 (SC_ENABLE_THREADS): Make sure -lpthread gets passed on
	the link line when checking for the pthread_attr_setstacksize symbol.

2003-02-18  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclTest.c: cleanup of new 'simplefs' test code, and better
	documentation.

2003-02-17  Miguel Sofer <msofer@users.sf.net>

	* generic/tclBasic.c (TclRenameCommand): fixing error in previous
	commit.

2003-02-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclExecute.c (TclExecuteByteCode INST_STR_MATCH):
	* generic/tclCmdMZ.c (Tcl_StringObjCmd STR_MATCH):
	* generic/tclUtf.c (TclUniCharMatch):
	* generic/tclInt.decls:	 add private TclUniCharMatch function that
	* generic/tclIntDecls.h: does string match on counted unicode
	* generic/tclStubInit.c: strings.  Tcl_UniCharCaseMatch has the
	* tests/string.test:	 failing that it can't handle strings or
	* tests/stringComp.test: patterns with embedded NULLs.	Added
	tests that actually try strings/pats with NULLs.  TclUniCharMatch
	should be TIPed and made public in the next minor version rev.

2003-02-17  Miguel Sofer <msofer@users.sf.net>

	* generic/tclBasic.c (TclRenameCommand): 'oldFullName' object was not
	being freed on all function exits, causing a memory leak. [Bug 684756]

2003-02-17  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tclIO.c (Tcl_GetsObj): Minor change so that eol is only
	assigned at the top of the TCL_TRANSLATE_AUTO case block. The other
	cases assign eol so this does not change any functionality.

2003-02-17  Kevin Kenny  <kennykb@users.sourceforge.net>

	* tests/notify.test: Removed Windows line terminators. [Bug 687913].

2003-02-15  Miguel Sofer <msofer@users.sf.net>

	* generic/tclBasic.c (Tcl_EvalEx):
	* generic/tclCompExpr.c (CompileSubExpr):
	* generic/tclCompile.c (TclCompileScript):
	* generic/tclParse.c (Tcl_ParseCommand, ParseTokens):
	* generic/tclParseExpr.c (ParsePrimaryExpr):
	* tests/basic.test (47.1):
	* tests/main.test (3.4):
	* tests/misc.test (1.2):
	* tests/parse.test (6.18):
	* tests/parseExpr.test (15.35):
	* tests/subst.test (8.6): Don Porter's fix for bad parsing of
	nested scripts [Bug 681841].

2003-02-15  Kevin Kenny  <kennykb@users.sourceforge.net>

	* tests/notify.test (new-file):
	* generic/tclTest.c (TclTest_Init, EventtestObjCmd, EventtestProc,
	(EventTestDeleteProc):
	* generic/tclNotify.c (Tcl_DeleteEvents): Fixed Tcl_DeleteEvents
	not to get a pointer smash when deleting the last event in the
	queue. Added test code in 'tcltest' and a new file of test cases
	'notify.test' to exercise this functionality; several of the new
	test cases fail for the original code and pass for the corrected
	code. [Bug 673714]

	* unix/tclUnixTest.c (TestfilehandlerCmd): Corrected a couple
	of typos in error messages. [Bug 596027]

2003-02-14  Jeff Hobbs  <jeffh@ActiveState.com>

	* README:		Bumped to version 8.4.2.
	* generic/tcl.h:
	* tools/tcl.wse.in:
	* unix/configure:
	* unix/configure.in:
	* unix/tcl.m4:
	* unix/tcl.spec:
	* win/README.binary:
	* win/configure:
	* win/configure.in:
	* macosx/Tcl.pbproj/project.pbxproj:

	* generic/tclStringObj.c (Tcl_GetCharLength): perf tweak

	* unix/tcl.m4: correct HP-UX ia64 --enable-64bit build flags

2003-02-14  Kevin Kenny  <kennykb@users.sourceforge.net>

	* win/tclWinTime.c: Added code to test and compensate for forward
	leaps of the performance counter. See the MSDN Knowledge Base article
	Q274323 for the hardware problem that makes this necessary on certain
	machines.
	* tests/winTime.test: Revised winTime-2.1 - it had a tolerance of
	thousands of seconds, rather than milliseconds. (What's six orders of
	magnitude among friends?

	Both the above changes are triggered by a problem reported at
	http://aspn.activestate.com/ASPN/Mail/Message/ActiveTcl/1536811
	although the developers find it difficult to believe that it accounts
	for the observed behavior and suspect a fault in the RTC chip.

2003-02-13  Kevin Kenny  <kennykb@users.sourceforge.net>

	* win/tclWinInit.c: Added conversion from the system encoding to
	tcl_platform(user), so that it works with non-ASCII7 user names. [Bug
	685926]

	* doc/tclsh.1: Added language to describe the handling of the
	end-of-file character \u001a embedded in a script file. [Bug 685485]

2003-02-11  Vince Darley  <vincentdarley@users.sourceforge.net>

	* tests/fileName.test:
	* unix/tclUnixFile.c: fix for [Bug 685445] when using 'glob -l' on
	broken symbolic links. Added two new tests for this bug.

2003-02-11  Kevin Kenny  <kennykb@users.sourceforge.net>

	* tests/http.test: Corrected a problem where http-4.14 would fail when
	run in an environment with a proxy server. Replaced references to
	scriptics.com by tcl.tk.

2003-02-11  Jeff Hobbs  <jeffh@ActiveState.com>

	* tests/lsearch.test:
	* generic/tclCmdIL.c (Tcl_LsearchObjCmd): protect against the case
	that lsearch -regepx list and pattern objects are equal.

	* tests/stringObj.test:
	* generic/tclStringObj.c (Tcl_GetCharLength): correct ascii char
	opt of 2002-11-11 to not stop early on \x00. [Bug 684699]

	* tests.parse.test: remove excess EOF whitespace

	* generic/tclParse.c (CommandComplete): more paranoid check to
	break on (p >= end) instead of just (p == end).

2003-02-11  Miguel Sofer <msofer@users.sf.net>

	* generic/tclParse.c (CommandComplete):
	* tests/parse.test: fix for [Bug 684744], by Don Porter.

2003-02-11  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tclIOUtil.c (Tcl_FSJoinPath, Tcl_FSGetNormalizedPath):
	(UpdateStringOfFsPath): revert the cwdLen == 0 check and instead
	follow a different code path in Tcl_FSJoinPath.
	(Tcl_FSConvertToPathType, Tcl_FSGetNormalizedPath):
	(Tcl_FSGetFileSystemForPath): Update string rep of path objects
	before freeing the internal object. (darley)

	* tests/fileSystem.test: added test 8.3
	* generic/tclIOUtil.c (Tcl_FSGetNormalizedPath):
	(UpdateStringOfFsPath): handle the cwdLen == 0 case

	* unix/tclUnixFile.c (TclpMatchInDirectory): simplify the hidden
	file match check.

2003-02-10  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/configure:
	* win/configure.in: Generate error when attempting to build under
	Cygwin. The Cygwin port of Tcl/Tk does not build and people are filing
	bug reports under the mistaken impression that someone is actually
	maintaining the Cygwin port. A post to comp.lang.tcl asking someone to
	volunteer as an area maintainer has generated no results. Closing
	[Bugs 680840, 630199, 634772] and marking as "Won't fix".

2003-02-10  Donal K. Fellows  <fellowsd@cs.man.ac.uk>

	* doc/append.n: Return value was not documented. [Bug 683188]

2003-02-10  Vince Darley  <vincentdarley@users.sourceforge.net>

	* doc/FileSystem.3:
	* generic/tclIOUtil.c:
	* generic/tclInt.h:
	* tests/fileSystem.test:
	* unix/tclUnixFCmd.c:
	* unix/tclUnixFile.c:
	* win/tclWinFile.c: further filesystem optimization, applying
	[Patch 682500]. In particular, these code examples are faster now:
	    foreach f $flist { if {[file exists $f]} {file stat $f arr;...}}
	    foreach f [glob -dir $dir *] { # action and/or recursion on $f }
	    cd $dir
	    foreach f [glob *] { # action and/or recursion on $f }
	    cd ..

	* generic/tclTest.c: Fix for [Bug 683181] where test suite left files
	in 'tmp'.

2003-02-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/safe.tcl: code cleanup of eval and string comp use.

2003-02-07  Vince Darley  <vincentdarley@users.sourceforge.net>

	* win/tclWinFCmd.c: cleanup long lines
	* win/tclWinFile.c: sped up pure 'glob' by a factor of 2.5 ('foreach f
	[glob *] { file exists $f }' is still slow)
	* tests/fileSystem.text:
	* tests/fileName.test: added new tests to ensure correct behaviour in
	optimized filesystem code.

2003-02-07  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclTest.c:
	* tests/fileSystem.text: fixed test 7.2 to avoid a possible crash, and
	not change the pwd.

	* tests/http.text: added comment to test 4.15, that it may fail if you
	use a proxy server.

2003-02-06  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tclCompCmds.c (TclCompileIncrCmd):
	* tests/incr.test: Don't include the text "(increment expression)" in
	the errorInfo generated by the compiled version of the incr command
	since it does not match the message generated by the non-compiled
	version of incr. It is also not possible to match this error output
	under Jacl, which does not support a compiler.

2003-02-06  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tclExecute.c (TclExecuteByteCode): When an error is
	encountered reading the increment value during a compiled call to
	incr, add a "(reading increment)" error string to the errorInfo
	variable. This makes the errorInfo variable set by the compiled incr
	command match the value set by the non-compiled version.
	* tests/incr-old.test: Change errorInfo result for the compiled incr
	command case to match the modified implementation.
	* tests/incr.test: Add tests to make sure the compiled and
	non-compiled errorInfo messages are the same.

2003-02-06  Don Porter  <dgp@users.sourceforge.net>

	* library/tcltest/tcltest.tcl:	Filename arguments to [outputChannel]
	and [errorChannel] (also -outfile and -errfile) were [open]ed but
	never [closed]. Also, [cleanupTests] could remove output or error
	files. [Bug 676978].
	* library/tcltest/pkgIndex.tcl: Bumped to version 2.2.2.

2003-02-05  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/interp.test:
	* tests/set-old.test: Run test cases that depend on hash order through
	lsort so that the tests also pass under Jacl. Does not change test
	results under Tcl.

2003-02-04  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclIOUtil.c:
	* generic/tclEvent.c:
	* generic/tclInt.h:
	* mac/tclMacFCmd.c:
	* unix/tclUnixFCmd.c:
	* win/tclWin32Dll.c:
	* win/tclWinFCmd.c:
	* win/tclWinInit.c:
	* win/tclWinInt.h:
	* tests/fileSystem.test: fix to finalization/unloading/encoding issues
	to make filesystem much less dependent on encodings for its cleanup,
	and therefore allow it to be finalized later in the exit process. This
	fixes fileSystem.test-7.1. Also fixed one more bug in setting of
	modification dates of files which have undergone cross-platform
	copies. [Patch 676271]

	* tests/basic.test:
	* tests/exec.test:
	* tests/fileName.test:
	* tests/io.test: fixed some test failures when tests are run from a
	directory containing spaces.

	* tests/fileSystem.test:
	* generic/tclTest.c: added regression test for the modification
	date setting of cross-platform file copies.

2003-02-03  Kevin Kenny  <kennykb@users.sourceforge.net>

	* generic/tclBasic.c: Changed [trace add command] so that 'rename'
	callbacks get fully qualified names of the command. [Bug 651271].
	***POTENTIAL INCOMPATIBILITY***
	* tests/trace.test: Modified the test cases for [trace add command] to
	expect fully qualified names on the 'rename' callbacks. Added a case
	for renaming a proc within a namespace.
	* doc/trace.n: Added language about use of fully qualified names in
	trace callbacks.

2003-02-01  Kevin Kenny  <kennykb@users.sourceforge.net>

	* generic/tclCompCmds.c: Removed an unused variable that caused
	compiler warnings on SGI. [Bug 664379]

	* generic/tclLoad.c: Changed the code so that if Tcl_StaticPackage is
	called to report the same package as being loaded in two interps, it
	shows up in [info loaded {}] in both of them (previously, it didn't
	appear in the static package list in the second.

	* tests/load.test Added regression test for the above bug. [Bug
	670042]

	* generic/tclClock.c: Fixed a bug that incorrectly allowed [clock
	clicks {}] and [clock clicks -] to be accepted as if they were [clock
	clicks -milliseconds].

	* tests/clock.test: Added regression tests for the above bug. [Bug
	675356]

	* tests/unixNotfy.test: Added cleanup of working files [Bug 675609]

	* doc/Tcl.n: Added headings to the eleven paragraphs, to improve
	formatting in the tools that attempt to extract tables of contents
	from the manual pages. [Bug 627455]

	* generic/tclClock.c: Expanded mutex protection around the setting of
	env(TZ) and the thread-unsafe call to tzset(). [Bug 656660]

2003-01-31  Don Porter  <dgp@users.sourceforge.net>

	* tests/tcltest.test: Cleaned up management of file/directory
	creation/deletion to improve "-debug 1" output. [Bug 675614] The
	utility [slave] command failed to properly [list]-quote a constructed
	[open] command, causing failure when the pathname contained
	whitespace. [Bug 678415]

	* tests/main.test: Stopped main.test from deleting existing file.
	Test suite should not delete files that already exist. [Bug 675660]

2003-01-28  Don Porter  <dgp@users.sourceforge.net>

	* tests/main.test: Constrain tests that do not work on Windows. [Bug
	674387]

2003-01-28  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tclIOUtil.c: fix to setting modification date in
	TclCrossFilesystemCopy. Also added 'panic' in
	Tcl_FSGetFileSystemForPath under illegal calling circumstances which
	lead to hard-to-track-down bugs.

	* generic/tclTest.c: added test suite code to allow exercising a
	vfs-crash-on-exit bug in Tcl's finalization caused by the encodings
	being cleaned up before unloading occurs.
	* tests/fileSystem.test: added new 'knownBug' test 7.1 to demonstrate
	the crash on exit.

2003-01-28  Mo DeJong  <mdejong@users.sourceforge.net>

	* generic/tcl.h: Add TCL_PREFIX_IDENT and TCL_DEBUG_IDENT, used only
	by TclpCreateProcess.
	* unix/Makefile.in: Define TCL_DBGX.
	* win/Makefile.in: Define TCL_DBGX.
	* win/tclWinPipe.c (TclpCreateProcess): Check that the Tcl pipe dll
	actually exists in the Tcl bin directory and panic if it is not
	found. Incorporate TCL_DBGX into the Tcl pipe dll name. This fixes a
	really mysterious error that would show up when exec'ing a 16 bit
	application under Win95 or Win98 when Tcl was compiled with symbols.
	The error seemed to indicate that the executable could not be found,
	but it was actually the Tcl pipe dll that could not be found.
